#include "interface.h"
#include <windows.h>
#include <stdio.h>

LRESULT CALLBACK __WndProc(HWND,UINT,WPARAM,LPARAM);

LPCSTR	WClassName = "RbPSeClass";
LPCSTR	WTitle = "RbPSe Emulator Window";
int     return_value = INTERFACE_MESSAGE_EXIT;
message_function	key_handlers[16];
long	key_handlers_count;
long	__flag__ = 0;

int		InterfaceInit(long *data){
	WNDCLASS wc;
	wc.style = CS_HREDRAW|CS_VREDRAW;
	wc.lpfnWndProc = __WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = 0;
	wc.hIcon = 0;
	wc.hCursor = 0;
	wc.hbrBackground = 0;
	wc.lpszMenuName = 0;
	wc.lpszClassName = WClassName;
	RegisterClass(&wc);
	*data = (long)CreateWindow(WClassName,WTitle,WS_OVERLAPPEDWINDOW,
    				200,160,400,280,0,0,0,0);
	ShowWindow((HWND)(*data),SW_SHOW);
	return 0;
}

int		InterfaceMessage(message_function keys[],long func_count,long core_pos){
	MSG msg;
    int i;
    for(i=0;i<func_count;i++) key_handlers[i] = keys[i];
    key_handlers_count = func_count;
    __flag__ = 0;
	while(GetMessage(&msg,0,0,0)){
		DispatchMessage(&msg);
        if(__flag__) break;
	}
	return return_value;
}

int		InterfaceShutdown(int exit_code){
    return exit_code;
}

LRESULT CALLBACK __WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
	int i;
	switch(uMsg){
	case WM_DESTROY:
    	return_value = INTERFACE_MESSAGE_EXIT;
		PostQuitMessage(0);
		break;
    case WM_KEYDOWN:
    	for(i=0;i<key_handlers_count;i++) (*key_handlers[i])(0,(lParam>>16)&0x000000ff);
        if(((lParam>>16)&0x000000ff)==0x01){
        	__flag__ = 1;
            return_value = INTERFACE_MESSAGE_EXIT;
        }
    	break;
    case WM_KEYUP:
		for(i=0;i<key_handlers_count;i++) (*key_handlers[i])(1,(lParam>>16)&0x000000ff);
    	break;
	default:
		return DefWindowProc(hWnd,uMsg,wParam,lParam);
	}
	return 0;
}

