;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
CEXTERN RbPSe_LoadLibrary
CEXTERN RbPSe_ReadStrSettings
CEXTERN RbPSe_SysPrintf
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
    mov eax,[esp+4]     ;//RbPSeStartUpStrucAddr
    push dword ConfigSectionPSEmuBuffer
    push dword ConfigSectionPSEmuDefName
    push dword ConfigSectionPSEmuNames
    push dword ConfigSectionPSEmu
    push dword ConfigFileName
    push dword [eax+RbPSeStartStruc.ProfileDir]
    call RbPSe_ReadStrSettings
    add esp,0x18
        mov eax,[esp+4]     ;//RbPSeStartUpStrucAddr
		push dword cdrHandles
		push dword cdrFuncNames
        push dword ConfigSectionPSEmuBuffer
		push dword [eax+RbPSeStartStruc.PluginsDir]
		call RbPSe_LoadLibrary
		add esp,0x10
	test eax,eax
	jz .load_ok
		push dword ErrorLoadPSEmuCDRPlugin
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.load_ok:
	call [cdrHandles.cdrINIT]
    test eax,eax
    jz .init_ok
		push dword ErrorInitPSEmuCDRPlugin
        call RbPSe_SysPrintf
        add esp,0x0
	mov eax,0xffffffff
    ret
.init_ok:
;;---
	mov eax,writeCDr_0
	mov edx,readCDr_0
	mov ecx,0x00001800
	rb_call ___rb___Hook___HardWare8___
	mov eax,writeCDr_1
	mov edx,readCDr_1
	mov ecx,0x00001801
	rb_call ___rb___Hook___HardWare8___
	mov eax,writeCDr_2
	mov edx,readCDr_2
	mov ecx,0x00001802
	rb_call ___rb___Hook___HardWare8___
	mov eax,writeCDr_3
	mov edx,readCDr_3
	mov ecx,0x00001803
	rb_call ___rb___Hook___HardWare8___
	mov eax,DMAFunction
	mov ecx,0x00000003
	rb_call ___rb___Hook___dma___
	mov [DMAData],eax
;//
    call [cdrHandles.cdrOPEN]
    test eax,eax
    jz .open_ok
        push dword ErrorOpenPSEmuCDRPlugin
        call RbPSe_SysPrintf
        add esp,0x0
    mov eax,0xffffffff
    ret
.open_ok:
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
    xor eax,eax
    ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
    xor eax,eax
    ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
    xor eax,eax
    ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
DMAFunction:    ;//(eax)control
	test eax,0x00000001
	jnz .ToCDR
	jmp .FromCDR
.ToCDR:
    mov ecx,[DMAData]
	mov edx,[ecx]
	push edx
    mov ecx,[ecx+4]
    mov eax,ecx
    shr ecx,0x10
    mul cx
    shl edx,0x10
    mov dx,ax
    mov ecx,edx
    pop edx
    and edx,0x001fffff
;;--SomeThing
	ret
.FromCDR:
    mov ecx,[DMAData]
	mov edx,[ecx]
    push edx
    mov ecx,[ecx+4]
    mov eax,ecx
    shr ecx,0x10
    mul cx
    shl edx,0x10
    mov dx,ax
    mov ecx,edx
    pop edx
    and edx,0x001fffff
		push ecx
		push edx
		call CDRHookFunction
		add esp,0x08
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Write----------------------------------------------;
;------------------------------------------------------------------------------;
writeCDr_0:			;Okey!!!
;//LogBegin
;	pusha
;                mov edx,[esp+0x24]
;                sub edx,DynRegister
;                shr edx,0x02
;                and edx,0xfffffffc
;                push edx
;    	cmp al,0x00
;        jne .ncommand
;			push dword msg_cd_mode_select_command
;    		jmp .log
;.ncommand:
;		cmp al,0x01
;        jne .nresult
;        	push dword msg_cd_mode_select_result
;            jmp .log
;.nresult:
;            push dword msg_cd_mode_select_other
;.log:
;		rb_call ___rb___Log___Printf___
;		add esp,0x08
;	popa
;
;//LogEnd
	mov [CDmainControlRegister],al
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Read-----------------------------------------------;
;------------------------------------------------------------------------------;
readCDr_0:			;Okey!!!
	mov eax,0x00;0x18
	mov dl,[CDmainControlRegister]
	and dl,0x01
	or al,dl
	cmp dword [ResultReady],0x00000000
	je .nResultReady
	or eax,0x20
.nResultReady:
	cmp dword [DMAReady],0x00000000
	je .nDMAReady
	or eax,0x40
.nDMAReady:
;//	cmp dword [CommandAccepted],0x00000000
;//	je .nComAcc
;//	or eax,0x80
;//.nComAcc:
;//
;                pusha
;		mov edx,[esp+0x24]
;		sub edx,DynRegister
;		shr edx,0x02
;		and edx,0xfffffffc
;                    push eax
;        push edx
;                    push dword ReadCD0
;                    rb_call ___rb___Log___Printf___
;                    add esp,0x0c
;                popa
;//
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Write----------------------------------------------;
;------------------------------------------------------------------------------;
writeCDr_1:						;Ok?
;//
;                pusha
;        mov edx,[esp+0x24]
;        sub edx,DynRegister
;        shr edx,0x02
;        and edx,0xfffffffc
;                    push eax
;        push edx
;                    push dword WriteCD1
;                    rb_call ___rb___Log___Printf___
;                    add esp,0x0c
;                popa
;//
	cmp byte [CDmainControlRegister],byte 0x00
	jne .nCommandMode
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Command Mode	;WriteCommand
	mov byte [ResultReady],byte 0x00
	mov byte [InterruptStatus],0x00
	and eax,0x000000ff
	jmp [CDCommandTable+eax*4]
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.nCommandMode:
	cmp byte [CDmainControlRegister],byte 0x01
	jne .nResultMode
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Result Mode
	ret
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.nResultMode:
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Read-----------------------------------------------;
;------------------------------------------------------------------------------;
readCDr_1:						;Ok
	cmp byte [CDmainControlRegister],byte 0x00
	jne .nCommandMode
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Command Mode
;//
;                pusha
;        mov edx,[esp+0x24]
;        sub edx,DynRegister
;        shr edx,0x02
;        and edx,0xfffffffc
;                    push eax
;        push edx
;                    push dword ReadCD1
;                    rb_call ___rb___Log___Printf___
;                    add esp,0x0c
;                popa
;//
	ret
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.nCommandMode:
	cmp byte [CDmainControlRegister],byte 0x01
	jne NEAR .nResultMode
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Result Mode	;ReadResultBuffer
	cmp dword [ResultCount],dword 0x00000000
	je .NoResults
	mov ecx,[ResultCount]
	dec ecx
	jnz .stillready
	mov dword [ResultReady],dword 0x00000000
.stillready:
	movzx eax,byte [Results+ecx]
	mov [ResultCount],ecx
	mov ecx,0x00001801
;//
;                pusha
;        mov edx,[esp+0x24]
;        sub edx,DynRegister
;        shr edx,0x02
;        and edx,0xfffffffc
;                    push eax
;        push edx
;                    push dword ReadCD1
;                    rb_call ___rb___Log___Printf___
;                    add esp,0x0c
;                popa
;//
	ret
.NoResults:
	movzx eax,byte [Results]
;//
                pusha
        mov edx,[esp+0x24]
        sub edx,DynRegister
        shr edx,0x02
        and edx,0xfffffffc
                    push eax
        push edx
                    push dword ReadCD1
                    rb_call ___rb___Log___Printf___
                    add esp,0x0c
                popa
;//
	ret
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.nResultMode:
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Write----------------------------------------------;
;------------------------------------------------------------------------------;
writeCDr_2:
;//
;                pusha
;        mov edx,[esp+0x24]
;        sub edx,DynRegister
;        shr edx,0x02
;        and edx,0xfffffffc
;                    push eax
;        push edx
;                    push dword WriteCD2
;                    rb_call ___rb___Log___Printf___
;                    add esp,0x0c
;                popa
;//
	cmp byte [CDmainControlRegister],byte 0x00
	jne .nCommandMode
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Command Mode	;WriteArgs
	mov edx,[ArgCount]
	mov [Args+edx],al
	inc dword [ArgCount]
	ret
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.nCommandMode:
	cmp byte [CDmainControlRegister],byte 0x01
	jne .nResultMode
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Result Mode	;SomeThing
	ret
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.nResultMode:
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Read-----------------------------------------------;
;------------------------------------------------------------------------------;
readCDr_2:
	cmp byte [CDmainControlRegister],byte 0x00
	jne .nCommandMode
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Command Mode
;//
;                pusha
;        mov edx,[esp+0x24]
;        sub edx,DynRegister
;        shr edx,0x02
;        and edx,0xfffffffc
;                    push eax
;        push edx
;                    push dword ReadCD2
;                    rb_call ___rb___Log___Printf___
;                    add esp,0x0c
;                popa
;//
	ret
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.nCommandMode:
	cmp byte [CDmainControlRegister],byte 0x01
	jne .nResultMode
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Result Mode	;ReadDataBuffer
;	mov eax,0x00
;	cmp byte	[DataCount]	,byte	0x00
;        je .nCMdata_empty
;	movzx edx,byte [DataCount]
;	mov al,[Datas+edx]
;	dec byte [DataCount]
;	ret
;.nCMdata_empty:
;	mov byte [ResultReady],0x00
;//
;                pusha
;        mov edx,[esp+0x24]
;        sub edx,DynRegister
;        shr edx,0x02
;        and edx,0xfffffffc
;                    push eax
;        push edx
;                    push dword ReadCD2
;                    rb_call ___rb___Log___Printf___
;                    add esp,0x0c
;                popa
;//
        ret
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.nResultMode:
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Write----------------------------------------------;
;------------------------------------------------------------------------------;
writeCDr_3:						;Ok
;//
;                pusha
;        mov edx,[esp+0x24]
;        sub edx,DynRegister
;        shr edx,0x02
;        and edx,0xfffffffc
;                    push eax
;        push edx
;                    push dword WriteCD3
;                    rb_call ___rb___Log___Printf___
;                    add esp,0x0c
;                popa
;//
	cmp byte [CDmainControlRegister],byte 0x00
	jne .nCommandMode
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Command Mode
	and al,0x07
	mov byte [InterruptStatus],al
	ret
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.nCommandMode:
	cmp byte [CDmainControlRegister],byte 0x01
	jne .nResultMode
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Result Mode
	not eax
	and eax,0x00000007
	and byte [InterruptStatus],al
	ret
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.nResultMode:
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Read-----------------------------------------------;
;------------------------------------------------------------------------------;
readCDr_3:						;Ok
	cmp byte [CDmainControlRegister],byte 0x00
	jne .nCommandMode
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Command Mode
;//
;                pusha
;        mov edx,[esp+0x24]
;        sub edx,DynRegister
;        shr edx,0x02
;        and edx,0xfffffffc
;                    push eax
;        push edx
;                    push dword ReadCD3
;                    rb_call ___rb___Log___Printf___
;                    add esp,0x0c
;                popa
;//
	ret
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.nCommandMode:
	cmp byte [CDmainControlRegister],byte 0x01
	jne .nResultMode
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Result Mode
	movzx eax,byte [InterruptStatus]		;{__}
;//
;                pusha
;        mov edx,[esp+0x24]
;        sub edx,DynRegister
;        shr edx,0x02
;        and edx,0xfffffffc
;                    push eax
;        push edx
;                    push dword ReadCD3
;                    rb_call ___rb___Log___Printf___
;                    add esp,0x0c
;                popa
;//
	ret
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.nResultMode:
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Command---Execute-------------------------------------------;
;------------------------------------------------------------------------------;
CSync
			call _UnKnownCommand_
	ret
CNop:											;!!!Ok!!!
	mov eax,0x138									;FirstIntValue
	mov edx,ENop
	q_call q___w__int
	ret
ENop:											;!!!Ok!!!
	mov byte [InterruptStatus],0x03					;CommandComplete
	mov byte [ResultReady],0x01
	mov byte [ResultCount],0x01
	mov byte [Results],0x02
	mov eax,0x04
	mov edx,0x00ffffff
	ret
CSetloc:		;full
        mov edx,[ArgCount]
	sub edx,0x03
        mov eax,[Args+edx]
        mov [CurLocMin],eax
        mov [ArgCount],edx
;--
        mov eax,0x138			;??
        mov edx,ENop
	q_call q___w__int
        ret
CPlay:			;just nothing
;--
        mov eax,0x138
        mov edx,RbCDfuncRead
	q_call q___w__int
        ret
CForward
CBackward
                        call _UnKnownCommand_
	ret
CReadN:			;full
	mov byte [ReadNextSector],byte 0x01
        mov eax,0x138
        mov edx,DReadN
	q_call q___w__int
        ret
DReadN:
        mov eax,0x00
        mov edx,EReadN
	q_call q___w__int
;---
	push dword CurLocMin
	call [cdrHandles.cdrReadT]
;---
        mov byte [ResultReady],0x01
        mov byte [InterruptStatus],0x02                 ;Complete
        mov byte [ResultCount],0x01
        mov byte [Results],0x02
        mov eax,0x04
        mov edx,0x238
	ret
EReadN:
	call [cdrHandles.cdrGetBuf]
        push esi
	push edi
	mov esi,eax
	mov edi,SectorReadBuffer
	mov ecx,2340
	rep movsb
	pop edi
	pop esi
	mov dword [CurReadPointer],SectorReadBuffer
;---
	mov al,[CurLocSector]
	add al,0x26
	daa
	jc .addsec
	sub al,0x25
	das
	mov [CurLocSector],al
	jmp .addend
.addsec:
        mov [CurLocSector],al
        adc byte [CurLocSec],byte 0x00
.addend:
;+++
	mov eax,[CurLocMin]
	mov ecx,0xff000000
;	call writeWord
;+++
        push dword CurLocMin
        call [cdrHandles.cdrReadT]
;---
        mov byte [ResultReady],0x01
        mov byte [InterruptStatus],0x01                 ;DataReady
        mov byte [ResultCount],0x01
        mov byte [Results],0x02
        mov eax,0x04
        mov edx,0x238
	ret
CStandby
CStop
                        call _UnKnownCommand_
	ret
CPause:											;???Partialy???
	mov eax,0x138
	mov edx,EPause
	q_call q___w__int
    mov byte [InterruptStatus],0x03
	ret
;DPause:
;	mov byte [ResultReady],0x01
;	mov byte [ResultCount],0x01
;	mov byte [Results],0x02
;	mov dword [CommandAccepted],0x01
;	mov eax,0x00
;	mov edx,EPause
;	q_call q___w__int
;	mov eax,0x04
;	mov edx,0x0238
;	ret
EPause:
;	mov dword [CommandAccepted],0x00
;    mov byte [ResultReady],0x01
;    mov byte [ResultCount],0x01
;    mov byte [Results],0x02
	mov byte [InterruptStatus],0x02
	mov eax,0x04
	mov edx,0x00ffffff
	ret
CInit:			;simple		;blocked
;--
	mov eax,0x138
	mov edx,RbCDfuncB
	q_call q___w__int
        ret
CMute
                        call _UnKnownCommand_
	ret
CDemute:		;simple
        mov eax,0x138
        mov edx,RbCDfunc
	q_call q___w__int
        ret
CSetfilter
                        call _UnKnownCommand_
	ret
CSetmode:		;full
	mov edx,[ArgCount]
	dec edx
        mov al,[Args+edx]
        mov [ArgCount],edx
        mov [CDMode],al
;--
        mov eax,0x138
        mov edx,ENop
	q_call q___w__int
        ret
CGetparam
CGetlocL
CGetlocP
                        call _UnKnownCommand_
	ret
CGetTN:			;just nothing
;--
        mov eax,0x138
        mov edx,RbCDfunc
	q_call q___w__int
        ret
CGetTD:			;just nothing
;--
	mov eax,0x138
	mov edx,RbCDfunc
	q_call q___w__int
	ret
CSeekL:			;???Full???
	mov eax,0x138
	mov edx,ESeekL
	q_call q___w__int
	mov byte [InterruptStatus],0x03
	ret
ESeekL:			;???Full???
	mov byte [InterruptStatus],0x02
	mov eax,0x04
	mov edx,0x00ffffff
	ret
CSeekP
CTest
CID
CReadS
CReset
CReadTOC
                        call _UnKnownCommand_
	ret
RbCDfunc:
        mov byte [ResultReady],0x01
        mov byte [InterruptStatus],0x03			;Asknowledge
	mov byte [ResultCount],0x01
        mov byte [Results],0x02
        mov eax,0x04
	mov edx,0x00ffffff
	ret
RbCDfuncB:
        mov eax,0x00
        mov edx,RbCDfuncB2
	q_call q___w__int
;---
        mov byte [ResultReady],0x01
        mov byte [InterruptStatus],0x02                 ;Asknowledge
        mov byte [ResultCount],0x01
	mov byte [Results],0x02
        mov eax,0x04
        mov edx,0x0138
        ret
RbCDfuncB2:
        mov byte [ResultReady],0x01
        mov byte [InterruptStatus],0x02                 ;Complete
        mov byte [ResultCount],0x01
	mov byte [Results],0x02
        mov eax,0x04
        mov edx,0x00ffffff
        ret
RbCDfuncRead:
        mov eax,0x00
        mov edx,RbCDfuncRead2
	q_call q___w__int
;---
        mov byte [ResultReady],0x01
        mov byte [InterruptStatus],0x03                 ;Asknowledge
        mov byte [ResultCount],0x01
	mov byte [Results],0x02
        mov eax,0x04
        mov edx,0x0138
        ret
RbCDfuncRead2:
        mov byte [ResultReady],0x01
        mov byte [InterruptStatus],0x02                 ;Complete
        mov byte [ResultCount],0x01
	mov byte [Results],0x02
        mov eax,0x04
        mov edx,0x00ffffff
        ret
CDRHookFunction:
	mov edx,[esp+4]
	mov ecx,[esp+8]
	add edx,[RbPSeDataData+RbPSeDataStruc.Data___Memory___]
	push esi
	push edi
	mov esi,[CurReadPointer]
	mov edi,edx
	rep movsd
	mov [CurReadPointer],esi
	pop edi
	pop esi
	mov edx,[esp+4]
	mov ecx,[esp+8]
	rb_call ___rb___Clear___Dynarec___
    	push dword [esp+4]
        push dword ReadCD
        rb_call ___rb___Log___Printf___
        add esp,0x08
	ret
_UnKnownCommand_:
	pusha
    	push eax
    	push dword StrUnKnCom
        rb_call ___rb___Log___Printf___
        add esp,0x08
    popa
    ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
ConfigSectionPSEmuNames:
				dd  ConfigSectionPSEmuPlugin,ConfigSectionPSEmuConfig,0
cdrFuncNames	dd	CDRinitName,CDRopenName,CDRcloseName,CDRshutdownName
				dd	CDRgetTNName,CDRgetTDName,CDRreadTrackName
				dd	CDRgetBufferName,CDRplayName,CDRstopName,0
CDCommandTable:
	dd	CSync		,CNop		,CSetloc	,CPlay
	dd	CForward	,CBackward	,CReadN		,CStandby
	dd	CStop		,CPause		,CInit		,CMute
	dd	CDemute		,CSetfilter	,CSetmode	,CGetparam
	dd	CGetlocL	,CGetlocP	,0x00000000	,CGetTN
	dd	CGetTD		,CSeekL		,CSeekP		,0x00000000
	dd	0x00000000	,CTest		,CID		,CReadS
	dd	CReset		,0x00000000	,CReadTOC	,0x00000000
CDmainControlRegister	db	0x00
InterruptStatus			db	0x00
CommandAccepted			db	0x00000000
DMAReady				dd	0x00000001
ResultReady				dd	0x00000000
ResultCount				dd	0x00000000
ArgCount				dd	0x00000000
Results		db	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
			db	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
Args		db	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
			db	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
CurLocMin		db      0x00
CurLocSec		db      0x00
CurLocSector	db      0x00
CurLocTrack		db		0x00	;Reserved(NotUse)(for alingment)
CDMode			db      0x00
ReadNextSector	db		0x00
;;DataCount		db      0x00
;;Datas			db      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;;				db      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;;StatusCount	db      0x00
;;Statuses		db      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
;;				db      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00

ConfigFileName              db  "s_cdr_psemu.cfg",0
ConfigSectionPSEmu          db  "psemu",0
ConfigSectionPSEmuPlugin    db  "plugin",0
ConfigSectionPSEmuConfig    db  "config",0
ConfigSectionPSEmuDefName   db  "_nf_",0
WINDOWS_ONLY    PSEmuPluginDefName  db  "PSEmuPro\cdr.dll",0
BEOS_ONLY       PSEmuPluginDefName  db  "PSEmuPro/cdr.so",0
BEOS_ONLY       PSEmuConfigDefName  db  "PSEmuPro/cdr.cfg",0
ErrorLoadPSEmuCDRPlugin		db	"[  CDR  ]Error: Cann't Load PSEmu CDR plugin",10,0
ErrorInitPSEmuCDRPlugin		db	"[  CDR  ]Error: Cann't Init PSEmu CDR plugin",10,0
ErrorOpenPSEmuCDRPlugin		db	"[  CDR  ]Error: Cann't Open PSEmu CDR plugin",10,0
ErrorClosePSEmuCDRPlugin	db  "[  CDR  ]Error: Cann't Close PSEmu CDR plugin",10,0
ErrorShutdownPSEmuCDRPlugin	db  "[  CDR  ]Error: Cann't Shutdown PSEmu CDR plugin",10,0
CDRinitName			db	"CDRinit",0
CDRopenName			db	"CDRopen",0
CDRcloseName		db	"CDRclose",0
CDRshutdownName		db	"CDRshutdown",0
CDRgetTNName		db	"CDRgetTN",0
CDRgetTDName		db	"CDRgetTD",0
CDRreadTrackName	db	"CDRreadTrack",0
CDRgetBufferName	db	"CDRgetBuffer",0
CDRplayName			db	"CDRplay",0
CDRstopName			db	"CDRstop",0
;//
msg_cd_mode_select_command	db	"(%8x)SELECT MODE: ___COMMAND___ MODE",10,0
msg_cd_mode_select_result	db	"(%8x)SELECT MODE: ___RESULT___ MODE",10,0
msg_cd_mode_select_other	db	"(%8x)SELECT MODE: ___OTHER___ MODE",10,0
;//
;CDRead0			db	"CDREAD0 %X",13,10,0
CDRead1                 db      "CDREAD1 %X",13,10,0
CDRead2                 db      "CDREAD2 %X",13,10,0
CDRead3			db      "CD read interrupt status %X",13,10,0
CDWrite1                db      "CD write command : %X ",13,10,0
CDWrite2                db      "CDWRITE2 %X",13,10,0
CDWrite3                db      "CDWRITE3 %X",13,10,0
CDWrite3_fi		db	"Flush IRQ",13,10,0
WriteCD1        db  "(%8x)CD1 Write ---------- %x",10,0
WriteCD2        db  "(%8x)CD2 Write ---------- %x",10,0
WriteCD3        db  "(%8x)CD3 Write ---------- %x",10,0
ReadCD0			db	"(%8x)CD0 Read ----------- %x",10,0
ReadCD1         db  "(%8x)CD1 Read ----------- %x",10,0
ReadCD2         db  "(%8x)CD2 Read ----------- %x",10,0
ReadCD3			db  "(%8x)CD3 Read ----------- %x",10,0
StrUnKnCom		db	"[--CDR--]Warning: UnKnown CD Command -%x-",10,0
ReadCD			db	"[--CDR--]Info: Read Sector to -=|%x|=-",10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
ConfigSectionPSEmuBuffer
				resd	0x04*0x20
cdrHandles
.hlib			resd    1
.cdrINIT		resd    1
.cdrOPEN		resd    1
.cdrCLOSE		resd    1
.cdrSHUTDOWN	resd    1
.cdrGetTN		resd    1
.cdrGetTD		resd    1
.cdrReadT		resd    1
.cdrGetBuf		resd    1
.cdrPlay		resd    1
.cdrStop		resd    1
DMAData			resd    1
SectorReadBuffer	resd	0x250
CurReadPointer		resd    1
