;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
CEXTERN RbPSe_SysPrintf
CEXTERN	RbPSe_malloc
;------------------------------------------------------------------------------;
%define __CPULOG
%macro LogCPULOG 1
	%ifdef __CPULOG
		push dword %1
		rb_call ___rb___Log___Printf___
		add esp,0x04
	%endif
%endmacro
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
;Allocate DynaRec Memory
		push dword 0x00800000
		call RbPSe_malloc
		add esp,0x04
	test eax,eax
	jnz .DynarecMemoryAllocOk
		push dword DynarecMemoryAllocError
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.DynarecMemoryAllocOk:
	mov [Data___Dynarec___],eax
	INSTALL_DATA Data___Dynarec___,eax
;Allocate Branch Memory
		push dword 0x00200000
		call RbPSe_malloc
		add esp,0x04
	test eax,eax
	jnz .BranchMemoryAllocOk
		push dword BranchMemoryAllocError
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.BranchMemoryAllocOk:
	mov [Data___Branch___],eax
	INSTALL_FUNC Write___Dynarec___,Write___Dynarec___
	INSTALL_FUNC Clear___Dynarec___,Clear___Dynarec___
	INSTALL_HOOK Hook___Function___,Hook___Function___
    INSTALL_HOOK Hook___FunctionEx___,Hook___FunctionEx___
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
		push edi
		mov edi,[Data___Dynarec___]
		mov ecx,0x00010000
		mov eax,CallUnSKernel
		rep stosd
		mov ecx,0x001f0000
		mov eax,CallNotDecode
		rep stosd
;//		mov ecx,0x00080000
;//		mov eax,UnSBIOSCall
;//		rep stosd
		pop edi
	mov eax,[Data___Branch___]
	mov [NextFreeBranch],eax
	mov eax,OpcodeDecode				;Decode
	mov ecx,s___NotDecode				;      New
	rb_call ___rb___Hook___Table___		;         Block
	mov eax,OpcodeUKC					;Decode
	mov ecx,s___UnSKernel				;      Kernel
	rb_call ___rb___Hook___Table___		;            Block
	mov eax,OpcodeDiv					;Execute
	mov ecx,o___div						;       Divide
	rb_call ___rb___Hook___Table___		;             Operation
	mov eax,OpcodeDivu					;Unsigned
	mov ecx,o___divu					;        Divide
	rb_call ___rb___Hook___Table___		;              Operation
	mov eax,ExecuteBreak				;Break
	mov ecx,o___break					;     Opera
	rb_call ___rb___Hook___Table___		;          tion
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
Write___Dynarec___:;eax - from(src),edx - to(dst),ecx - len(dword)
	push ebx
	push esi
	push edi
		mov ebx,[Data___Dynarec___]
		mov esi,eax
		lea edi,[ebx+edx*4]
		rep movsd
	pop edi
	pop esi
	pop ebx
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
Clear___Dynarec___:;edx - to(dst),ecx - len(dword)
    push ebx
    push edi
		mov ebx,[Data___Dynarec___]
		mov eax,CallNotDecode
		lea edi,[ebx+edx*4]
		rep stosd
    pop edi
    pop ebx
    ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
Hook___Function___:;eax - func,edx - addr
	mov [BasicHookFunc.faddr],eax
	mov ecx,0x08
	mov eax,BasicHookFunc
	call Write___Dynarec___
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
Hook___FunctionEx___:;eax - func,edx - addr,ecx - size
	call Write___Dynarec___
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
OpcodeDecode:
	sub dword [esp],byte 0x03
	mov ebp,[esp]
	sub ebp,DynRegister
	shr ebp,0x02
	push esi
.loop:
	pop esi
    push esi
    push dword [byte esi + r___RA___b]
	push ebp
	LogCPULOG LOG_decode
    add esp,0x08
;;;;	pusha
;;;;	cmp ebp,0x00a72b8
;;;;	jne .next
;;;;		mov eax,Message_Error
;;;;		mov edx,Message_Error
;;;;		call Rb_message
;;;;.next:
;;;;	popa
;//
;    push dword [RegRegister+0x7c]
;    push dword [RegRegister+0x78]
;    push dword [RegRegister+0x74]
;    push dword [RegRegister+0x70]
;    push dword [RegRegister+0x6c]
;    push dword [RegRegister+0x68]
;    push dword [RegRegister+0x64]
;    push dword [RegRegister+0x60]
;    push dword [RegRegister+0x5c]
;    push dword [RegRegister+0x58]
;    push dword [RegRegister+0x54]
;    push dword [RegRegister+0x50]
;    push dword [RegRegister+0x4c]
;    push dword [RegRegister+0x48]
;    push dword [RegRegister+0x44]
;    push dword [RegRegister+0x40]
;    push dword [RegRegister+0x3c]
;    push dword [RegRegister+0x38]
;    push dword [RegRegister+0x34]
;    push dword [RegRegister+0x30]
;    push dword [RegRegister+0x2c]
;    push dword [RegRegister+0x28]
;    push dword [RegRegister+0x24]
;    push dword [RegRegister+0x20]
;    push dword [RegRegister+0x1c]
;    push dword [RegRegister+0x18]
;    push dword [RegRegister+0x14]
;    push dword [RegRegister+0x10]
;    push dword [RegRegister+0x0c]
;    push dword [RegRegister+0x08]
;    push dword [RegRegister+0x04]
;	push dword [RegRegister+0x00]
;	push dword [MemRegister+ebp]
;;
;	push esp
;	push edi
;	push esi
; 	push ebx
;	push ebp
;	push dword MMM2
;	push dword [cpuloghandle]
;	call fprintf
;;
;	add esp,0xa0
;;//
	mov eax,[MemRegister+ebp]
	mov edx,eax
	shr eax,26
	call [__Opcodes+eax*4]
;---out->esi
	push edi
	lea edi,[DynRegister+ebp*4]
	add ebp,ecx
	rep movsd
	pop edi
	test eax,eax
	jz .loop
;---
	pop esi
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
OpcodeUKC:
;;		push dword unsup_ker_call
;	push ebp
;	push eax
;	push Message_UnMIPSInst
;	push dword [LogFileHandle]
;;		call Log_printf
;;		add esp,0x04
;	call GeneralDecodeError
    sub dword [esp],byte 0x03
    mov ebp,[esp]
    sub ebp,DynRegister
    shr ebp,0x02
    push ebp
    push dword [byte esi + r___RA___b]
	LogCPULOG LOG_UKC
    add esp,0x08
;//
    push dword [RegRegister+0x7c]
    push dword [RegRegister+0x78]
    push dword [RegRegister+0x74]
    push dword [RegRegister+0x70]
    push dword [RegRegister+0x6c]
    push dword [RegRegister+0x68]
    push dword [RegRegister+0x64]
    push dword [RegRegister+0x60]
    push dword [RegRegister+0x5c]
    push dword [RegRegister+0x58]
    push dword [RegRegister+0x54]
    push dword [RegRegister+0x50]
    push dword [RegRegister+0x4c]
    push dword [RegRegister+0x48]
    push dword [RegRegister+0x44]
    push dword [RegRegister+0x40]
    push dword [RegRegister+0x3c]
    push dword [RegRegister+0x38]
    push dword [RegRegister+0x34]
    push dword [RegRegister+0x30]
    push dword [RegRegister+0x2c]
    push dword [RegRegister+0x28]
    push dword [RegRegister+0x24]
    push dword [RegRegister+0x20]
    push dword [RegRegister+0x1c]
    push dword [RegRegister+0x18]
    push dword [RegRegister+0x14]
    push dword [RegRegister+0x10]
    push dword [RegRegister+0x0c]
    push dword [RegRegister+0x08]
    push dword [RegRegister+0x04]
   push dword [RegRegister+0x00]
   push dword [MemRegister+ebp]
;;
   push esp
   push edi
   push esi
   push ebx
   push ebp
   push dword MMM2
   rb_call ___rb___Log___Printf___
;;
   add esp,0x9c
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
OpcodeDiv:
	idiv ecx
	mov [byte esi + r___LO___b],eax
	mov [byte esi + r___HI___b],edx
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
OpcodeDivu:
	div ecx
	mov [byte esi + r___LO___b],eax
	mov [byte esi + r___HI___b],edx
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
ExecuteBreak:
	LogCPULOG LOG_break
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_00:						;;;;Checked
	mov eax,edx					;
	test edx,edx					;
	jz .nop						;
	and eax,0x3f					;--00--SPECIAL
	jmp [__Specials+eax*4]				;
.nop:							;
	mov esi,COpcodeNOP				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_01:						;;;;Checked
	mov eax,edx					;
	shr eax,0x10					;
	and eax,0x1f					;--01--BCOND
	jmp [__BConds+eax*4]				;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_02:						;;;;
	push edi                                        ;
	shl edx,2					;
	and edx,0x001fffff				;
	lea edx,[DynRegister+edx*4]			;
	mov [COpcodeJ_j.t_addr],edx			;
	mov eax,[NextFreeBranch]			;
	mov [COpcodeJ.b_addr],eax			;
;--->
	mov eax,[MemRegister+ebp+0x04]			;
	mov edx,eax					;--02--J
	shr eax,26					;
	call [__Opcodes+eax*4]				;
;<---
        push esi					;
        push ecx					;
        mov edi,COpcodeJ.placeOpcode			;
        rep movsd                                       ;
        pop ecx						;
        pop esi						;
        mov edi,COpcodeJ_j.placeOpcode			;
        rep movsd					;
        mov esi,COpcodeJ_j                              ;
        mov edi,[NextFreeBranch]			;
        mov ecx,0x08					;
        add dword [NextFreeBranch],dword 0x00000020	;
        rep movsd					;
        mov esi,COpcodeJ				;
        mov ecx,0x08					;
        mov eax,0x01					;
        pop edi                                         ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_03:						;;;;Checked?
	push edi								;
	shl edx,2								;
	and edx,0x001fffff						;
	lea edx,[DynRegister+edx*4]
	mov [COpcodeJAL_j.t_addr],edx			;
	mov [COpcodeJAL.ra],ebp
	add [COpcodeJAL.ra],dword 0x08
	mov eax,[NextFreeBranch]                        ;
	mov [COpcodeJAL.b_addr],eax			;
;-->
	mov eax,[MemRegister+ebp+0x04]			;
	mov edx,eax					;--03--JAL
	shr eax,26					;
	call [__Opcodes+eax*4]				;
;<--
        push esi
        push ecx
        mov edi,COpcodeJAL.placeOpcode                  ;
        rep movsd                                       ;
        pop ecx
        pop esi
        mov edi,COpcodeJAL_j.placeOpcode                        ;
        rep movsd                                       ;
        mov esi,COpcodeJAL_j
        mov edi,[NextFreeBranch]
        mov ecx,0x08
        add dword [NextFreeBranch],dword 0x00000020
        rep movsd                                       ;
;    push dword [COpcodeJAL_j.t_addr]
;    LogCPULOG JAL_LOG
;    add esp,0x04
        mov esi,COpcodeJAL                              ;
        mov ecx,0x08                                    ;
        mov eax,0x01                                    ;
        pop edi                                         ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_04:						;;;;Checked
	push edi                                        ;
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	shl ecx,2					;
	add ecx,ebp					;
	add ecx,0x04					;
	lea ecx,[DynRegister+ecx*4]			;
	mov [COpcodeBEQ_b.t_addr],ecx			;
	mov [COpcodeBEQ.rs],dl				;
	mov [COpcodeBEQ.rt],al				;
	mov eax,[NextFreeBranch]			;
	mov [COpcodeBEQ.b_addr],eax			;
;--->
	mov eax,[MemRegister+ebp+0x04]			;
	mov edx,eax					;--04--BEQ
	shr eax,26					;
	call [__Opcodes+eax*4]				;
;<---
	push esi					;
	push ecx					;
	mov edi,COpcodeBEQ.placeOpcode			;
	rep movsd					;
	pop ecx						;
	pop esi						;
	mov edi,COpcodeBEQ_b.placeOpcode		;
	rep movsd					;
        mov esi,COpcodeBEQ_b				;
	mov edi,[NextFreeBranch]			;
	mov ecx,0x08					;
	rep movsd					;
        add dword [NextFreeBranch],dword 0x00000020	;
	mov esi,COpcodeBEQ				;
	mov ecx,0x08					;
	mov eax,0x01					;
        pop edi                                         ;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_05:						;;;;
        push edi                                        ;
        mov eax,edx                                     ;
        movsx ecx,dx                                    ;
        shr edx,0x15-2                                  ;
        and edx,0x1f<<2					;
        shr eax,0x10-2                                  ;
        and eax,0x1f<<2					;
        shl ecx,2                                       ;
        add ecx,ebp                                     ;
        add ecx,0x04					;
        lea ecx,[DynRegister+ecx*4]			;
        mov [COpcodeBNE_b.t_addr],ecx			;
        mov [COpcodeBNE.rs],dl				;
        mov [COpcodeBNE.rt],al				;
        mov eax,[NextFreeBranch]			;
        mov [COpcodeBNE.b_addr],eax			;
;--->
	mov eax,[MemRegister+ebp+0x04]			;
	mov edx,eax					;--05--BNE
	shr eax,26					;
	call [__Opcodes+eax*4]				;
;<---
        push esi					;
        push ecx					;
        mov edi,COpcodeBNE.placeOpcode                  ;
        rep movsd                                       ;
        pop ecx						;
        pop esi						;
        mov edi,COpcodeBNE_b.placeOpcode		;
        rep movsd                                       ;
        mov esi,COpcodeBNE_b				;
        mov edi,[NextFreeBranch]			;
        mov ecx,0x08					;
        add dword [NextFreeBranch],dword 0x00000020	;
        rep movsd                                       ;
        mov esi,COpcodeBNE                              ;
        mov ecx,0x08                                    ;
        mov eax,0x01                                    ;
        pop edi                                         ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_06:						;;;;Checked
        push edi                                        ;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shl ecx,2					;
	add ecx,ebp					;
	add ecx,0x04					;
	lea ecx,[DynRegister+ecx*4]			;
	mov [COpcodeBLEZ_b.t_addr],ecx			;
	mov [COpcodeBLEZ.rs],dl				;
        mov eax,[NextFreeBranch]			;
        mov [COpcodeBLEZ.b_addr],eax			;
;--->
	mov eax,[MemRegister+ebp+0x04]			;
	mov edx,eax					;--06--BLEZ
	shr eax,26					;
	call [__Opcodes+eax*4]				;
;<---
        push esi					;
        push ecx					;
        mov edi,COpcodeBLEZ.placeOpcode                 ;
        rep movsd                                       ;
        pop ecx						;
        pop esi						;
        mov edi,COpcodeBLEZ_b.placeOpcode		;
        rep movsd                                       ;
        mov esi,COpcodeBLEZ_b				;
        mov edi,[NextFreeBranch]			;
        mov ecx,0x08					;
        add dword [NextFreeBranch],dword 0x00000020	;
        rep movsd                                       ;
        mov esi,COpcodeBLEZ                             ;
        mov ecx,0x08                                    ;
        mov eax,0x01                                    ;
        pop edi                                         ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_07:						;;;;Checked
        push edi                                        ;
        movsx ecx,dx                                    ;
        shr edx,0x15-2                                  ;
        and edx,0x1f<<2					;
        shl ecx,2                                       ;
        add ecx,ebp                                     ;
        add ecx,0x04                                    ;
        lea ecx,[DynRegister+ecx*4]			;
        mov [COpcodeBGTZ_b.t_addr],ecx			;
        mov [COpcodeBGTZ.rs],dl				;
        mov eax,[NextFreeBranch]			;
        mov [COpcodeBGTZ.b_addr],eax			;
;--->
	mov eax,[MemRegister+ebp+0x04]			;
	mov edx,eax					;--07--BGTZ
	shr eax,26					;
	call [__Opcodes+eax*4]				;
;<---
        push esi					;
        push ecx					;
        mov edi,COpcodeBGTZ.placeOpcode                 ;
        rep movsd                                       ;
        pop ecx						;
        pop esi						;
        mov edi,COpcodeBGTZ_b.placeOpcode               ;
        rep movsd                                       ;
        mov esi,COpcodeBGTZ_b				;
        mov edi,[NextFreeBranch]			;
        mov ecx,0x08					;
        add dword [NextFreeBranch],dword 0x00000020	;
        rep movsd                                       ;
        mov esi,COpcodeBGTZ                             ;
        mov ecx,0x08                                    ;
        mov eax,0x01                                    ;
        pop edi                                         ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_08:						;;;;Checked
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--08--ADDI
	mov [COpcodeADDI.imm],ecx			;
	mov [COpcodeADDI.rs],dl				;
	mov [COpcodeADDI.rt],al				;
	mov esi,COpcodeADDI				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_09:						;;;;Checked
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--09--ADDIU
	mov [COpcodeADDIU.imm],ecx			;
	mov [COpcodeADDIU.rs],dl			;
	mov [COpcodeADDIU.rt],al			;
	mov esi,COpcodeADDIU				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_0a:						;;;;Checked
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;--0A--SLTI
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	mov [COpcodeSLTI.imm],ecx			;
	mov [COpcodeSLTI.rs],dl				;
	mov [COpcodeSLTI.rt],al				;
	mov esi,COpcodeSLTI				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_0b:						;;;;Checked
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;--0B--SLTIU
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	mov [COpcodeSLTIU.imm],ecx			;
	mov [COpcodeSLTIU.rs],dl			;
	mov [COpcodeSLTIU.rt],al			;
	mov esi,COpcodeSLTIU				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_0c:						;;;;Checked
	mov eax,edx					;
	movzx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;--0C--ANDI
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	mov [COpcodeANDI.imm],ecx			;
	mov [COpcodeANDI.rs],dl				;
	mov [COpcodeANDI.rt],al				;
	mov esi,COpcodeANDI				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_0d:						;;;;Checked
	mov eax,edx					;
	movzx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;--0D--ORI
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	mov [COpcodeORI.imm],ecx			;
	mov [COpcodeORI.rs],dl				;
	mov [COpcodeORI.rt],al				;
	mov esi,COpcodeORI				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_0e:						;;;;Checked
	mov eax,edx					;
	movzx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;--0E--XORI
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	mov [COpcodeXORI.imm],ecx			;
	mov [COpcodeXORI.rs],dl				;
	mov [COpcodeXORI.rt],al				;
	mov esi,COpcodeXORI				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_0f:						;;;;Checked
	mov eax,edx					;
	shl edx,0x10					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	mov [COpcodeLUI.imm],edx			;--0F--LUI
	mov [COpcodeLUI.rt],al				;
	mov esi,COpcodeLUI				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_10:						;;;;Ok---
        mov eax,edx                                     ;
        and eax,0x3f                                    ;--10--Cop0
        call [__Cop0s+eax*4]                            ;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_12:						;;;;
	mov eax,edx					;
	and eax,0x3f					;--12--Cop2
	call [__Cop2s+eax*4]				;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_20:						;;;;Checked
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--20--LB
	jz .lb_exit					;
	mov [COpcodeLB.imm],ecx				;
	mov [COpcodeLB.rs],dl				;
	mov [COpcodeLB.rt],al				;
	mov esi,COpcodeLB				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;
.lb_exit:						;
	mov esi,COpcodeNOP
	mov ecx,0x04
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_21:						;;;;Checked
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--21--LH
	jz .lh_exit					;
	mov [COpcodeLH.imm],ecx				;
	mov [COpcodeLH.rs],dl				;
	mov [COpcodeLH.rt],al				;
	mov esi,COpcodeLH				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;
.lh_exit:						;
	mov esi,COpcodeNOP
	mov ecx,0x04
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_22:						;;;;Checked?
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--22--LWL
	jz .lwl_exit					;
	mov [COpcodeLWL.imm],ecx			;
	mov [COpcodeLWL.rs],dl				;
	mov [COpcodeLWL.rt],al				;
	mov esi,COpcodeLWL				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;
.lwl_exit:						;
	mov esi,COpcodeNOP
	mov ecx,0x04
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_23:						;;;;Checked
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--23--LW
	jz .lw_exit					;
	mov [COpcodeLW.imm],ecx				;
	mov [COpcodeLW.rs],dl				;
	mov [COpcodeLW.rt],al				;
	mov esi,COpcodeLW				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;
.lw_exit:						;
	mov esi,COpcodeNOP				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_24:						;;;;Checked
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--24--LBU
	jz .lbu_exit					;
	mov [COpcodeLBU.imm],ecx			;
	mov [COpcodeLBU.rs],dl				;
	mov [COpcodeLBU.rt],al				;
	mov esi,COpcodeLBU				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;
.lbu_exit:						;
	mov esi,COpcodeNOP				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_25:						;;;;
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--25--LHU
	jz .lhu_exit					;
	mov [COpcodeLHU.imm],ecx			;
	mov [COpcodeLHU.rs],dl				;
	mov [COpcodeLHU.rt],al				;
	mov esi,COpcodeLHU				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;
.lhu_exit:						;
	mov esi,COpcodeNOP				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_26:						;;;;Checked?
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--26--LWR
	jz .lwr_exit					;
	mov [COpcodeLWR.imm],ecx			;
	mov [COpcodeLWR.rs],dl				;
	mov [COpcodeLWR.rt],al				;
	mov esi,COpcodeLWR				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;
.lwr_exit:						;
	mov esi,COpcodeNOP
	mov ecx,0x04
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_28:						;;;;Checked
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--28--SB
	mov [COpcodeSB.imm],ecx				;
	mov [COpcodeSB.rs],dl				;
	mov [COpcodeSB.rt],al				;
	mov esi,COpcodeSB				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_29:						;;;;Checked
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--29--SH
	mov [COpcodeSH.imm],ecx				;
	mov [COpcodeSH.rs],dl				;
	mov [COpcodeSH.rt],al				;
	mov esi,COpcodeSH				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_2a:						;;;;Checked?
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--2a--SWL
	mov [COpcodeSWL.imm],ecx			;
	mov [COpcodeSWL.rs],dl				;
	mov [COpcodeSWL.rt],al				;
	mov esi,COpcodeSWL				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_2b:						;;;;Checked
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--2B--SW
	mov [COpcodeSW.imm],ecx				;
	mov [COpcodeSW.rs],dl				;
	mov [COpcodeSW.rt],al				;
	mov esi,COpcodeSW				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_2e:						;;;;Checked?
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--2e--SWR
	mov [COpcodeSWR.imm],ecx			;
	mov [COpcodeSWR.rs],dl				;
	mov [COpcodeSWR.rt],al				;
	mov esi,COpcodeSWR				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_32:						;;;;
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f*4					;
	shr eax,0x10-2					;
	and eax,0x1f*4					;--32--LWC2
	mov [COpcodeLWC2.imm],ecx			;
	mov [COpcodeLWC2.rs],dl				;
	mov [COpcodeLWC2.rt],al				;
	mov esi,COpcodeLWC2				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Opcode_3a:						;;;;
	mov eax,edx					;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;--3A--SWC2
	mov [COpcodeSWC2.imm],ecx			;
	mov [COpcodeSWC2.rs],dl				;
	mov [COpcodeSWC2.rt],al				;
	mov esi,COpcodeSWC2				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_00:						;;;;Checked
	mov eax,edx					;
	mov ecx,edx					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	shr ecx,0x06					;--00--SLL
	and ecx,0x1f					;
	mov [COpcodeSLL.rt],al				;
	mov [COpcodeSLL.sa],cl				;
	mov [COpcodeSLL.rd],dl				;
	mov esi,COpcodeSLL				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_02:						;;;;Checked
	mov eax,edx					;
	mov ecx,edx					;
	shr eax,0x10-2					;--02--SRL
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	shr ecx,0x06					;
	and ecx,0x1f
	mov [COpcodeSRL.rt],al				;
	mov [COpcodeSRL.sa],cl				;
	mov [COpcodeSRL.rd],dl				;
	mov esi,COpcodeSRL				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_03:						;;;;Checked
	mov eax,edx					;
	mov ecx,edx					;
	shr eax,0x10-2					;--03--SRA
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	shr ecx,0x06					;
	and ecx,0x1f
	mov [COpcodeSRA.rt],al				;
	mov [COpcodeSRA.sa],cl				;
	mov [COpcodeSRA.rd],dl				;
	mov esi,COpcodeSRA				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_04:						;;;;Checked
	mov ecx,edx					;
	mov eax,edx					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	shr ecx,0x15-2					;
	and ecx,0x1f<<2					;
	shr edx,0x0b-2					;--04--SLLV
	and edx,0x1f<<2					;
	mov [COpcodeSLLV.rt],al				;
	mov [COpcodeSLLV.rs],cl				;
	mov [COpcodeSLLV.rd],dl				;
	mov esi,COpcodeSLLV				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_06:						;;;;
	mov ecx,edx					;
	mov eax,edx					;
	shr eax,0x10-2					;
	and eax,0x1f*4					;
	shr ecx,0x15-2					;
	and ecx,0x1f*4					;
	shr edx,0x0b-2					;--06--SRLV
	and edx,0x1f*4					;
	mov [COpcodeSRLV.rt],al				;
	mov [COpcodeSRLV.rs],cl				;
	mov [COpcodeSRLV.rd],dl				;
	mov esi,COpcodeSRLV				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_07:						;;;;Checked
	mov ecx,edx					;
	mov eax,edx					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	shr ecx,0x15-2					;
	and ecx,0x1f<<2					;
	shr edx,0x0b-2					;--07--SRAV
	and edx,0x1f<<2					;
	mov [COpcodeSRAV.rt],al				;
	mov [COpcodeSRAV.rs],cl				;
	mov [COpcodeSRAV.rd],dl				;
	mov esi,COpcodeSRAV				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_08:						;;;;Checked
        push edi                                        ;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	mov [COpcodeJR.rs],dl				;
        mov eax,[NextFreeBranch]                        ;
        mov [COpcodeJR.b_addr],eax			;
;--->
	mov eax,[MemRegister+ebp+0x04]			;
	mov edx,eax					;--08--JR
	shr eax,26					;
	call [__Opcodes+eax*4]				;
;<---
        push esi					;
        push ecx					;
        mov edi,COpcodeJR.placeOpcode			;
        rep movsd                                       ;
        pop ecx						;
        pop esi						;
        mov edi,COpcodeJR_j.placeOpcode			;
        rep movsd                                       ;
        mov esi,COpcodeJR_j				;
        mov edi,[NextFreeBranch]                        ;
        mov ecx,0x08                                    ;
        add dword [NextFreeBranch],dword 0x00000020     ;
        rep movsd                                       ;
        mov esi,COpcodeJR				;
        mov ecx,0x08                                    ;
        mov eax,0x01                                    ;
        pop edi                                         ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_09:						;;;;Checked
        push edi                                        ;
        shr edx,0x15-2                                  ;
        and edx,0x1f<<2					;
        mov [COpcodeJALR.rs],dl				;
        mov [COpcodeJALR_j.ra],ebp			;
        add [COpcodeJALR_j.ra],dword 0x08		;
        mov eax,[NextFreeBranch]                        ;
        mov [COpcodeJALR.b_addr],eax			;
;--->
	mov eax,[MemRegister+ebp+0x04]			;
	mov edx,eax					;--09--JALR
	shr eax,26					;
	call [__Opcodes+eax*4]				;
;<---
        push esi					;
        push ecx					;
        mov edi,COpcodeJALR.placeOpcode			;
        rep movsd                                       ;
        pop ecx						;
        pop esi						;
        mov edi,COpcodeJALR_j.placeOpcode		;
        rep movsd                                       ;
        mov esi,COpcodeJALR_j				;
        mov edi,[NextFreeBranch]                        ;
        mov ecx,0x0c                                    ;
        add dword [NextFreeBranch],dword 0x00000030     ;
        rep movsd                                       ;
        mov esi,COpcodeJALR				;
        mov ecx,0x08                                    ;
        mov eax,0x01                                    ;
        pop edi                                         ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_0c:						;;;;Checked
	mov esi,COpcodeSYSCALL				;
	mov ecx,0x04					;--0c--SYSCALL
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_0d:						;;;;Checked
        mov esi,COpcodeBREAK				;
        mov ecx,0x04                                    ;--0d--BREAK
        xor eax,eax                                     ;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_10:						;;;;Ok
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	mov [COpcodeMFHI.rd],dl				;--10--MFHI
	mov esi,COpcodeMFHI				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_12:						;;;;Checked
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	mov [COpcodeMFLO.rd],dl				;--12--MFLO
	mov esi,COpcodeMFLO				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_18:						;;;;Checked
	mov eax,edx					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	shr edx,0x15-2					;--18--MULT
	and edx,0x1f<<2					;
	mov [COpcodeMULT.rs],dl				;
	mov [COpcodeMULT.rt],al				;
	mov esi,COpcodeMULT				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_19:						;;;;
	mov eax,edx					;
	shr eax,0x10-2					;
	and eax,0x1f*4					;
	shr edx,0x15-2					;--19--MULTU
	and edx,0x1f*4					;
	mov [COpcodeMULTU.rs],dl			;
	mov [COpcodeMULTU.rt],al			;
	mov esi,COpcodeMULTU				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_1a:						;;;;
	mov eax,edx					;
	shr eax,0x10-2					;
	and eax,0x1f*4					;
	shr edx,0x15-2					;
	and edx,0x1f*4					;--1A--DIV
	mov [COpcodeDIV.rs],dl				;
	mov [COpcodeDIV.rt],al				;
	mov esi,COpcodeDIV				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_1b:						;;;;
	mov eax,edx					;
	shr eax,0x10-2					;
	and eax,0x1f*4					;
	shr edx,0x15-2					;
	and edx,0x1f*4					;--1B--DIVU
	mov [COpcodeDIVU.rs],dl				;
	mov [COpcodeDIVU.rt],al				;
	mov esi,COpcodeDIVU				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_20:						;;;;
	mov eax,edx					;
	mov ecx,edx					;
	shr ecx,0x15-2					;
	and ecx,0x1f*4					;
	shr eax,0x10-2					;--20--ADD
	and eax,0x1f*4					;
	shr edx,0x0b-2					;
	and edx,0x1f*4					;
	mov [COpcodeADD.rs],cl				;
	mov [COpcodeADD.rt],al				;
	mov [COpcodeADD.rd],dl				;
	mov esi,COpcodeADD				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_21:						;;;;Checked
	mov eax,edx					;
	mov ecx,edx					;
	shr ecx,0x15-2					;
	and ecx,0x1f<<2					;
	shr eax,0x10-2					;--21--ADDU
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	mov [COpcodeADDU.rs],cl				;
	mov [COpcodeADDU.rt],al				;
	mov [COpcodeADDU.rd],dl				;
	mov esi,COpcodeADDU				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_22:						;;;;
	mov eax,edx					;
	mov ecx,edx					;
	shr ecx,0x15-2					;
	and ecx,0x1f<<2					;
	shr eax,0x10-2					;--23--SUB
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	mov [COpcodeSUB.rs],cl				;
	mov [COpcodeSUB.rt],al				;
	mov [COpcodeSUB.rd],dl				;
	mov esi,COpcodeSUB				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_23:						;;;;Checked
	mov eax,edx					;
	mov ecx,edx					;
	shr ecx,0x15-2					;
	and ecx,0x1f<<2					;
	shr eax,0x10-2					;--23--SUBU
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	mov [COpcodeSUBU.rs],cl				;
	mov [COpcodeSUBU.rt],al				;
	mov [COpcodeSUBU.rd],dl				;
	mov esi,COpcodeSUBU				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_24:						;;;;Checked
	mov eax,edx					;
	mov ecx,edx					;
	shr ecx,0x15-2					;
	and ecx,0x1f<<2					;
	shr eax,0x10-2					;--24--AND
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	mov [COpcodeAND.rs],cl				;
	mov [COpcodeAND.rt],al				;
	mov [COpcodeAND.rd],dl				;
	mov esi,COpcodeAND				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_25:						;;;;Checked
	mov eax,edx					;
	mov ecx,edx					;
	shr ecx,0x15-2					;
	and ecx,0x1f<<2					;
	shr eax,0x10-2					;--25--OR
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	mov [COpcodeOR.rs],cl				;
	mov [COpcodeOR.rt],al				;
	mov [COpcodeOR.rd],dl				;
	mov esi,COpcodeOR				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_26:						;;;;
	mov eax,edx					;
	mov ecx,edx					;
	shr ecx,0x15-2					;
	and ecx,0x1f<<2					;
	shr eax,0x10-2					;--26--XOR
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	mov [COpcodeXOR.rs],cl				;
	mov [COpcodeXOR.rt],al				;
	mov [COpcodeXOR.rd],dl				;
	mov esi,COpcodeXOR				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_27:						;;;;
	mov eax,edx					;
	mov ecx,edx					;
	shr ecx,0x15-2					;
	and ecx,0x1f<<2					;
	shr eax,0x10-2					;--27--NOR
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	mov [COpcodeNOR.rs],cl				;
	mov [COpcodeNOR.rt],al				;
	mov [COpcodeNOR.rd],dl				;
	mov esi,COpcodeNOR				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_2a:						;;;;Checked
	mov eax,edx					;
	mov ecx,edx					;
	shr ecx,0x15-2					;
	and ecx,0x1f<<2					;--2A--SLT
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	mov [COpcodeSLT.rs],cl				;
	mov [COpcodeSLT.rt],al				;
	mov [COpcodeSLT.rd],dl				;
	mov esi,COpcodeSLT				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Special_2b:						;;;;Checked
	mov eax,edx					;
	mov ecx,edx					;
	shr ecx,0x15-2					;
	and ecx,0x1f<<2					;--2B--SLTU
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;
	mov [COpcodeSLTU.rs],cl				;
	mov [COpcodeSLTU.rt],al				;
	mov [COpcodeSLTU.rd],dl				;
	mov esi,COpcodeSLTU				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__BCond_00:						;;;;Checked
        push edi                                        ;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shl ecx,2					;
	add ecx,ebp					;
	add ecx,0x04					;
	lea ecx,[DynRegister+ecx*4]			;
        mov [COpcodeBLTZ_b.t_addr],ecx			;
        mov [COpcodeBLTZ.rs],dl				;
        mov eax,[NextFreeBranch]			;
        mov [COpcodeBLTZ.b_addr],eax			;
;--->
	mov eax,[MemRegister+ebp+0x04]			;
	mov edx,eax					;--00--BLTZ
	shr eax,26					;
	call [__Opcodes+eax*4]				;
;<---
        push esi					;
        push ecx					;
        mov edi,COpcodeBLTZ.placeOpcode                 ;
        rep movsd                                       ;
        pop ecx						;
        pop esi						;
        mov edi,COpcodeBLTZ_b.placeOpcode               ;
        rep movsd                                       ;
        mov esi,COpcodeBLTZ_b				;
        mov edi,[NextFreeBranch]			;
        mov ecx,0x08					;
        add dword [NextFreeBranch],dword 0x00000020	;
        rep movsd                                       ;
        mov esi,COpcodeBLTZ                             ;
        mov ecx,0x08                                    ;
        mov eax,0x01                                    ;
        pop edi                                         ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__BCond_01:						;;;;Checked
        push edi                                        ;
	movsx ecx,dx					;
	shr edx,0x15-2					;
	and edx,0x1f<<2					;
	shl ecx,2					;
	add ecx,ebp					;
	add ecx,0x04					;
	lea ecx,[DynRegister+ecx*4]			;
        mov [COpcodeBGEZ_b.t_addr],ecx			;
        mov [COpcodeBGEZ.rs],dl				;
        mov eax,[NextFreeBranch]			;
        mov [COpcodeBGEZ.b_addr],eax			;
;--->
	mov eax,[MemRegister+ebp+0x04]			;
	mov edx,eax					;--01--BGEZ
	shr eax,26					;
	call [__Opcodes+eax*4]				;
;<---
        push esi					;
        push ecx					;
        mov edi,COpcodeBGEZ.placeOpcode                 ;
        rep movsd                                       ;
        pop ecx						;
        pop esi						;
        mov edi,COpcodeBGEZ_b.placeOpcode               ;
        rep movsd                                       ;
        mov esi,COpcodeBGEZ_b				;
        mov edi,[NextFreeBranch]			;
        mov ecx,0x08					;
        add dword [NextFreeBranch],dword 0x00000020	;
        rep movsd                                       ;
        mov esi,COpcodeBGEZ                             ;
        mov ecx,0x08                                    ;
        mov eax,0x01                                    ;
        pop edi                                         ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__BCond_11:                                             ;;;;
        movsx ecx,dx                                    ;
        shr edx,0x15-2                                  ;
        and edx,0x1f*4                                  ;
        shl ecx,2                                       ;
        add ecx,ebp                                     ;
        add ecx,0x04                                    ;
        lea ecx,[DynRegister+ecx*4]
        mov [COpcodeBGEZAL_b.t_addr],ecx
        mov [COpcodeBGEZAL.rs],dl
        mov eax,[NextFreeBranch]
        mov [COpcodeBGEZAL.b_addr],eax
        mov [COpcodeBGEZAL_b.ra],ebp
        add [COpcodeBGEZAL_b.ra],dword 0x08
;--->
        mov eax,[MemRegister+ebp+0x04]                  ;
        mov edx,eax                                     ;--11--BGEZAL
        shr eax,26                                      ;
        call [__Opcodes+eax*4]                          ;
;<---
        push edi                                        ;
;
        push esi
        push ecx
        mov edi,COpcodeBGEZAL.placeOpcode                 ;
        rep movsd                                       ;
;
        pop ecx
        pop esi
        mov edi,COpcodeBGEZAL_b.placeOpcode               ;
        rep movsd                                       ;
;
        mov edi,[NextFreeBranch]
        mov esi,COpcodeBGEZAL_b
        mov ecx,0x0C
        add dword [NextFreeBranch],dword 0x00000030
        rep movsd                                       ;
;
        pop edi                                         ;
        mov esi,COpcodeBGEZAL				;
        mov ecx,0x08                                    ;
        mov eax,0x01                                    ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop0Ext:                                              ;;;;
        mov eax,edx
        shr eax,0x15
        and eax,0x1f
        call [__Cop0Exts+eax*4]
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop0Ext_00:                                           ;;;;
	mov eax,edx                                     ;
	shr edx,0x0b-2                                  ;
	and edx,0x1f<<2					;
	shr eax,0x10-2                                  ;--00--MFC0
	and eax,0x1f<<2					;
	jz .nop						;
	mov [COpcodeMFC0.rt],al                         ;
	mov [COpcodeMFC0.rd],dl                         ;
	mov esi,COpcodeMFC0                             ;
	mov ecx,0x04                                    ;
	xor eax,eax                                     ;
	ret						;
.nop:							;
	mov esi,COpcodeNOP				;
	mov ecx,0x04					;
	xor eax,eax                                     ;
	ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop0Ext_04:                                           ;;;;
        mov eax,edx                                     ;
        shr eax,0x10-2                                  ;
        and eax,0x1f<<2					;
        shr edx,0x0b-2                                  ;--04--MTC0
        and edx,0x1f<<2					;
        mov [COpcodeMTC0.rt],al                         ;
        mov [COpcodeMTC0.rd],dl                         ;
        mov esi,COpcodeMTC0                             ;
        mov ecx,0x04                                    ;
        xor eax,eax                                     ;
	ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2Ext:						;;;;
	mov eax,edx
	shr eax,0x15
	and eax,0x1f
	call [__Cop2Exts+eax*4]
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_01:						;;;;
	mov [COpcodeRTPS.data],edx			;
	mov esi,COpcodeRTPS				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_06:                                              ;;;;NOT!!!
        mov [COpcodeNCLIP.data],edx                      ;
        mov esi,COpcodeNCLIP                             ;
        mov ecx,0x04                                    ;
        xor eax,eax                                     ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_10:						;;;;NOT!!!
	mov [COpcodeDPCS.data],edx			;
	mov esi,COpcodeDPCS				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_12:						;;;;NOT!!!
	mov [COpcodeMVMVA.data],edx			;
	mov esi,COpcodeMVMVA				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_13:						;;;;NOT!!!
	mov [COpcodeNCDS.data],edx			;
	mov esi,COpcodeNCDS				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_16:						;;;;NOT!!!
	mov [COpcodeNCDT.data],edx			;
	mov esi,COpcodeNCDT				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_1b:						;;;;NOT!!!
	mov [COpcodeNCCS.data],edx			;
	mov esi,COpcodeNCCS				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_28:                                              ;;;;
        mov [COpcodeSQR.data],edx			;
        mov esi,COpcodeSQR				;
        mov ecx,0x04                                    ;
        xor eax,eax                                     ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_29:                                              ;;;;
        mov [COpcodeDCPL.data],edx			;
        mov esi,COpcodeDCPL				;
        mov ecx,0x04                                    ;
        xor eax,eax                                     ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_2d:                                              ;;;;
        mov [COpcodeAVSZ3.data],edx                     ;
        mov esi,COpcodeAVSZ3				;
        mov ecx,0x04                                    ;
        xor eax,eax                                     ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_2e:                                              ;;;;
        mov [COpcodeAVSZ4.data],edx                     ;
        mov esi,COpcodeAVSZ4                            ;
        mov ecx,0x04                                    ;
        xor eax,eax                                     ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_30:                                              ;;;;
        mov [COpcodeRTPT.data],edx                      ;
        mov esi,COpcodeRTPT                             ;
        mov ecx,0x04                                    ;
        xor eax,eax                                     ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_3d:                                              ;;;;
        mov [COpcodeGPF.data],edx			;
        mov esi,COpcodeGPF				;
        mov ecx,0x04                                    ;
        xor eax,eax                                     ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_3e:                                              ;;;;
        mov [COpcodeGPL.data],edx                       ;
        mov esi,COpcodeGPL                              ;
        mov ecx,0x04                                    ;
        xor eax,eax                                     ;
        ret                                             ;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2_3f:						;;;;
        mov [COpcodeNCCT.data],edx			;
        mov esi,COpcodeNCCT				;
        mov ecx,0x04					;
        xor eax,eax					;
        ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2Ext_00:						;;;;
	mov eax,edx					;
	shr edx,0x0b-2                                  ;
	and edx,0x1f<<2					;
	shr eax,0x10-2                                  ;
	and eax,0x1f<<2					;
	jz .nop						;
	mov [COpcodeMFC2.rd],dl				;
	mov [COpcodeMFC2.rt],al				;
	mov esi,COpcodeMFC2				;--00--MFC2
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;
.nop:							;
	mov esi,COpcodeNOP				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2Ext_02:						;;;;
	mov eax,edx					;
	shr edx,0x0b-2                                  ;
	and edx,0x1f<<2					;
	shr eax,0x10-2                                  ;
	and eax,0x1f<<2					;
	jz .nop						;
	mov [COpcodeCFC2.rd],dl				;
	mov [COpcodeCFC2.rt],al				;
	mov esi,COpcodeCFC2				;--02--CFC2
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;
.nop:							;
	mov esi,COpcodeNOP				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2Ext_04:						;;;;
	mov eax,edx					;
	shr eax,0x10-2                                  ;
	and eax,0x1f<<2                                 ;
	shr edx,0x0b-2                                  ;--04--MTC2
	and edx,0x1f<<2                                 ;
	mov [COpcodeMTC2.rt],al				;
	mov [COpcodeMTC2.rd],dl				;
	mov esi,COpcodeMTC2				;
 	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
__Cop2Ext_06:						;;;;
	mov eax,edx					;
	shr eax,0x10-2					;
	and eax,0x1f<<2					;
	shr edx,0x0b-2					;
	and edx,0x1f<<2					;--06--CTC2
	mov [COpcodeCTC2.rt],al				;
	mov [COpcodeCTC2.rd],dl				;
	mov esi,COpcodeCTC2				;
	mov ecx,0x04					;
	xor eax,eax					;
	ret						;;;;
;------------------------------------------------------------------------------;
__UnsupOp:
		push dword ErrorUnsupOpInst
		call RbPSe_SysPrintf
		add esp,0x04
;	push ebx
;	push edi
;	push esi
;	push dword RError
;	call _Rb_SysPrintf
;	jmp $
;	mov ecx,0x00000000
;	mov edx,0x00000000
;	call cpuWriteError
	ret
__UnsupSp:
		push dword ErrorUnsupSpInst
		call RbPSe_SysPrintf
		add esp,0x04
;	mov ecx,0x00000000
;	mov edx,0x00000001
;	call cpuWriteError
	ret
__UnsupBc:
		push dword ErrorUnsupBcInst
		call RbPSe_SysPrintf
		add esp,0x04
;	mov ecx,0x00000000
;	mov edx,0x00000002
;	call cpuWriteError
	ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
Data___Dynarec___	dd	0
Data___Branch___	dd	0
;--- F u n c t i o n -- f o r -- D R H o o k F u n c --------------------------;
BasicHookFunc	db	0xb8
.faddr			db	0x00,0x00,0x00,0x00,0xff,0xd0,0x8b,0x46
.ra				db	r___RA___b,0x25,0xff,0xff,0x1f,0x00
				db	0x8d,0x04,0x83,0xff,0xe0
				db	0x00,0x00,0x00,0x00,0x00,0x00
				db	0x00,0x00,0x00,0x00,0x00,0x00
;----- Op = 00 ------------------------------------------------------;Checked
COpcodeNOP		db	0xeb,0x0e,0x90,0x90,0x90,0x90,0x90,0x90
				db	0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Op = 02 -New-Interface-Main-----------------------------------;Checked
COpcodeJ		db	0xb8
.b_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
;--------------------------------------------------------------------;Opt
;----- Op = 02 -New-Interface-Jump-----------------------------------;Checked
COpcodeJ_j
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
				db	0xff,0x56
.do_timing		db	s___timing___b,0xb8
.t_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 03 -New-Interface-Main-----------------------------------;
COpcodeJAL		db	0xc7,0x46,r___RA___b
.ra				db	0x00,0x00,0x00,0x00,0xb8
.b_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0,0x90,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
;--------------------------------------------------------------------;
;----- Op = 03 -New-Interface-Jump-----------------------------------;
COpcodeJAL_j
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
				db	0xff,0x56
.do_timing		db	s___timing___b,0xb8
.t_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- Op = 04 -New-Interface-Main-----------------------------------;Checked
COpcodeBEQ		db	0x8b,0x46
.rs				db	0x00,0x3b,0x46
.rt				db	0x00,0x75,0x08,0xb8
.b_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
;--------------------------------------------------------------------;Opt?
;----- Op = 04 -New-Interface-Branch---------------------------------;Checked
COpcodeBEQ_b
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
				db	0xff,0x56
.do_timing		db	s___timing___b,0xb8
.t_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 05 -New-Interface-Main-----------------------------------;Checked
COpcodeBNE		db	0x8b,0x46
.rs				db	0x00,0x3b,0x46
.rt				db	0x00,0x74,0x08,0xb8
.b_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
;--------------------------------------------------------------------;Opt?
;----- Op = 05 -New-Interface-Branch---------------------------------;Checked
COpcodeBNE_b
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
				db	0xff,0x56
.do_timing		db	s___timing___b,0xb8
.t_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 06 -New-Interface-Main-----------------------------------;Checked
COpcodeBLEZ		db	0x8b,0x46
.rs				db	0x00,0x83,0xf8
				db	0x00,0x7f,0x08,0xb8
.b_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
;--------------------------------------------------------------------;Opt?
;----- Op = 06 -New-Interface-Branch---------------------------------;Checked
COpcodeBLEZ_b
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
				db	0xff,0x56
.do_timing		db	s___timing___b,0xb8
.t_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 07 -New-Interface-Main-----------------------------------;Checked
COpcodeBGTZ		db	0x8b,0x46
.rs				db	0x00,0x83,0xf8
				db	0x00,0x7e,0x08,0xb8
.b_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
;--------------------------------------------------------------------;Opt?
;----- Op = 07 -New-Interface-Branch---------------------------------;Checked
COpcodeBGTZ_b
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
				db	0xff,0x56
.do_timing		db	s___timing___b,0xb8
.t_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 08 ------------------------------------------------------;Checked
COpcodeADDI		db	0x8b,0x46
.rs				db	0x00,0x05
.imm			db	0x00,0x00,0x00,0x00,0x89,0x46
.rt				db	0x00,0xeb,0x03,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 09 ------------------------------------------------------;Checked
COpcodeADDIU	db	0x8b,0x46
.rs				db	0x00,0x05
.imm			db	0x00,0x00,0x00,0x00,0x89,0x46
.rt				db	0x00,0xeb,0x03,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt=
;----- Op = 0a ------------------------------------------------------;Checked
COpcodeSLTI		db	0x33,0xd2,0x8b,0x46
.rs				db	0x00,0x3d
.imm			db	0x00,0x00,0x00,0x00,0x7d,0x01,0x42,0x89,0x56
.rt				db	0x00
;--------------------------------------------------------------------;Opt?
;----- Op = 0a ------------------------------------------------------;Checked
COpcodeSLTIU	db	0x33,0xd2,0x8b,0x46
.rs				db	0x00,0x3d
.imm			db	0x00,0x00,0x00,0x00,0x73,0x01,0x42,0x89,0x56
.rt				db	0x00
;--------------------------------------------------------------------;Opt?
;----- Op = 0c ------------------------------------------------------;Checked
COpcodeANDI		db	0x8b,0x46
.rs				db	0x00,0x25
.imm			db	0x00,0x00,0x00,0x00,0x89,0x46
.rt				db	0x00,0xeb,0x03,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 0d ------------------------------------------------------;Checked
COpcodeORI		db	0x8b,0x46
.rs				db	0x00,0x0d
.imm			db	0x00,0x00,0x00,0x00,0x89,0x46
.rt				db	0x00,0xeb,0x03,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 0e ------------------------------------------------------;Checked
COpcodeXORI		db	0x8b,0x46
.rs				db	0x00,0x35
.imm			db	0x00,0x00,0x00,0x00,0x89,0x46
.rt				db	0x00,0xeb,0x03,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 0f ------------------------------------------------------;Checked
COpcodeLUI		db	0xc7,0x46
.rt				db	0x00
.imm			db	0x00,0x00,0x00,0x00,0xeb,0x07
				db	0x90,0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 20 ------------------------------------------------------;
COpcodeLB		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x03,0x4e
.rs				db	0x00,0xff,0x56
.func			db	f___MemRead8S___b,0x89,0x46
.rt				db	0x00,0x90,0x90
;--------------------------------------------------------------------;
;----- Op = 21 ------------------------------------------------------;Checked
COpcodeLH		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x03,0x4e
.rs				db	0x00,0xff,0x56
.func			db	f___MemRead16S___b,0x89,0x46
.rt				db	0x00,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 22 ------------------------------------------------------;Checked?
COpcodeLWL		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x03,0x4e
.rs				db	0x00,0xb2
.rt				db	0x00,0xff,0x56
.func			db	f___MemReadL___b,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- Op = 23 ------------------------------------------------------;Checked
COpcodeLW		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x03,0x4e
.rs				db	0x00,0xff,0x56
.func			db	f___MemRead32___b,0x89,0x46
.rt				db	0x00,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 24 ------------------------------------------------------;Checked
COpcodeLBU		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x03,0x4e
.rs				db	0x00,0xff,0x56
.func			db	f___MemRead8U___b,0x89,0x46
.rt				db	0x00,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 25 ------------------------------------------------------;Checked
COpcodeLHU		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x03,0x4e
.rs				db	0x00,0xff,0x56
.func			db	f___MemRead16U___b,0x89,0x46
.rt				db	0x00,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Op = 26 ------------------------------------------------------;Checked?
COpcodeLWR		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x03,0x4e
.rs				db	0x00,0xb2
.rt				db	0x00,0xff,0x56
.func			db	f___MemReadR___b,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- Op = 28 ------------------------------------------------------;Checked
COpcodeSB		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x8b,0x46
.rt				db	0x00,0x03,0x4e
.rs				db	0x00,0xff,0x56
.func			db	f___MemWrite8___b,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Op = 29 ------------------------------------------------------;Checked
COpcodeSH		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x8b,0x46
.rt				db	0x00,0x03,0x4e
.rs				db	0x00,0xff,0x56
.func			db	f___MemWrite16___b,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Op = 2a ------------------------------------------------------;Checked?
COpcodeSWL		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x03,0x4e
.rs				db	0x00,0xb2
.rt				db	0x00,0xff,0x56
.func			db	f___MemWriteL___b,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- Op = 2b ------------------------------------------------------;Checked
COpcodeSW		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x8b,0x46
.rt				db	0x00,0x03,0x4e
.rs				db	0x00,0xff,0x56
.func			db	f___MemWrite32___b,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Op = 2e ------------------------------------------------------;Checked?
COpcodeSWR		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x03,0x4e
.rs				db	0x00,0xb2
.rt				db	0x00,0xff,0x56
.func			db	f___MemWriteR___b,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- Op = 32 ------------------------------------------------------;
COpcodeLWC2		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x03,0x4e
.rs				db	0x00,0xb2
.rt				db	0x00,0xff,0x96
.func			dd	___lwc2
;--------------------------------------------------------------------;
;----- Op = 3a ------------------------------------------------------;
COpcodeSWC2		db	0xb9
.imm			db	0x00,0x00,0x00,0x00,0x03,0x4e
.rs				db	0x00,0xb2
.rt				db	0x00,0xff,0x96
.func			dd	___swc2
;--------------------------------------------------------------------;
;----- Sp = 00 ------------------------------------------------------;Checked
COpcodeSLL		db	0x8b,0x46
.rt				db	0x00,0xc1,0xe0
.sa				db	0x00,0x89,0x46
.rd				db	0x00,0xeb,0x05,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Sp = 02 ------------------------------------------------------;Checked
COpcodeSRL		db	0x8b,0x46
.rt				db	0x00,0xc1,0xe8
.sa				db	0x00,0x89,0x46
.rd				db	0x00,0xeb,0x05,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Sp = 03 ------------------------------------------------------;Checked
COpcodeSRA		db	0x8b,0x46
.rt				db	0x00,0xc1,0xf8
.sa				db	0x00,0x89,0x46
.rd				db	0x00,0xeb,0x05,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Sp = 04 ------------------------------------------------------;Checked
COpcodeSLLV		db	0x8b,0x46
.rt				db	0x00,0x8b,0x4e
.rs				db	0x00,0xd3,0xe0,0x89,0x46
.rd				db	0x00,0xeb,0x03,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Sp = 06 ------------------------------------------------------;Checked
COpcodeSRLV		db	0x8b,0x46
.rt				db	0x00,0x8b,0x4e
.rs				db	0x00,0xd3,0xe8,0x89,0x46
.rd				db	0x00,0xeb,0x03,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Sp = 07 ------------------------------------------------------;Checked
COpcodeSRAV		db	0x8b,0x46
.rt				db	0x00,0x8b,0x4e
.rs				db	0x00,0xd3,0xf8,0x89,0x46
.rd				db	0x00,0xeb,0x03,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Sp = 08 -New-Interface-Main-----------------------------------;Checked
COpcodeJR		db	0xff,0x76
.rs				db	0x00,0xb8
.b_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
;--------------------------------------------------------------------;Opt?
;----- Sp = 08 -New-Interface-Jump-----------------------------------;Checked
COpcodeJR_j
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
				db	0xff,0x56
.do_timing		db	s___timing___b,0x58,0x25,0xff,0xff
				db	0x1f,0x00,0x8d,0x04,0x83,0xff,0xe0
				db	0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Sp = 09 -New-Interface-Main-----------------------------------;Checked
COpcodeJALR		db	0xff,0x76
.rs				db	0x00,0xb8
.b_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
;--------------------------------------------------------------------;Opt?
;----- Sp = 09 -New-Interface-Branch---------------------------------;Checked
COpcodeJALR_j	db	0xc7,0x46,r___RA___b
.ra				db	0x00,0x00,0x00,0x00,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
				db	0xff,0x56
.do_timing		db	s___timing___b,0x58,0x25,0xff,0xff
				db	0x1f,0x00,0x8d,0x04,0x83,0xff,0xe0
				db	0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Sp = 0c ------------------------------------------------------;Checked
COpcodeSYSCALL	db	0x8b,0x4e,r___A0___b,0xff,0x56
				db	o___syscall___b,0xeb,0x08
				db	0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- Sp = 0c ------------------------------------------------------;Checked
COpcodeBREAK	db	0x8b,0x4e,r___A0___b,0xff,0x56
				db	o___break,0xeb,0x08
				db	0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- Sp = 10 ------------------------------------------------------;Checked
COpcodeMFHI		db	0x8b,0x46,r___HI___b,0x89,0x46
.rd				db	0x00,0xeb,0x08
				db	0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Sp = 12 ------------------------------------------------------;Checked
COpcodeMFLO		db	0x8b,0x46,r___LO___b,0x89,0x46
.rd				db	0x00,0xeb,0x08
				db	0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Sp = 18 ------------------------------------------------------;Checked
COpcodeMULT		db	0x8b,0x46
.rs				db	0x00,0xf7,0x6e
.rt				db	0x00,0x89,0x46,r___LO___b
				db	0x89,0x56,r___HI___b,0xeb,0x02,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Sp = 19 ------------------------------------------------------;Checked
COpcodeMULTU	db	0x8b,0x46
.rs				db	0x00,0xf7,0x66
.rt				db	0x00,0x89,0x46,r___LO___b
				db	0x89,0x56,r___HI___b,0xeb,0x02,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Sp = 1a ------------------------------------------------------;
COpcodeDIV		db	0x8b,0x4e
.rt				db	0x00,0x85,0xc9,0x74,0x09,0x8b,0x46
.rs				db	0x00,0x99,0xff,0x56
				db	o___div___b,0x90,0x90
;--------------------------------------------------------------------;
;----- Sp = 1b ------------------------------------------------------;
COpcodeDIVU		db	0x8b,0x4e
.rt				db	0x00,0x85,0xc9,0x74,0x09,0x8b,0x46
.rs				db	0x00,0x33,0xd2,0xff,0x56
				db	o___divu___b,0x90
;--------------------------------------------------------------------;
;----- Sp = 20 ------------------------------------------------------;Checked
COpcodeADD		db	0x8b,0x46
.rs				db	0x00,0x03,0x46
.rt				db	0x00,0x89,0x46
.rd				db	0x00,0xeb,0x05,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Sp = 21 ------------------------------------------------------;Checked
COpcodeADDU		db	0x8b,0x46
.rs				db	0x00,0x03,0x46
.rt				db	0x00,0x89,0x46
.rd				db	0x00,0xeb,0x05,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Sp = 22 ------------------------------------------------------;Checked
COpcodeSUB		db	0x8b,0x46
.rs				db	0x00,0x2b,0x46
.rt				db	0x00,0x89,0x46
.rd				db	0x00,0xeb,0x05,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Sp = 23 ------------------------------------------------------;Checked
COpcodeSUBU		db	0x8b,0x46
.rs				db	0x00,0x2b,0x46
.rt				db	0x00,0x89,0x46
.rd				db	0x00,0xeb,0x05,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Sp = 24 ------------------------------------------------------;Checked
COpcodeAND		db	0x8b,0x46
.rs				db	0x00,0x23,0x46
.rt				db	0x00,0x89,0x46
.rd				db	0x00,0xeb,0x05,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Sp = 25 ------------------------------------------------------;Checked
COpcodeOR		db	0x8b,0x46
.rs				db	0x00,0x0b,0x46
.rt				db	0x00,0x89,0x46
.rd				db	0x00,0xeb,0x05,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Sp = 26 ------------------------------------------------------;
COpcodeXOR		db	0x8b,0x46
.rs				db	0x00,0x33,0x46
.rt				db	0x00,0x89,0x46
.rd				db	0x00,0xeb,0x05,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- Sp = 27 ------------------------------------------------------;Checked
COpcodeNOR		db	0x8b,0x46
.rs				db	0x00,0x0b,0x46
.rt				db	0x00,0xf7,0xd0,0x89,0x46
.rd				db	0x00,0xeb,0x03,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Sp = 2a ------------------------------------------------------;Checked
COpcodeSLT		db	0x33,0xd2,0x8b,0x46
.rs				db	0x00,0x3b,0x46,
.rt				db	0x00,0x7d,0x01,0x42,0x89,0x56
.rd				db	0x00,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Sp = 2b ------------------------------------------------------;Checked
COpcodeSLTU		db	0x33,0xd2,0x8b,0x46
.rs				db	0x00,0x3b,0x46,
.rt				db	0x00,0x73,0x01,0x42,0x89,0x56
.rd				db	0x00,0x90,0x90
;--------------------------------------------------------------------;Opt
;----- Bc = 00 -New-Interface-Main-----------------------------------;Checked
COpcodeBLTZ		db	0x8b,0x46
.rs				db	0x00,0x83,0xf8
				db	0x00,0x7d,0x08,0xb8
.b_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
;--------------------------------------------------------------------;Opt?
;----- Bc = 00 -New-Interface-Branch---------------------------------;Checked
COpcodeBLTZ_b
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
				db	0xff,0x56
.do_timing		db	s___timing___b,0xb8
.t_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Bc = 01 -New-Interface-Main-----------------------------------;Checked
COpcodeBGEZ		db	0x8b,0x46
.rs				db	0x00,0x83,0xf8
				db	0x00,0x7c,0x08,0xb8
.b_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
;--------------------------------------------------------------------;Opt?
;----- Bc = 01 -New-Interface-Branch---------------------------------;Checked
COpcodeBGEZ_b
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
				db	0xff,0x56
.do_timing		db	s___timing___b,0xb8
.t_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;Opt?
;----- Bc = 10 -New-Interface-Main-----------------------------------;
COpcodeBLTZAL	db	0x8b,0x46
.rs				db	0x00,0x83,0xf8
				db	0x00,0xb8
.b_addr			db	0x00,0x00,0x00,0x00,0xff,0xd0,0x90,0x90,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
;--------------------------------------------------------------------;
;----- Bc = 10 -New-Interface-Branch---------------------------------;
COpcodeBLTZAL_b	db	0xc7,0x46,r___RA___b
.ra				db	0x00,0x00,0x00,0x00,0x7c,0x01,0xc3
				db	0x58,0x90,0x90,0x90,0x90,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
				db	0xff,0x56
.do_timing		db	s___timing___b,0xb8
.t_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- Bc = 11 -New-Interface-Main-----------------------------------;
COpcodeBGEZAL	db	0x8b,0x46
.rs				db	0x00,0x83,0xf8
				db	0x00,0xb8
.b_addr			db	0x00,0x00,0x00,0x00,0xff,0xd0,0x90,0x90,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
;--------------------------------------------------------------------;
;----- Bc = 11 -New-Interface-Branch---------------------------------;
COpcodeBGEZAL_b	db	0xc7,0x46,r___RA___b
.ra				db	0x00,0x00,0x00,0x00,0x7d,0x01,0xc3
				db	0x58,0x90,0x90,0x90,0x90,0x90
.placeOpcode	dd	0xffffffff,0xffffffff,0xffffffff,0xffffffff
				db	0xff,0x56
.do_timing		db	s___timing___b,0xb8
.t_addr			db	0x00,0x00,0x00,0x00,0xff,0xe0
				db	0x90,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C0 = 00 ------------------------------------------------------;
COpcodeMFC0		db	0xb2
.rd				db	0x00,0xff,0x96
.func			dd	___mfc0
				db	0x89,0x46
.rt				db	0x00,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C0 = 04 ------------------------------------------------------;
COpcodeMTC0		db	0x8b,0x46
.rt				db	0x00,0xb2
.rd				db	0x00,0xff,0x96
.func			dd	___mtc0
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 00 ------------------------------------------------------;
COpcodeMFC2		db	0xb2
.rd				db	0x00,0xff,0x96
.func			dd	___mfc2
				db	0x89,0x46
.rt				db	0x00,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 02 ------------------------------------------------------;
COpcodeCFC2		db	0xb2
.rd				db	0x00,0xff,0x96
.func			dd	___cfc2
				db	0x89,0x46
.rt				db	0x00,0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 04 ------------------------------------------------------;
COpcodeMTC2		db	0x8b,0x46
.rt				db	0x00,0xb2
.rd				db	0x00,0xff,0x96
.func			dd	___mtc2
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 06 ------------------------------------------------------;
COpcodeCTC2		db	0x8b,0x46
.rt				db	0x00,0xb2
.rd				db	0x00,0xff,0x96
.func			dd	___ctc2
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 01 ------------------------------------------------------;
COpcodeRTPS		db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___RTPS
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 06 ------------------------------------------------------;
COpcodeNCLIP	db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___NCLIP
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 10 ------------------------------------------------------;
COpcodeDPCS		db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___DPCS
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 12 ------------------------------------------------------;
COpcodeMVMVA	db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___MVMVA
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 13 ------------------------------------------------------;
COpcodeNCDS		db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___NCDS
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 16 ------------------------------------------------------;
COpcodeNCDT		db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___NCDT
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 1b ------------------------------------------------------;
COpcodeNCCS		db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___NCCS
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 28 ------------------------------------------------------;
COpcodeSQR		db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___SQR
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 29 ------------------------------------------------------;
COpcodeDCPL		db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___DCPL
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 2d ------------------------------------------------------;
COpcodeAVSZ3	db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___AVSZ3
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 2e ------------------------------------------------------;
COpcodeAVSZ4	db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___AVSZ4
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 30 ------------------------------------------------------;
COpcodeRTPT		db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___RTPT
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 3d ------------------------------------------------------;
COpcodeGPF		db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___GPF
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 3e ------------------------------------------------------;
COpcodeGPL		db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___GPL
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;----- C2 = 3f ------------------------------------------------------;
COpcodeNCCT		db	0xba
.data			db	0x00,0x00,0x00,0x00,0xff,0x96
.func			dd	___NCCT
				db	0x90,0x90,0x90,0x90,0x90
;--------------------------------------------------------------------;
;--------------------------------------------------------------------;
__Opcodes:
	dd	__Opcode_00,__Opcode_01,__Opcode_02,__Opcode_03
	dd	__Opcode_04,__Opcode_05,__Opcode_06,__Opcode_07
	dd	__Opcode_08,__Opcode_09,__Opcode_0a,__Opcode_0b
	dd	__Opcode_0c,__Opcode_0d,__Opcode_0e,__Opcode_0f
	dd	__Opcode_10,__UnsupOp  ,__Opcode_12,__UnsupOp
	dd	__UnsupOp  ,__UnsupOp  ,__UnsupOp  ,__UnsupOp
	dd	__UnsupOp  ,__UnsupOp  ,__UnsupOp  ,__UnsupOp
	dd	__UnsupOp  ,__UnsupOp  ,__UnsupOp  ,__UnsupOp
	dd	__Opcode_20,__Opcode_21,__Opcode_22,__Opcode_23
	dd	__Opcode_24,__Opcode_25,__Opcode_26,__UnsupOp
	dd	__Opcode_28,__Opcode_29,__Opcode_2a,__Opcode_2b
	dd	__UnsupOp  ,__UnsupOp  ,__Opcode_2e,__UnsupOp
	dd	__UnsupOp  ,__UnsupOp  ,__Opcode_32,__UnsupOp
	dd	__UnsupOp  ,__UnsupOp  ,__UnsupOp  ,__UnsupOp
	dd	__UnsupOp  ,__UnsupOp  ,__Opcode_3a,__UnsupOp
	dd	__UnsupOp  ,__UnsupOp  ,__UnsupOp  ,__UnsupOp
__Specials:
	dd	__Special_00,__UnsupSp   ,__Special_02,__Special_03
	dd	__Special_04,__UnsupSp   ,__Special_06,__Special_07
	dd	__Special_08,__Special_09,__UnsupSp   ,__UnsupSp
	dd	__Special_0c,__Special_0d,__UnsupSp   ,__UnsupSp
	dd	__Special_10,__UnsupSp   ,__Special_12,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp   ,__UnsupSp   ,__UnsupSp
	dd	__Special_18,__Special_19,__Special_1a,__Special_1b
	dd	__UnsupSp   ,__UnsupSp   ,__UnsupSp   ,__UnsupSp
	dd	__Special_20,__Special_21,__Special_22,__Special_23
	dd	__Special_24,__Special_25,__Special_26,__Special_27
	dd	__UnsupSp   ,__UnsupSp   ,__Special_2a,__Special_2b
	dd	__UnsupSp   ,__UnsupSp   ,__UnsupSp   ,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp   ,__UnsupSp   ,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp   ,__UnsupSp   ,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp   ,__UnsupSp   ,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp   ,__UnsupSp   ,__UnsupSp
__BConds:
	dd	__BCond_00,__BCond_01,__UnsupBc ,__UnsupBc
	dd	__UnsupBc ,__UnsupBc ,__UnsupBc ,__UnsupBc
	dd	__UnsupBc ,__UnsupBc ,__UnsupBc ,__UnsupBc
	dd	__UnsupBc ,__UnsupBc ,__UnsupBc ,__UnsupBc
	dd	__UnsupBc ,__BCond_11,__UnsupBc ,__UnsupBc
	dd	__UnsupBc ,__UnsupBc ,__UnsupBc ,__UnsupBc
	dd	__UnsupBc ,__UnsupBc ,__UnsupBc ,__UnsupBc
	dd	__UnsupBc ,__UnsupBc ,__UnsupBc ,__UnsupBc
__Cop0s:
	dd	__Cop0Ext,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
__Cop0Exts:
	dd	__Cop0Ext_00,__UnsupSp,__UnsupSp,__UnsupSp
	dd	__Cop0Ext_04,__UnsupSp,__UnsupSp,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp,__UnsupSp,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp,__UnsupSp,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp,__UnsupSp,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp,__UnsupSp,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp,__UnsupSp,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp,__UnsupSp,__UnsupSp
__Cop2s:
	dd	__Cop2Ext,__Cop2_01,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__Cop2_06,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__Cop2_10,__UnsupOp,__Cop2_12,__Cop2_13
	dd	__UnsupOp,__UnsupOp,__Cop2_16,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__Cop2_1b
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__Cop2_28,__Cop2_29,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__Cop2_2d,__Cop2_2e,__UnsupOp
	dd	__Cop2_30,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__UnsupOp,__UnsupOp,__UnsupOp
	dd	__UnsupOp,__Cop2_3d,__Cop2_3e,__Cop2_3f
__Cop2Exts:
	dd	__Cop2Ext_00,__UnsupSp,__Cop2Ext_02,__UnsupSp
	dd	__Cop2Ext_04,__UnsupSp,__Cop2Ext_06,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp,__UnsupSp   ,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp,__UnsupSp   ,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp,__UnsupSp   ,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp,__UnsupSp   ,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp,__UnsupSp   ,__UnsupSp
	dd	__UnsupSp   ,__UnsupSp,__UnsupSp   ,__UnsupSp
;------------------------------------------------------------------------------;
DynarecMemoryAllocError	db	"[  CPU  ]Error: Cann't allocate Memory for DynaRec",10,0
BranchMemoryAllocError	db	"[  CPU  ]Error: Cann't allocate Memory for Branch",10,0
ErrorUnsupOpInst		db	"[  CPU  ]Error: Unsupported Op Instruction!!!",10,0
ErrorUnsupSpInst		db	"[  CPU  ]Error: Unsupported Sp Instruction!!!",10,0
ErrorUnsupBcInst		db	"[  CPU  ]Error: Unsupported Bc Instruction!!!",10,0
LOG_decode				db	"Decode Block from [ %X ] ra=[%x]",10,0
LOG_UKC					db	"Unsupported Call to Kernel Memory [%x]->[%x]",10,0
LOG_break				db	"ExecuteBreak",10,0
RError		db	"esi==%x...edi==%x...ebx==%x...%x.%x.",0
;MMM___		db	"(%x):ebx=%x,esi=%x,edi=%x,(%x)",10,0
MMM2		db	"(%x):ebx=%x,esi=%x,edi=%x,(%x)",10
			db	"Opcode = %x",10
			db	"Regs:",10
            db	"|%x||%x||%x||%x||%x||%x||%x||%x|",10
            db  "|%x||%x||%x||%x||%x||%x||%x||%x|",10
            db  "|%x||%x||%x||%x||%x||%x||%x||%x|",10
            db  "|%x||%x||%x||%x||%x||%x||%x||%x|",10,10,0
JAL_LOG		db	"JAL -> [%x]",10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
NextFreeBranch		resd	1
