;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%define ___LOG___ENABLE___
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
CEXTERN RbPSe_SysMessage
CEXTERN RbPSe_SysPrintf
CEXTERN	RbPSe_ReadIntSettings
;------------------------------------------------------------------------------;
;======import======
;Interface:
;		[Hook___HardWare32___]		0x1f801080 - 0x1f8010ff
;Run--Time:
;		[Exec___Interrupt]
;BIOS-Call: (None)
;======export======
;Interface:
;		[Hook___dma___]
;Run--Time:	(None)
;BIOS-Call:	(None)
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	INSTALL_HOOK Hook___dma___,Hook___dma___
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
%ifdef ___LOG___ENABLE___
	mov eax,[RbPSeStartDataAddr]
    push dword ConfigSectionLogBuffer
    push dword 0
    push dword ConfigSectionLogNames
    push dword ConfigSectionLog
    push dword ConfigFileName
	push dword [eax+RbPSeStartStruc.ProfileDir]
	call RbPSe_ReadIntSettings
	add esp,0x18
;---Begin---Log---Channel---???---
	push esi
    push edi
	xor edx,edx
.CheckLogChannels:
	cmp dword [ConfigSectionLogBuffer.LogCh0+edx],byte 0
	je .CheckLogNext
	lea esi,[LogChannel0write+edx*4]
	lea edi,[DefChannel0write+edx*4]
    mov ecx,0x04
    rep movsd
	lea esi,[LogChannel0read+edx*4]
	lea edi,[DefChannel0read+edx*4]
	mov ecx,0x04
	rep movsd
.CheckLogNext:
    add edx,0x04
    cmp edx,0x1C
    jl .CheckLogChannels
	pop edi
    pop esi
;---End---Log---Channel---???---
%endif
;---Install HardWare Handlers
	mov ecx,0x00001080
.___loop___:
	mov eax,[DefChannel0write + ecx - 0x00001080]
	mov edx,[DefChannel0read + ecx - 0x00001080]
	rb_call ___rb___Hook___HardWare32___
	add ecx,0x04
	cmp ecx,0x00001100
	jl .___loop___
;---End
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
Hook___dma___:;[in]eax-write;[in]edx-read;[in]ecx-channel
	mov [DMAHooks+ecx*4],eax
	mov eax,[DMAChannelData+ecx*4]
	ret
;==============================================================================;
FuncWrite80:;//MDECin - Write - Address
	mov [Channel0],eax
	ret
;------------------------------------------------------------------------------;
FuncRead80:;//MDECin - Read - Address
	mov eax,[Channel0]
	ret
;------------------------------------------------------------------------------;
FuncWrite84:;//MDECin - Write - Block
	mov [Channel0+4],eax
	ret
;------------------------------------------------------------------------------;
FuncRead84:;//MDECin - Read - Block
	mov eax,[Channel0+4]
	ret
;------------------------------------------------------------------------------;
FuncWrite88:;//MDECin - Write - Control
	mov [Channel0+8],eax
	test eax,0x01000000
	jnz .begin
	ret
.begin:
	call [DMAHooks+0*4]
	and dword [Channel0+8],0xfeffffff
	mov eax,[DMAControl+4]
	and eax,0x00010000
	jz .not_dma_int
	shl eax,0x08
	or [DMAControl+4],eax
	mov edx,0x08
	call [dword esi+___RequestInterrupt]
.not_dma_int:
	ret
;------------------------------------------------------------------------------;
FuncRead88:;//MDECin - Read - Control
	mov eax,[Channel0+8]
	ret
;==============================================================================;
FuncWrite90:;//MDECout - Write - Address
	mov [Channel1],eax
	ret
;------------------------------------------------------------------------------;
FuncRead90:;//MDECout - Read - Address
	mov eax,[Channel1]
	ret
;------------------------------------------------------------------------------;
FuncWrite94:;//MDECout - Write - Block
	mov [Channel1+4],eax
	ret
;------------------------------------------------------------------------------;
FuncRead94:;//MDECout - Read - Block
	mov eax,[Channel1+4]
	ret
;------------------------------------------------------------------------------;
FuncWrite98:;//MDECout - Write - Control
	mov [Channel1+8],eax
	test eax,0x01000000
	jnz .begin
	ret
.begin:
	call [DMAHooks+1*4]
	and dword [Channel1+8],0xfeffffff
	mov eax,[DMAControl+4]
	and eax,0x00020000
	jz .not_dma_int
	shl eax,0x08
	or [DMAControl+4],eax
	mov edx,0x08
	call [dword esi+___RequestInterrupt]
.not_dma_int:
	ret
;------------------------------------------------------------------------------;
FuncRead98:;//MDECout - Read - Control
	mov eax,[Channel1+8]
	ret
;==============================================================================;
FuncWriteA0:;//GPU - Write - Address
	mov [Channel2],eax
	ret
;------------------------------------------------------------------------------;
FuncReadA0:;//GPU - Read - Address
	mov eax,[Channel2]
	ret
;------------------------------------------------------------------------------;
FuncWriteA4:;//GPU - Write - Block
	mov [Channel2+4],eax
	ret
;------------------------------------------------------------------------------;
FuncReadA4:;//GPU - Read - Block
	mov eax,[Channel2+4]
	ret
;------------------------------------------------------------------------------;
FuncWriteA8:;//GPU - Write - Control
	mov [Channel2+8],eax
	test eax,0x01000000
	jnz .begin
	ret
.begin:
	call [DMAHooks+2*4]
	and dword [Channel2+8],0xfeffffff
	mov eax,[DMAControl+4]
	and eax,0x00040000
	jz .not_dma_int
	shl eax,0x08
	or [DMAControl+4],eax
	mov edx,0x08
	call [dword esi+___RequestInterrupt]
.not_dma_int:
	ret
;------------------------------------------------------------------------------;
FuncReadA8:;//GPU - Read - Control
	mov eax,[Channel2+8]
	ret
;==============================================================================;
FuncWriteB0:;//CDR - Write - Address
	mov [Channel3],eax
	ret
;------------------------------------------------------------------------------;
FuncReadB0:;//CDR - Read - Address
	mov eax,[Channel3]
	ret
;------------------------------------------------------------------------------;
FuncWriteB4:;//CDR - Write - Block
	mov [Channel3+4],eax
	ret
;------------------------------------------------------------------------------;
FuncReadB4:;//CDR - Read - Block
	mov eax,[Channel3+4]
	ret
;------------------------------------------------------------------------------;
FuncWriteB8:;//CDR - Write - Control
    mov [Channel3+8],eax
    test eax,0x01000000
    jnz .begin
    ret
.begin:
    call [DMAHooks+3*4]
    and dword [Channel3+8],0xfeffffff
    mov eax,[DMAControl+4]
    and eax,0x00080000
    jz .not_dma_int
    shl eax,0x08
    or [DMAControl+4],eax
    mov edx,0x08
    call [dword esi+___RequestInterrupt]
.not_dma_int:
	ret
;------------------------------------------------------------------------------;
FuncReadB8:;//CDR - Read - Control
	mov eax,[Channel3+8]
	ret
;==============================================================================;
FuncWriteC0:;//SPU - Write - Address
	mov [Channel4],eax
	ret
;------------------------------------------------------------------------------;
FuncReadC0:;//SPU - Read - Address
	mov eax,[Channel4]
	ret
;------------------------------------------------------------------------------;
FuncWriteC4:;//SPU - Write - Block
	mov [Channel4+4],eax
	ret
;------------------------------------------------------------------------------;
FuncReadC4:;//SPU - Read - Block
	mov eax,[Channel4+4]
	ret
;------------------------------------------------------------------------------;
FuncWriteC8:;//SPU - Write - Control
	mov [Channel4+8],eax
	test eax,0x01000000
	jnz .begin
	ret
.begin:
	call [DMAHooks+4*4]
	and dword [Channel4+8],0xfeffffff
	mov eax,[DMAControl+4]
	and eax,0x00100000
	jz .not_dma_int
	shl eax,0x08
	or [DMAControl+4],eax
	mov edx,0x08
	call [dword esi+___RequestInterrupt]
.not_dma_int:
	ret
;------------------------------------------------------------------------------;
FuncReadC8:;//SPU - Read - Control
	mov eax,[Channel4+8]
	ret
;==============================================================================;
FuncWriteD0:;//PIO - Write - Address
	mov [Channel5],eax
	ret
;------------------------------------------------------------------------------;
FuncReadD0:;//PIO - Read - Address
	mov eax,[Channel5]
	ret
;------------------------------------------------------------------------------;
FuncWriteD4:;//PIO - Write - Block
	mov [Channel5+4],eax
	ret
;------------------------------------------------------------------------------;
FuncReadD4:;//PIO - Read - Block
	mov eax,[Channel5+4]
	ret
;------------------------------------------------------------------------------;
FuncWriteD8:;//PIO - Write - Control
	mov [Channel5+8],eax
	test eax,0x01000000
	jnz .begin
	ret
.begin:
	call [DMAHooks+5*4]
	and dword [Channel5+8],0xfeffffff
	mov eax,[DMAControl+4]
	and eax,0x00200000
	jz .not_dma_int
	shl eax,0x08
	or [DMAControl+4],eax
	mov edx,0x08
	call [dword esi+___RequestInterrupt]
.not_dma_int:
	ret
;------------------------------------------------------------------------------;
FuncReadD8:;//PIO - Read - Control
	mov eax,[Channel5+8]
	ret
;==============================================================================;
FuncWriteE0:;//OTC - Write - Address
	mov [Channel6],eax
	ret
;------------------------------------------------------------------------------;
FuncReadE0:;//OTC - Read - Address
	mov eax,[Channel6]
	ret
;------------------------------------------------------------------------------;
FuncWriteE4:;//OTC - Write - Block
	mov [Channel6+4],eax
	ret
;------------------------------------------------------------------------------;
FuncReadE4:;//OTC - Read - Block
	mov eax,[Channel6+4]
	ret
;------------------------------------------------------------------------------;
FuncWriteE8:;//OTC - Write - Control
	mov [Channel6+8],eax
	test eax,0x01000000
	jnz .begin
	ret
.begin:
;;;---
	mov edx,[Channel6]
	mov ecx,[Channel6+4]
;;;             pusha
;;;             mov ebx,eax
;;;             mov eax,6
;;;             call execDMA
;;;             popa
	and edx,0x001fffff
	mov eax,[RbPSeDataData+RbPSeDataStruc.Data___Memory___]
.loop:
	sub edx,0x04
	mov [eax+edx+4],edx
	loop .loop
	mov dword [eax+edx+4],0x00ffffff
;;;---
	and dword [Channel6+8],0xfeffffff
	mov eax,[DMAControl+4]
	and eax,0x00400000
	jz .not_dma_int
	shl eax,0x08
	or [DMAControl+4],eax
	mov edx,0x08
	call [dword esi+___RequestInterrupt]
.not_dma_int:
	ret
;------------------------------------------------------------------------------;
FuncReadE8:;//OTC - Read - Control
	mov eax,[Channel6+8]
    ret
;==============================================================================;
FuncWriteF0:
	mov [DMAControl],eax
	ret
;------------------------------------------------------------------------------;
FuncReadF0:
	mov eax,[DMAControl]
	ret
;------------------------------------------------------------------------------;
FuncWriteF4:
	xor [DMAControl+4],eax
	and [DMAControl+4],dword 0xff000000
	and eax,0x00ffffff
	or [DMAControl+4],eax
	ret
;------------------------------------------------------------------------------;
FuncReadF4:
	mov eax,[DMAControl+4]
	ret
;==============================================================================;
NullDMAHook:
	ret
;==============================================================================;
%ifdef ___LOG___ENABLE___
;==============================================================================;
FuncWriteA0_log:;//GPU - Write - Address//Log
	mov [Channel2],eax
	ret
;------------------------------------------------------------------------------;
FuncReadA0_log:;//GPU - Read - Address//Log
	mov eax,[Channel2]
	ret
;------------------------------------------------------------------------------;
FuncWriteA4_log:;//GPU - Write - Block//Log
	mov [Channel2+4],eax
	ret
;------------------------------------------------------------------------------;
FuncReadA4_log:;//GPU - Read - Block//Log
	mov eax,[Channel2+4]
	ret
;------------------------------------------------------------------------------;
FuncWriteA8_log:;//GPU - Write - Control//Log
;//
	cmp dword [ConfigSectionLogBuffer.Ch2Wr8], byte 0
	je .nlogwr8
;//
	push eax
    	push dword 0x1f8010A8
		push eax
		push dword 0x00
		push dword LogDmaWrite
		rb_call ___rb___Log___Printf___
        add esp,0x10
    pop eax
;//
.nlogwr8:
;//
	mov [Channel2+8],eax
	test eax,0x01000000
	jnz .begin
	ret
.begin:
;//
	cmp dword [ConfigSectionLogBuffer.Ch2Exec], byte 0
    je .nlogexec
;//
	push eax
		push dword [Channel2+8]
		push dword [Channel2+4]
		push dword [Channel2]
		push dword 0x02
        push dword 0x00
		push dword ExecLogStr
		rb_call ___rb___Log___Printf___
		add esp,0x18
	pop eax
;//
.nlogexec:
;//
    call [DMAHooks+2*4]
    and dword [Channel2+8],0xfeffffff
    mov eax,[DMAControl+4]
    and eax,0x00040000
    jz .not_dma_int
    shl eax,0x08
    or [DMAControl+4],eax
    mov edx,0x08
    call [dword esi+___RequestInterrupt]
.not_dma_int:
    ret
;------------------------------------------------------------------------------;
FuncReadA8_log:;//GPU - Read - Control//Log
	mov eax,[Channel2+8]
	ret
;==============================================================================;
FuncWriteB0_log:;//CDR - Write - Address//Log
	mov [Channel3],eax
	ret
;------------------------------------------------------------------------------;
FuncReadB0_log:;//CDR - Read - Address//Log
	mov eax,[Channel3]
	ret
;------------------------------------------------------------------------------;
FuncWriteB4_log:;//CDR - Write - Block//Log
	mov [Channel3+4],eax
	ret
;------------------------------------------------------------------------------;
FuncReadB4_log:;//CDR - Read - Block//Log
	mov eax,[Channel3+4]
	ret
;------------------------------------------------------------------------------;
FuncWriteB8_log:;//CDR - Write - Control//Log
	mov [Channel3+8],eax
	test eax,0x01000000
	jnz .begin
	ret
.begin:
	call [DMAHooks+3*4]
	and dword [Channel3+8],0xfeffffff
	mov eax,[DMAControl+4]
	and eax,0x00080000
	jz .not_dma_int
	shl eax,0x08
	or [DMAControl+4],eax
	mov edx,0x08
	call [dword esi+___RequestInterrupt]
.not_dma_int:
	ret
;------------------------------------------------------------------------------;
FuncReadB8_log:;//CDR - Read - Control//Log
	mov eax,[Channel3+8]
	ret
;==============================================================================;
FuncWriteC0_log:;//SPU - Write - Address//Log
	mov [Channel4],eax
	ret
;------------------------------------------------------------------------------;
FuncReadC0_log:;//SPU - Read - Address//Log
	mov eax,[Channel4]
	ret
;------------------------------------------------------------------------------;
FuncWriteC4_log:;//SPU - Write - Block//Log
	mov [Channel4+4],eax
	ret
;------------------------------------------------------------------------------;
FuncReadC4_log:;//SPU - Read - Block//Log
	mov eax,[Channel4+4]
	ret
;------------------------------------------------------------------------------;
FuncWriteC8_log:;//SPU - Write - Control//Log
;//
	cmp dword [ConfigSectionLogBuffer.Ch4Wr8], byte 0
	je .nlogwr8
;//
	push eax
		push dword 0x1f8010C8
		push eax
		push dword 0x00
		push dword LogDmaWrite
		rb_call ___rb___Log___Printf___
		add esp,0x10
	pop eax
;//
.nlogwr8:
;//
	mov [Channel4+8],eax
	test eax,0x01000000
	jnz .begin
	ret
.begin:
;//
	cmp dword [ConfigSectionLogBuffer.Ch4Exec], byte 0
	je .nlogexec
;//
	push eax
		push dword [Channel4+8]
		push dword [Channel4+4]
		push dword [Channel4]
		push dword 0x04
		push dword 0x00
		push dword ExecLogStr
		rb_call ___rb___Log___Printf___
		add esp,0x18
	pop eax
;//
.nlogexec:
;//
	call [DMAHooks+4*4]
	and dword [Channel4+8],0xfeffffff
	mov eax,[DMAControl+4]
	and eax,0x00100000
	jz .not_dma_int
	shl eax,0x08
	or [DMAControl+4],eax
	mov edx,0x08
	call [dword esi+___RequestInterrupt]
.not_dma_int:
	ret
;------------------------------------------------------------------------------;
FuncReadC8_log:;//SPU - Read - Control//Log
	mov eax,[Channel4+8]
	ret
;==============================================================================;
%endif
;==============================================================================;
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
DefChannel0write	dd	FuncWrite80 ,FuncWrite84 ,FuncWrite88 ,0
DefChannel1write	dd	FuncWrite90 ,FuncWrite94 ,FuncWrite98 ,0
DefChannel2write	dd	FuncWriteA0 ,FuncWriteA4 ,FuncWriteA8 ,0
DefChannel3write	dd	FuncWriteB0 ,FuncWriteB4 ,FuncWriteB8 ,0
DefChannel4write	dd	FuncWriteC0 ,FuncWriteC4 ,FuncWriteC8 ,0
DefChannel5write	dd	FuncWriteD0 ,FuncWriteD4 ,FuncWriteD8 ,0
DefChannel6write	dd	FuncWriteE0 ,FuncWriteE4 ,FuncWriteE8 ,0
DefDMAwrite			dd	FuncWriteF0 ,FuncWriteF4 ,0           ,0
DefChannel0read		dd	FuncRead80  ,FuncRead84  ,FuncRead88  ,0
DefChannel1read		dd	FuncRead90  ,FuncRead94  ,FuncRead98  ,0
DefChannel2read		dd	FuncReadA0  ,FuncReadA4  ,FuncReadA8  ,0
DefChannel3read		dd	FuncReadB0  ,FuncReadB4  ,FuncReadB8  ,0
DefChannel4read		dd	FuncReadC0  ,FuncReadC4  ,FuncReadC8  ,0
DefChannel5read		dd	FuncReadD0  ,FuncReadD4  ,FuncReadD8  ,0
DefChannel6read		dd	FuncReadE0  ,FuncReadE4  ,FuncReadE8  ,0
DefDMAread			dd	FuncReadF0  ,FuncReadF4  ,0           ,0
DMAChannelData		dd	Channel0    ,Channel1    ,Channel2    ,Channel3
					dd	Channel4    ,Channel5    ,Channel6    ,0
%ifdef ___LOG___ENABLE___
LogChannel0write	dd	FuncWrite80 ,FuncWrite84 ,FuncWrite88 ,0
LogChannel1write	dd	FuncWrite90 ,FuncWrite94 ,FuncWrite98 ,0
LogChannel2write	dd	FuncWriteA0_log ,FuncWriteA4_log ,FuncWriteA8_log ,0
LogChannel3write	dd	FuncWriteB0_log ,FuncWriteB4_log ,FuncWriteB8_log ,0
LogChannel4write	dd	FuncWriteC0_log ,FuncWriteC4_log ,FuncWriteC8_log ,0
LogChannel5write	dd	FuncWriteD0 ,FuncWriteD4 ,FuncWriteD8 ,0
LogChannel6write	dd	FuncWriteE0 ,FuncWriteE4 ,FuncWriteE8 ,0
LogChannel0read		dd	FuncRead80  ,FuncRead84  ,FuncRead88  ,0
LogChannel1read		dd	FuncRead90  ,FuncRead94  ,FuncRead98  ,0
LogChannel2read		dd	FuncReadA0_log  ,FuncReadA4_log  ,FuncReadA8_log  ,0
LogChannel3read		dd	FuncReadB0_log  ,FuncReadB4_log  ,FuncReadB8_log  ,0
LogChannel4read		dd	FuncReadC0_log  ,FuncReadC4_log  ,FuncReadC8_log  ,0
LogChannel5read		dd	FuncReadD0  ,FuncReadD4  ,FuncReadD8  ,0
LogChannel6read		dd	FuncReadE0  ,FuncReadE4  ,FuncReadE8  ,0
ConfigSectionLogNames	dd	LogChannel0 ,LogChannel1 ,LogChannel2 ,LogChannel3
						dd	LogChannel4 ,LogChannel5 ,LogChannel6
						dd	Channel0exec,Channel1exec,Channel2exec,Channel3exec
						dd	Channel4exec,Channel5exec,Channel6exec
						dd	Channel2write0,Channel2read0,Channel2write4
						dd	Channel2read4,Channel2write8,Channel2read8,0

%endif
ConfigFileName		db	"s_dma.cfg",0
%ifdef ___LOG___ENABLE___
LogChannel0			db	"LogChannel0",0
LogChannel1			db	"LogChannel1",0
LogChannel2			db	"LogChannel2",0
LogChannel3			db	"LogChannel3",0
LogChannel4			db	"LogChannel4",0
LogChannel5			db	"LogChannel5",0
LogChannel6			db	"LogChannel6",0
Channel0exec		db	"Channel0exec",0
Channel1exec		db	"Channel1exec",0
Channel2exec		db	"Channel2exec",0
Channel3exec		db	"Channel3exec",0
Channel4exec		db	"Channel4exec",0
Channel5exec		db	"Channel5exec",0
Channel6exec		db	"Channel6exec",0
Channel0write0		db	"Channel0write0",0
Channel0read0		db	"Channel0read0",0
Channel0write4		db	"Channel0write4",0
Channel0read4		db	"Channel0read4",0
Channel0write8		db	"Channel0write8",0
Channel0read8		db	"Channel0read8",0
Channel1write0		db	"Channel1write0",0
Channel1read0		db	"Channel1read0",0
Channel1write4		db	"Channel1write4",0
Channel1read4		db	"Channel1read4",0
Channel1write8		db	"Channel1write8",0
Channel1read8		db	"Channel1read8",0
Channel2write0		db	"Channel2write0",0
Channel2read0		db	"Channel2read0",0
Channel2write4		db	"Channel2write4",0
Channel2read4		db	"Channel2read4",0
Channel2write8		db	"Channel2write8",0
Channel2read8		db	"Channel2read8",0
Channel3write0		db	"Channel3write0",0
Channel3read0		db	"Channel3read0",0
Channel3write4		db	"Channel3write4",0
Channel3read4		db	"Channel3read4",0
Channel3write8		db	"Channel3write8",0
Channel3read8		db	"Channel3read8",0
Channel4write0		db	"Channel4write0",0
Channel4read0		db	"Channel4read0",0
Channel4write4		db	"Channel4write4",0
Channel4read4		db	"Channel4read4",0
Channel4write8		db	"Channel4write8",0
Channel4read8		db	"Channel4read8",0
Channel5write0		db	"Channel5write0",0
Channel5read0		db	"Channel5read0",0
Channel5write4		db	"Channel5write4",0
Channel5read4		db	"Channel5read4",0
Channel5write8		db	"Channel5write8",0
Channel5read8		db	"Channel5read8",0
Channel6write0		db	"Channel6write0",0
Channel6read0		db	"Channel6read0",0
Channel6write4		db	"Channel6write4",0
Channel6read4		db	"Channel6read4",0
Channel6write8		db	"Channel6write8",0
Channel6read8		db	"Channel6read8",0
ConfigSectionLog	db	"log",0
LogDmaWrite			db	"[  DMA  ][ %x ]  Write Word  [ %x ]  --->>>  [ %x ]",10,0
LogDmaRead			db	"[  DMA  ][ %x ]   Read Word  [ %x ]  <<<---  [ %x ]",10,0
ExecLogStr			db	"[  DMA  ][ %x ]  Execute  Channel  %1i  ( %x )( %x )( %x )",10,0
%endif
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
DMAHooks		resd	8		;//align(DMA Channels Count)
Channel0		resd	4		;//align(3)
Channel1		resd	4		;//align(3)
Channel2		resd	4		;//align(3)
Channel3		resd	4		;//align(3)
Channel4		resd	4		;//align(3)
Channel5		resd	4		;//align(3)
Channel6		resd	4		;//align(3)
DMAControl		resd	4		;//align(2)
;------------------------------------------------------------------------------;
%ifdef ___LOG___ENABLE___
ConfigSectionLogBuffer
.LogCh0			resd	1
.LogCh1			resd	1
.LogCh2			resd	1
.LogCh3			resd	1
.LogCh4			resd	1
.LogCh5			resd	1
.LogCh6			resd	1
.Ch0Exec		resd	1
.Ch1Exec		resd	1
.Ch2Exec		resd	1
.Ch3Exec		resd	1
.Ch4Exec		resd	1
.Ch5Exec		resd	1
.Ch6Exec		resd	1
.Ch2Wr0			resd	1
.Ch2Rd0			resd	1
.Ch2Wr4			resd	1
.Ch2Rd4			resd	1
.Ch2Wr8			resd	1
.Ch2Rd8			resd	1
.Ch3Wr0			resd	1
.Ch3Rd0			resd	1
.Ch3Wr4			resd	1
.Ch3Rd4			resd	1
.Ch3Wr8			resd	1
.Ch3Rd8			resd	1
.Ch4Wr0			resd	1
.Ch4Rd0			resd	1
.Ch4Wr4			resd	1
.Ch4Rd4			resd	1
.Ch4Wr8			resd	1
.Ch4Rd8			resd	1
%endif

