;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
CEXTERN RbPSe_fopen
CEXTERN RbPSe_fclose
CEXTERN RbPSe_fread
CEXTERN RbPSe_SysMessage
CEXTERN RbPSe_SysPrintf
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
;--SetMem = 8Mb--
;        mov ecx,0x00001060
;        mov eax,0x00000b88
;       q_call HardWareWrite32
;---Copy System Tables
;	push ebx
;	mov ebx,f0_table
;.f0_loop:
;	cmp dword [ebx],dword 0x00000000
;	jz .f0_end
;	mov eax,[ebx]
;	mov ecx,[ebx+4]
;	mov edx,[ebx+8]
;	call MemWriteBlockBase
;	add ebx,0x10
;	jmp .f0_loop
;.f0_end:
;	pop ebx
;--SysEnq--(root1)--
;	mov dword [RegRegister+___A0]	,dword	0x00000001
;	mov dword [RegRegister+___A1]	,dword	0x00006d68
;        hle_call C0,0x02
;--SysEnq--(root2)--
;        mov ecx,0x01
;        mov edx,0x00006d78
;        hle_call C0,0x02
;--SysEnq--(last)--
;	mov dword [RegRegister+___A0]   ,dword  0x00000003
;	mov dword [RegRegister+___A1]   ,dword  0x00006d98
;	hle_call C0,0x02
;--ResetHook
;        hle_call B0,0x18
;--Exit--Critical--Section--
;	mov ecx,0x02
;	call ExecuteSystemCall

;//	push esi
;//	push edi
;//	mov esi,[RbPSeMainData+RbPSeMainStruc.Data___Get___Main___]
;//	mov edi,[RbPSeMainData+RbPSeMainStruc.Data___Get___Base___]
	mov edx,[esp+0x04]
	cmp [edx+RbPSeStartStruc.SourceType],dword 0x00000002
	jnz .exit
	mov eax,[edx+RbPSeStartStruc.SourceName]
	call ExecutePSXExe
	mov edx,[esp+0x04]
	mov [edx+RbPSeStartStruc.ExecAddr],eax
;//	pop edi
;//	pop esi
.exit:
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExecutePSXExe:;[in]eax - psxexe file;[out]eax - load addr
	mov [ExeFileName],eax
		push dword 0
		push eax
		push dword 0
		call RbPSe_fopen
		add esp,0x0c
	test eax,eax
	jnz .opened
		push dword [ExeFileName]
		push dword ExeOpenError
		call RbPSe_SysPrintf
		add esp,0x08
		xor eax,eax
		ret
.opened:
	mov [ExeFileHandle],eax
		push dword 0x800
		push dword ExecExeBuffer
		push dword [ExeFileHandle]
		call RbPSe_fread
		add esp,0x0c
	cmp eax,0x800
	je .headreaded
		push dword [ExeFileName]
		push dword ExeReadError
		call RbPSe_SysPrintf
		add esp,0x08
		xor eax,eax
		ret
.headreaded:
;---
	mov edx,[ExecExeBuffer+PSX_EXE_Header.pc0]		;entry addr
	and edx,0x001fffff
	push edx
;---
	push esi
	mov esi,[RbPSeDataData+RbPSeDataStruc.Data___Table___]
		mov eax,[ExecExeBuffer+PSX_EXE_Header.s_addr]	;sp
		mov [byte RegRegister+r___SP___b],eax
		mov edx,[ExecExeBuffer+PSX_EXE_Header.t_addr]	;text addr
		and edx,0x001fffff
		add edx,[RbPSeDataData+RbPSeDataStruc.Data___Memory___]
		mov eax,[ExecExeBuffer+PSX_EXE_Header.t_size]	;texe size
			push eax
			push edx					;
			push dword [ExeFileHandle]	;this must be doing by another way
			call RbPSe_fread				;
			add esp,0x0c
	pop esi
	pop eax						;was edx
;---
	ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
;f0_table:       ;-- PC --  -- LEN --  -- PSX --
;	dd      f0__0100,f0__0100_len,0x00000100,0x00000000
;	dd      f0__4c54,f0__4c54_len,0x00004c54,0x00000000
;	dd	f0__6cf4,f0__6cf4_len,0x00006cf4,0x00000000
;	dd      f0__6d58,f0__6d58_len,0x00006d58,0x00000000
;	dd      f0__74a8,f0__74a8_len,0x000074a8,0x00000000
;	dd      f0__e1e8,f0__e1e8_len,0x0000e1e8,0x00000000
;	dd      0x00000000,0x00000000,0x00000000,0x00000000
;f0__0100:
;	dd      0xa000e004,0x00000020,0xa000e1ec,0x00000004
;	dd      0xa000e1f4,0x00000300,0x00000000,0x00000000
;	dd      0xa000e028,0x000001c0,0x00000000,0x00000000
;f0__0100_len    equ     $-f0__0100
;f0__4c54:
;        dd      0x240e0001,0x3c010000,0x03e00008,0xac2e74b8
;f0__4c54_len    equ     $-f0__4c54
;f0__6cf4:
;	dd	0x00000f40,0x000085d4,0x00000000,0x00000000
;	dd	0x00000000,0x00000000,0x00000000,0x00000000
;	dd	0x00000000,0x00000000,0x00000000,0x00000000
;f0__6cf4_len	equ	$-f0__6cf4
;f0__6d58:
;        dd      0x00000000,0x00001920,0x00001794,0x00000000
;        dd      0x00006d58,0x00001958,0x000017f4,0x00000000
;        dd      0x00006d68,0x00001990,0x00001858,0x00000000
;        dd      0x00006d78,0x000019c8,0x000018bc,0x00000000
;        dd      0x00000000,0x00000000,0x00002458,0x00000000
;        dd      0x00000000,0x00000000,0x00001a00,0x00000000
;f0__6d58_len    equ     $-f0__6d58
;f0__74a8:
;        dd      0x00000000,0x000049bc,0x00004a4c,0x00000000
;f0__74a8_len    equ     $-f0__74a8
;f0__e1e8:
;        dd      0x00000004,0xa000e1f4,0x00000300,0x00004000
;f0__e1e8_len    equ     $-f0__e1e8
;------------------------------------------------------------------------------;
ExeOpenError	db	"[  EXE  ]Error: Cann't open file ",0x22,"%s",0x22,10,0
ExeReadError	db	"[  EXE  ]Error: Cann't read file ",0x22,"%s",0x22,10,0
message_ExecuteError    db      "Exe Plugin Error",0
message_cannotopen      db      "Cann't open file",0
message_cannotread      db      "Cann't read file",0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
ExecExeBuffer		resd	0x200
ExeFileHandle		resd	1
ExeFileName			resd	1
