;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
CEXTERN RbPSe_LoadLibrary
CEXTERN RbPSe_ReadStrSettings
CEXTERN RbPSe_SysPrintf
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
        xor eax,eax
        ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
	mov eax,[esp+4]		;//RbPSeStartUpStrucAddr
    push dword ConfigSectionPSEmuBuffer
    push dword ConfigSectionPSEmuDefName
    push dword ConfigSectionPSEmuNames
    push dword ConfigSectionPSEmu
	push dword ConfigFileName
	push dword [eax+RbPSeStartStruc.ProfileDir]
    call RbPSe_ReadStrSettings
    add esp,0x18
		mov eax,[esp+4]		;//RbPSeStartUpStrucAddr
		push dword gpuHandles
		push dword gpuFuncNames
		push dword ConfigSectionPSEmuBuffer
		push dword [eax+RbPSeStartStruc.PluginsDir]
		call RbPSe_LoadLibrary
		add esp,0x10
	test eax,eax
	jz .load_ok
		push dword ErrorLoadPSEmuGPUPlugin
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.load_ok:
	call [gpuHandles.gpuINIT]
	test eax,eax
	jz .init_ok
		push dword ErrorInitPSEmuGPUPlugin
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.init_ok:
;;---
	mov eax,A0_48
	mov ecx,0x0048
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_49
	mov ecx,0x0049
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_4E
	mov ecx,0x004E
	rb_call ___rb___Hook___hleA0___
;;---
	mov eax,Hook32write_1810
	mov edx,Hook32read_1810
	mov ecx,0x00001810
	rb_call ___rb___Hook___HardWare32___
	mov eax,Hook32write_1814
	mov edx,Hook32read_1814
	mov ecx,0x00001814
	rb_call ___rb___Hook___HardWare32___
	mov eax,DMAFunction				;//
	mov ecx,0x00000002				;//
	rb_call ___rb___Hook___dma___	;//
	mov [DMAData],eax				;//
	mov eax,[gpuHandles.gpuUPDATE]
	mov ecx,___screenupdatefunc
	rb_call ___rb___Hook___Table___
;%ifdef __GPULOG
;		push 1
;		push gpulogfilename
;		call Rb_fopen
;		add esp,0x08
;	mov [gpuloghandle],eax
;%endif

	mov eax,[esp+4]
;%ifdef __GPULOG
;	pusha
;        	push eax
;		push dword [eax]
;		push dword [eax+4]
;		push dword [eax+8]
;		push dword [eax+12]
;		push dword [eax+16]
;		push dword str2write
;		push dword [gpuloghandle]
;		call Rb_fprintf
;		add esp,0x20
;	popa
;%endif
BEOS_ONLY		push dword ConfigSectionPSEmuBuffer+0x20
BEOS_ONLY		push dword GPUinitName
				push dword [eax+RbPSeStartStruc.Display]
				call [gpuHandles.gpuOPEN]
BEOS_ONLY		add esp,0x0c
	test eax,eax
	jz .open_ok
		push dword ErrorOpenPSEmuGPUPlugin
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.open_ok:
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	call [gpuHandles.gpuCLOSE]
	test eax,eax
	jz .close_ok
		push dword ErrorClosePSEmuGPUPlugin
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.close_ok:

        call [gpuHandles.gpuSHUTDOWN]
	test eax,eax
	jz .shutdown_ok
		push dword ErrorShutdownPSEmuGPUPlugin
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.shutdown_ok:
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
Hook32write_1810:
			push eax
			call [gpuHandles.gpuWData]
BEOS_ONLY	add esp,0x04
	ret
Hook32read_1810:
	call [gpuHandles.gpuRData]
	ret
Hook32write_1814:
			push eax
			call [gpuHandles.gpuWStatus]
BEOS_ONLY	add esp,0x04
	ret
Hook32read_1814:
	call [gpuHandles.gpuRStatus]
	ret
;------------------------------------------------------------------------------;
DMAFunction:	;//(eax)control
	test eax,0x00000001
	jnz .ToGPU
	jmp .FromGPU
.ToGPU:
	test eax,0x00000400
	jnz .LinkList
	jmp .Simple
.LinkList:
	mov edx,[DMAData]
	mov edx,[edx]
	and edx,0x001fffff
			push edx
			push dword [RbPSeDataData+RbPSeDataStruc.Data___Memory___]
			call [gpuHandles.gpuLL]
BEOS_ONLY	add esp,0x08
	ret
.Simple:
	mov ecx,[DMAData]
	mov edx,[ecx]
	push edx
	mov ecx,[ecx+4]
	mov eax,ecx
	shr ecx,0x10
	mul cx
	shl edx,0x10
	mov dx,ax
	mov ecx,edx
	pop edx
	and edx,0x001fffff
			add edx,[RbPSeDataData+RbPSeDataStruc.Data___Memory___]
			push ecx
			push edx
			call [gpuHandles.gpuWDMA]
BEOS_ONLY	add esp,0x08
	ret
.FromGPU:
	ret
;------------------------------------------------------------------------------;
;void SetGPUStatus(u_long ctrl_cmd)
A0_48:
	mov eax,[byte RegRegister + r___A0___b]
	mov ecx,0x1f801814
	q_call HardwareWrite32
	ret
;------------------------------------------------------------------------------;
;GPU_cw(u_long cmd)
A0_49:
	mov edx,[byte RegRegister + r___A0___b]
	push edx
	mov dword [byte RegRegister + r___T1___b]   ,dword  0x0000004e
	q_call q___hle___a0					;;;GPU_sync
	mov [byte RegRegister + r___V0___b],eax
	mov ecx,0x1f801810
	pop eax
	q_call HardwareWrite32
	ret
;------------------------------------------------------------------------------;
A0_4E:                              ;;;Partialy
	mov ecx,0x1f801814
	q_call HardwareRead32
	and eax,0x60000000
	jnz .dma_check
	mov ecx,0x1f801814
	q_call HardwareRead32
	and eax,0x10000000
	jnz .ready_yes
	mov edx,0x10000000
.rloop:
	mov ecx,0x1f801814
	q_call HardwareRead32
	and eax,0x10000000
	jnz .ready_yes
	dec edx
	jnz .rloop
.ready_no:
	mov eax,0xffffffff
	ret
.ready_yes:
	mov eax,0x00
	ret
.dma_check:
	jmp .ready_yes
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
ConfigSectionPSEmuNames
				dd	ConfigSectionPSEmuPlugin,ConfigSectionPSEmuConfig,0
gpuFuncNames	dd	GPUinitName,GPUopenName,GPUcloseName,GPUshutdownName
				dd	GPUwriteDataName,GPUreadDataName,GPUwriteStatusName
				dd	GPUreadStatusName,GPUwriteDataMemName,GPUreadDataMemName
				dd	GPUdmaChainName,GPUupdateLaceName,0
ConfigFileName				db	"s_gpu_psemu.cfg",0
ConfigSectionPSEmu			db	"psemu",0
ConfigSectionPSEmuPlugin	db	"plugin",0
ConfigSectionPSEmuConfig	db	"config",0
ConfigSectionPSEmuDefName	db	"_nf_",0
WINDOWS_ONLY	PSEmuPluginDefName	db	"PSEmuPro\gpu.dll",0
BEOS_ONLY		PSEmuPluginDefName	db	"PSEmuPro/gpu.so",0
BEOS_ONLY		PSEmuConfigDefName	db	"PSEmuPro/gpu.cfg",0
GPUinitName			db	"GPUinit",0
GPUopenName			db	"GPUopen",0
GPUcloseName		db	"GPUclose",0
GPUshutdownName		db	"GPUshutdown",0
GPUwriteDataName	db	"GPUwriteData",0
GPUreadDataName		db	"GPUreadData",0
GPUwriteStatusName	db	"GPUwriteStatus",0
GPUreadStatusName	db	"GPUreadStatus",0
GPUwriteDataMemName	db	"GPUwriteDataMem",0
GPUreadDataMemName	db	"GPUreadDataMem",0
GPUdmaChainName		db	"GPUdmaChain",0
GPUupdateLaceName	db	"GPUupdateLace",0
ErrorLoadPSEmuGPUPlugin		db	"[  GPU  ]Error: Cann't Load PSEmu GPU Plugin",10,0
ErrorInitPSEmuGPUPlugin		db	"[  GPU  ]Error: Cann't Init PSEmu GPU Plugin",10,0
ErrorOpenPSEmuGPUPlugin		db	"[  GPU  ]Error: Cann't Open PSEmu GPU Plugin",10,0
ErrorClosePSEmuGPUPlugin	db	"[  GPU  ]Error: Cann't Close PSEmu GPU Plugin",10,0
ErrorShutdownPSEmuGPUPlugin	db	"[  GPU  ]Error: Cann't Shutdown PSEmu GPU Plugin",10,0
;tmp_message			db	"DMA Function Execute %x",10,0
;gpu_ll			db	"Linked List (___)=%x, (data)=%x, (esp)=%x",10,0
;gpu_wd			db	"GPU Write (data)=%x, (len)=%x, (esp)=%x",10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
ConfigSectionPSEmuBuffer
				resd	0x04*0x20
gpuHandles
.hlib			resd	1
.gpuINIT		resd	1
.gpuOPEN		resd	1
.gpuCLOSE		resd	1
.gpuSHUTDOWN	resd	1
.gpuWData		resd	1
.gpuRData		resd	1
.gpuWStatus		resd	1
.gpuRStatus		resd	1
.gpuWDMA		resd	1
.gpuRDMA		resd	1
.gpuLL			resd	1
.gpuUPDATE		resd	1
DMAData			resd	1

