;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
%define __HWLOG
%macro LogHWLOG 1
	%ifdef __HWLOG
		mov edx,[esp+4]
		sub edx,DynRegister
		shr edx,0x02
		and edx,0xfffffffc
		push eax
		push ecx
			push ecx
			push eax
			push edx
			push dword %1
            rb_call ___rb___Log___Printf___
			add esp,0x10
		pop ecx
		pop eax
	%endif
%endmacro
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	INSTALL_HOOK Hook___HardWare8___,Hook___HardWare8___
	INSTALL_HOOK Hook___HardWare16___,Hook___HardWare16___
	INSTALL_HOOK Hook___HardWare32___,Hook___HardWare32___
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
	push esi
	push edi
        mov eax,__DefaultHWWWord
        mov edi,__HWWWordTable
        mov ecx,0x3000
        rep stosd
        mov eax,__DefaultHWRWord
        mov edi,__HWRWordTable
        mov ecx,0x3000
        rep stosd
        mov eax,__DefaultHWWHalf
        mov edi,__HWWHalfTable
        mov ecx,0x3000
        rep stosd
        mov eax,__DefaultHWRHalf
        mov edi,__HWRHalfTable
        mov ecx,0x3000
        rep stosd
        mov eax,__DefaultHWWByte
        mov edi,__HWWByteTable
        mov ecx,0x3000
        rep stosd
        mov eax,__DefaultHWRByte
        mov edi,__HWRByteTable
        mov ecx,0x3000
        rep stosd
;---ScratchPad
        mov eax,__DefScratchPadWWord
        mov edi,__HWWWordTable
        mov ecx,0x1000
        rep stosd
        mov eax,__DefScratchPadRWord
        mov edi,__HWRWordTable
        mov ecx,0x1000
        rep stosd
        mov eax,__DefScratchPadWHalf
        mov edi,__HWWHalfTable
        mov ecx,0x1000
        rep stosd
        mov eax,__DefScratchPadRHalf
        mov edi,__HWRHalfTable
        mov ecx,0x1000
        rep stosd
        mov eax,__DefScratchPadWByte
        mov edi,__HWWByteTable
        mov ecx,0x1000
        rep stosd
        mov eax,__DefScratchPadRByte
        mov edi,__HWRByteTable
        mov ecx,0x1000
        rep stosd
;;---
		mov eax,HWWrite8
		mov ecx,f___HWWrite8
		rb_call ___rb___Hook___Table___
        mov eax,HWWrite16
        mov ecx,f___HWWrite16
        rb_call ___rb___Hook___Table___
        mov eax,HWWrite32
        mov ecx,f___HWWrite32
        rb_call ___rb___Hook___Table___
        mov eax,HWRead8
        mov ecx,f___HWRead8
        rb_call ___rb___Hook___Table___
        mov eax,HWRead16
        mov ecx,f___HWRead16
        rb_call ___rb___Hook___Table___
        mov eax,HWRead32
        mov ecx,f___HWRead32
        rb_call ___rb___Hook___Table___
;;---
	pop edi
	pop esi
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
Hook___HardWare8___:;eax - write, edx - read, ecx - addr
        test eax,eax
        jnz .setWrite
        mov eax,__DefaultHWWByte
.setWrite:
        xchg [__HWWByteTable+ecx*4],eax
        test edx,edx
        jnz .setRead
        mov edx,__DefaultHWRByte
.setRead:
        xchg [__HWRByteTable+ecx*4],edx
        ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
Hook___HardWare16___:;eax - write, edx - read, ecx - addr
        test eax,eax
        jnz .setWrite
        mov eax,__DefaultHWWHalf
.setWrite:
        xchg [__HWWHalfTable+ecx*4],eax
        test edx,edx
        jnz .setRead
        mov edx,__DefaultHWRHalf
.setRead:
        xchg [__HWRHalfTable+ecx*4],edx
        ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
Hook___HardWare32___:;eax - write, edx - read, ecx - addr
        test eax,eax
        jnz .setWrite
        mov eax,__DefaultHWWWord
.setWrite:
        xchg [__HWWWordTable+ecx*4],eax
        test edx,edx
        jnz .setRead
        mov edx,__DefaultHWRWord
.setRead:
        xchg [__HWRWordTable+ecx*4],edx
        ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
HWWrite8:
        and ecx,0x00003fff
        jmp [__HWWByteTable+ecx*4]
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
HWWrite16:
        and ecx,0x00003fff
        jmp [__HWWHalfTable+ecx*4]
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
HWWrite32:
        and ecx,0x00003fff
        jmp [__HWWWordTable+ecx*4]
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
HWRead8:
        and ecx,0x00003fff
        jmp [__HWRByteTable+ecx*4]
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
HWRead16:
        and ecx,0x00003fff
        jmp [__HWRHalfTable+ecx*4]
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
HWRead32:
        and ecx,0x00003fff
        jmp [__HWRWordTable+ecx*4]
;------------------------------------------------------------------------------;
;;;;    Default Memory Functions        ;;;;
;------------------------------------------------------------------------------;
__DefaultHWWByte:
	LogHWLOG LOG_hww8
	mov [___HWMemory+ecx],al
	ret
__DefaultHWWHalf:
	LogHWLOG LOG_hww16
	mov [___HWMemory+ecx],ax
	ret
__DefaultHWWWord:
	LogHWLOG LOG_hww32
	mov [___HWMemory+ecx],eax
	ret
__DefaultHWRByte:
	movzx eax,byte [___HWMemory+ecx]
	LogHWLOG LOG_hwr8
	ret
__DefaultHWRHalf:
	movzx eax,word [___HWMemory+ecx]
	LogHWLOG LOG_hwr16
	ret
__DefaultHWRWord:
	mov eax,[___HWMemory+ecx]
	LogHWLOG LOG_hwr32
	ret
;------------------------------------------------------------------------------;
;;;;    Default ScratchPad Functions        ;;;;
;------------------------------------------------------------------------------;
__DefScratchPadWWord:
        mov [___HWMemory+ecx],eax
        ret
__DefScratchPadWHalf:
        mov [___HWMemory+ecx],ax
        ret
__DefScratchPadWByte:
        mov [___HWMemory+ecx],al
        ret
__DefScratchPadRWord:
        mov eax,[___HWMemory+ecx]
        ret
__DefScratchPadRHalf:
        movzx eax,word [___HWMemory+ecx]
        ret
__DefScratchPadRByte:
        movzx eax,byte [___HWMemory+ecx]
        ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
LOG_hwr8	db	"---HW---[ %X ]   Read Byte  [ %X ] from [ %X ] (UnHook)",10,0
LOG_hwr16	db	"---HW---[ %X ]   Read Half  [ %X ] from [ %X ] (UnHook)",10,0
LOG_hwr32	db	"---HW---[ %X ]   Read Word  [ %X ] from [ %X ] (UnHook)",10,0
LOG_hww8	db	"---HW---[ %X ]  Write Byte  [ %X ]  to  [ %X ] (UnHook)",10,0
LOG_hww16	db	"---HW---[ %X ]  Write Half  [ %X ]  to  [ %X ] (UnHook)",10,0
LOG_hww32	db	"---HW---[ %X ]  Write Word  [ %X ]  to  [ %X ] (UnHook)",10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
__HWWByteTable          resd    0x3000
__HWWHalfTable          resd    0x3000
__HWWWordTable          resd    0x3000
__HWRByteTable          resd    0x3000
__HWRHalfTable          resd    0x3000
__HWRWordTable 		resd    0x3000
___HWMemory		resd	0x3000

