;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
%define __HLELOG
%macro LogHLELOG 1
	%ifdef __HLELOG
		push dword [byte RegRegister + r___A3___b]
		push dword [byte RegRegister + r___A2___b]
		push dword [byte RegRegister + r___A1___b]
		push dword [byte RegRegister + r___A0___b]
		push eax
		push dword %1
		rb_call ___rb___Log___Printf___
		add esp,0x18
	%endif
%endmacro
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	INSTALL_HOOK Hook___hleA0___,Hook___hleA0___
	INSTALL_HOOK Hook___hleB0___,Hook___hleB0___
	INSTALL_HOOK Hook___hleC0___,Hook___hleC0___
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
;;;---
	mov eax,DefA0Table
	mov edx,___A0Table
	mov ecx,0xc0*0x04
	rb_call ___rb___Write___Memory___
	mov eax,DefB0Table
	mov edx,___B0Table
	mov ecx,0x80*0x04
	rb_call ___rb___Write___Memory___
	mov eax,DefC0Table
	mov edx,___C0Table
	mov ecx,0x20*0x04
	rb_call ___rb___Write___Memory___
;;---
	mov eax,A0CallFunc
	mov edx,0x000000a0
	rb_call ___rb___Hook___Function___
	mov eax,B0CallFunc
	mov edx,0x000000b0
	rb_call ___rb___Hook___Function___
	mov eax,C0CallFunc
	mov edx,0x000000c0
	rb_call ___rb___Hook___Function___
;;---
	mov eax,A0CallFunc
	mov ecx,___HLECallA0
	rb_call ___rb___Hook___Table___
	mov eax,B0CallFunc
	mov ecx,___HLECallB0
	rb_call ___rb___Hook___Table___
	mov eax,C0CallFunc
	mov ecx,___HLECallC0
	rb_call ___rb___Hook___Table___
;;---
	push edi
		mov edi,__A0HLETable
		mov eax,DefA0___
		mov ecx,0xc0
		rep stosd
		mov edi,__B0HLETable
		mov eax,DefB0___
		mov ecx,0x80
		rep stosd
		mov edi,__C0HLETable
		mov eax,DefC0___
		mov ecx,0x20
		rep stosd
	pop edi
;;---
;;        mov edx,f0_table
;;.f0_loop:
;;        cmp dword [edx],byte 0x00
;;        jz .f0_end
;;        mov edi,[esp]
;;        add edi,[edx+8]
;;        mov ecx,[edx+4]
;;        mov esi,[edx]
;;        rep movsb
;;        add edx,0x10
;;        jmp .f0_loop
;;.f0_end:
;;;--
;;	pop MemRegister
;	popa
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
Hook___hleA0___:;eax:func,ecx:pos
	mov [__A0HLETable+ecx*4],eax
	ret
Hook___hleB0___:
	mov [__B0HLETable+ecx*4],eax
	ret
Hook___hleC0___:
	mov [__C0HLETable+ecx*4],eax
	ret
;------------------------------------------------------------------------------;
A0CallFunc:
	mov eax,[byte RegRegister + r___T1___b]
	jmp [__A0HLETable+eax*4]
B0CallFunc:
	mov eax,[byte RegRegister + r___T1___b]
	jmp [__B0HLETable+eax*4]
C0CallFunc:
	mov eax,[byte RegRegister + r___T1___b]
	jmp [__C0HLETable+eax*4]
;------------------------------------------------------------------------------;
DefA0___:
	LogHLELOG LOG_hledefa0
	ret
DefB0___:
	LogHLELOG LOG_hledefb0
	ret
DefC0___:
	LogHLELOG LOG_hledefc0
	ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
DefA0Table:
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;00
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;04
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;08
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;0c

        dd      0x00000000,0x00000000,0x00000000,0x00000000	;10
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;14
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;18
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;1c

        dd      0x00000000,0x00000000,0x00000000,0x00000000	;20
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;24
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;28
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;2c

        dd      0x00000000,0x00000000,0x00000000,0x00000000	;30
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;34
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;38
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;3c

        dd      0x00000000,0x00000000,0x00000000,0x00000000	;40
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;44
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;48
        dd      0x00000000,0x00000000,0x00000000,0x00000000	;4c

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
DefB0Table:
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x000043d0
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
DefC0Table:
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000c80,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000

        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
        dd      0x00000000,0x00000000,0x00000000,0x00000000
LOG_hledefa0	db	"[--HLE--] Unsupported Call A0:[%2X]( %X, %X, %X, %X)",10,0
LOG_hledefb0	db	"[--HLE--] Unsupported Call B0:[%2X]( %X, %X, %X, %X)",10,0
LOG_hledefc0	db	"[--HLE--] Unsupported Call C0:[%2X]( %X, %X, %X, %X)",10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
__A0HLETable		resd	0x00C0
__B0HLETable		resd	0x0060
__C0HLETable		resd	0x0020
