;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%define	EnablePrintf
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
;%define __HLE_ConsoleLOG
;%macro LogHLE_ConsoleLOG 1
;        %ifdef __HLE_ConsoleLOG
;                push dword [RegRegister+___A3]
;                push dword [RegRegister+___A2]
;                push dword [RegRegister+___A1]
;                push dword [RegRegister+___A0]
;                push dword %1
;                rb_call ___rb___Emulator___Log___
;                add esp,0x14
;        %endif
;%endmacro
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
;---
	mov eax,A0_3F
	mov ecx,0x003f
	rb_call ___rb___Hook___hleA0___
	mov eax,B0_3F
	mov ecx,0x003f
	rb_call ___rb___Hook___hleB0___
;---
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
;printf(char *fmt,...)
;;;;Partialy
A0_3F:
%ifdef EnablePrintf
	mov eax,[byte RegRegister + r___SP___b]
	and eax,0x001fffff
	push dword [MemRegister+eax+0x14]
	push dword [MemRegister+eax+0x10]
	push dword [byte RegRegister + r___A3___b]
	push dword [byte RegRegister + r___A2___b]
	push dword [byte RegRegister + r___A1___b]
	push dword [byte RegRegister + r___A0___b]
	call psx_printf
	add esp,0x18
%endif
	ret
;------------------------------------------------------------------------------;
B0_3D:                                  ;;;Partialy
;        mov eax,[RegRegister+___A0]
;        call RPutChar
;        lea edi,[MemRegister+0x000005e0]
        ret
;------------------------------------------------------------------------------;
B0_3F:                                  ;;;Partialy
%ifdef EnablePrintf
	push dword [byte RegRegister + r___A0___b]
	push dword _it_is_str_
	call psx_printf
	add esp,0x08
%endif
	ret
;------------------------------------------------------------------------------;
;------------------------------------------------------------------------------;
;void psx_printf(char *str,...)
;                                                       Console Print
;------------------------------------------------------------------------------;
;------------------------------------------------------------------------------;
psx_printf:
	push RegRegister
	push MemRegister
	mov eax,[esp+0x0c]
	and eax,0x001fffff
        add eax,MemRegister
        lea edx,[esp+0x10]
        mov esi,eax
        mov edi,psx_printf_buffer
.loop:
        lodsb
        cmp al,0x00
        jne .not_zero
        mov [edi],byte 0x00
		push psx_printf_buffer
		rb_call ___rb___Log___Printf___
		add esp,0x04
        jmp .exit
.not_zero:
        cmp al,'%'
        jne NEAR .not_procent
	xor ecx,ecx
.digit_check:
        lodsb
	cmp al,'9'
	jg .char_check
	lea ecx,[ecx*4+ecx]
	shl ecx,0x01
	sub al,'0'
	add cl,al
	adc ch,0
	jmp .digit_check
.char_check:
        cmp al,'X'
	jne .not_procent_X
        push edx

	mov ecx,0x08
        mov eax,[edx]
        call psx_write_int_hex
        add edi,0x08

        pop edx
        add edx,0x04
        jmp .loop
.not_procent_X:
	cmp al,'x'
	jne .not_procent_x
	push edx

	mov ecx,0x08
	mov eax,[edx]
	call psx_write_int_hex
	add edi,0x08

	pop edx
	add edx,0x04
	jmp .loop
.not_procent_x:
	cmp al,'s'
	jne .not_procent_s
	push edx

	mov eax,[edx]
        and eax,0x001fffff
	add eax,[esp+4]
	call psx_write_string
	add edi,eax

	pop edx
	add edx,0x04
	jmp .loop
.not_procent_s:
	cmp al,'d'
	jne .not_procent_d
	push edx

	mov ecx,0x08
	mov eax,[edx]
	call psx_write_int_hex
        add edi,0x08

	pop edx
	add edx,0x04
	jmp .loop
.not_procent_d:
	cmp al,'i'
	jne .not_procent_i
	push edx

	mov ecx,0x08
	mov eax,[edx]
	call psx_write_int_hex
	add edi,0x08

	pop edx
	add edx,0x04
	jmp .loop
.not_procent_i:
	dec esi
        dec esi
        lodsb
.not_procent:
	stosb
        jmp .loop
.exit:
	pop MemRegister
	pop RegRegister
	ret
;------------------------------------------------------------------------------;
psx_write_int_hex:	;[in]ecx(len)[in]eax(int)[in]edi(plase_to_write)
	cmp ecx,0x08
	ja .exit
.loop:
        mov edx,eax
        and dl,0x0f
        add dl,0x30
        cmp dl,0x3A
        jb .write
        add dl,0x07
.write:
	dec ecx
        mov [edi+ecx],dl
        jecxz .exit
        shr eax,0x04
        jmp .loop
.exit:
	ret
;------------------------------------------------------------------------------;
psx_write_string:	;[in]eax(char*)[in]edi(plase_to_write)[out]eax(len)
	mov ecx,0x00
.loop:
	mov dl,[eax+ecx]
	test dl,dl
	jz .exit
	mov [edi+ecx],dl
	inc ecx
	jmp .loop
.exit:
	mov eax,ecx
	ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
_it_is_str_		db	"%s",0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
psx_printf_buffer	resb	0x100
