;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
%define __HLE_EventLOG
%macro LogHLE_EventLOG 1
	%ifdef __HLE_EventLOG
		push dword [byte RegRegister + r___A3___b]
		push dword [byte RegRegister + r___A2___b]
		push dword [byte RegRegister + r___A1___b]
		push dword [byte RegRegister + r___A0___b]
		push dword %1
		rb_call ___rb___Log___Printf___
		add esp,0x14
	%endif
%endmacro
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
        xor eax,eax
        ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
;---
	mov eax,B0_07
	mov ecx,0x0007
	rb_call ___rb___Hook___hleB0___
	mov eax,B0_08
	mov ecx,0x0008
	rb_call ___rb___Hook___hleB0___
	mov eax,B0_09
	mov ecx,0x0009
	rb_call ___rb___Hook___hleB0___
	mov eax,B0_0A
	mov ecx,0x000A
	rb_call ___rb___Hook___hleB0___
	mov eax,B0_0B
	mov ecx,0x000B
	rb_call ___rb___Hook___hleB0___
	mov eax,B0_0C
	mov ecx,0x000C
	rb_call ___rb___Hook___hleB0___
	mov eax,B0_0D
	mov ecx,0x000D
	rb_call ___rb___Hook___hleB0___
	mov eax,C0_04
	mov ecx,0x0004
	rb_call ___rb___Hook___hleC0___
;;--- kernel data
	mov edx,DataTable
.data_loop:
	cmp dword [edx],byte 0x00
	jz .data_end
	push edx
	mov eax,[edx]
	mov ecx,[edx+4]
	mov edx,[edx+8]
	rb_call ___rb___Write___Memory___
	pop edx
	add edx,0x10
	jmp .data_loop
.data_end:
;;--
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
;DeliverEvent(HEvent,mode)
B0_07:
;//
	LogHLE_EventLOG ___log___B0___07
;//
        push ebp
        mov edx,[byte RegRegister + r___A0___b]
        mov ecx,[MemRegister+0x00000120]
        mov eax,[byte RegRegister + r___A1___b]
        and ecx,0x001fffff
        mov ebp,[MemRegister+0x00000124]
        add ecx,MemRegister
        add ebp,ecx
.loop:
        cmp dword [ecx+ECB_status],dword 0x00002000
        jne .next
;                pusha
;                        push dword ___log___statusok
;                        rb_call ___rb___Emulator___Log___
;                        add esp,0x04
;                popa
        cmp [ecx+ECB_desc],edx
        jne .next
        cmp [ecx+ECB_spec],eax
        jne .next
        cmp [ecx+ECB_mode],dword 0x00002000
        je  .next2
;	        pusha
;			push dword ___log___exechandler
;			rb_call ___rb___Emulator___Log___
;			add esp,0x04
;		popa
	pusha
        mov eax,[ecx+ECB_FHandler]
        mov [byte RegRegister + r___RA___b],dword 0x00000090
        and eax,0x001fffff
        lea eax,[DynRegister+eax*4]
        call eax
        popa
.next:
        add ecx,ECB_SIZE
        cmp ecx,ebp
        jl .loop
        pop ebp
        ret
.next2:
        mov [ecx+ECB_status],dword 0x00004000
        jmp .next
;------------------------------------------------------------------------------;
;u_long OpenEvent(desc,spec,mode,fhandle)
B0_08:
;//
	LogHLE_EventLOG ___log___B0___08
;//
        mov dword [byte RegRegister + r___T1___b]   ,dword  0x00000004
        q_call q___hle___c0
;;;
        mov eax,[MemRegister+0x00000120]
	mov edx,[byte RegRegister + r___V0___b]
        and eax,0x001fffff
        add eax,MemRegister
        imul edx,0x001c
        add edx,eax
        mov eax,[byte RegRegister + r___A0___b]
        mov [edx+ECB_desc],eax
        mov [edx+ECB_status],dword 0x00001000
        mov eax,[byte RegRegister + r___A1___b]
        mov [edx+ECB_spec],eax
        mov eax,[byte RegRegister + r___A2___b]
        mov [edx+ECB_mode],eax
        mov eax,[byte RegRegister + r___A3___b]
        mov [edx+ECB_FHandler],eax
        or  [byte RegRegister + r___V0___b],dword 0xf1000000
        ret
;------------------------------------------------------------------------------;
;CloseEvent(Event)
B0_09:
        mov eax,[byte RegRegister + r___A0___b]
        and eax,0x0000ffff
        imul eax,0x1c
	mov dword [MemRegister+0x0000e028+eax+ECB_status],0x00000000
	ret
;------------------------------------------------------------------------------;
;WaitEvent(Event)
B0_0A:
;//
;//	LogHLE_EventLOG ___log___B0___0A
;//
        mov eax,[byte RegRegister + r___A0___b]
        and eax,0x0000ffff
        imul eax,0x1c
        cmp dword [MemRegister+0x0000e028+eax+ECB_status],0x00004000
        je .okexit
        cmp dword [MemRegister+0x0000e028+eax+ECB_status],0x00002000
        je .waitevent
        mov [byte RegRegister + r___V0___b],dword 0x00000000
        ret
.waitevent:
        lea edx,[MemRegister+0x0000e028+eax+ECB_status]
.waitloop:
        push edx
        call dword [byte esi + s___timing___b]
        pop edx
        cmp dword [edx],0x00004000
        jne .waitloop
.okexit:
        mov [MemRegister+0x0000e028+eax+ECB_status],dword 0x00002000
        mov [byte RegRegister + r___V0___b],dword 0x00000000
        ret
;------------------------------------------------------------------------------;
;TestEvent(Event)
B0_0B:
;//
;//	LogHLE_EventLOG ___log___B0___0B
;//
	mov [byte RegRegister + r___V0___b],dword 0x00000000
	mov eax,[byte RegRegister + r___A0___b]
	and eax,0x0000ffff
	imul eax,0x1c
	mov edx,[MemRegister+0x0000e028+eax+ECB_status]
	cmp edx,0x00004000
	jne .exit
	mov [MemRegister+0x0000e028+eax+ECB_status],dword 0x00002000
	mov [byte RegRegister + r___V0___b],dword 0x00000001
.exit:
	ret
;------------------------------------------------------------------------------;
;EnableEvent(Event)
B0_0C:
;//
	LogHLE_EventLOG ___log___B0___0C
;//
        mov eax,[byte RegRegister + r___A0___b]
        and eax,0x0000ffff
        imul eax,0x1c
        mov edx,[MemRegister+0x0000e028+eax+ECB_status]
        cmp edx,byte 0x00
        je .exit
        mov [MemRegister+0x0000e028+eax+ECB_status],dword 0x00002000
.exit:
        mov [byte RegRegister + r___V0___b],dword 0x00000001
        ret
;------------------------------------------------------------------------------;
;DisableEvent(Event)
B0_0D:
;//
;//	LogHLE_EventLOG ___log___B0___0D
;//
	mov eax,[byte RegRegister + r___A0___b]
	and eax,0x0000ffff
	imul eax,0x1c
	mov edx,[MemRegister+0x0000e028+eax+ECB_status]
	cmp edx,byte 0x00
	je .exit
	mov [MemRegister+0x0000e028+eax+ECB_status],dword 0x00001000
.exit:
	mov [byte RegRegister + r___V0___b],dword 0x00000001
	ret
;------------------------------------------------------------------------------;
;int get_free_EvCB_slot()
C0_04:
        mov ecx,[MemRegister+0x00000120]
        mov eax,[MemRegister+0x00000124]
        and ecx,0x001fffff
	xor edx,edx
	add ecx,MemRegister
	add eax,ecx
.loop:
        cmp dword [ecx+ECB_status],byte 0x00
        je .okexit
        add ecx,ECB_SIZE
        inc edx
        cmp ecx,eax
        jl .loop
        mov edx,0xffffffff
.okexit:
        mov [byte RegRegister + r___V0___b],edx
        ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
DataTable:              ;;--- PC ---  --- LEN ---  --- PSX ---
                dd      data__0120,data__0120___len,0x00000120,0x00000000
                dd      0x00000000,0x00000000,0x00000000,0x00000000
data__0120:
			dd      0xa000e028,0x000001c0,0x00000000,0x00000000
data__0120___len        equ     $-data__0120
___log___B0___07	db	"[  HLE  ]|EVENT|(B0:07)---DeliverEvent( 0x%X , 0x%X )",10,0
___log___B0___08	db	"---HLE---|EVENT|(B0:08)---OpenEvent( 0x%X , 0x%X , 0x%X , 0x%X )",13,10,0
___log___B0___0A	db	"[  HLE  ]|EVENT|(B0:0A)---WaitEvent( 0x%X )",10,0
___log___B0___0B	db	"[  HLE  ]|EVENT|(B0:0B)---TestEvent( 0x%X )",10,0
___log___B0___0C	db	"---HLE---|EVENT|(B0:0C)---EnableEvent( 0x%X )",13,10,0
___log___B0___0D	db	"---HLE---|EVENT|(B0:0D)---DisableEvent( 0x%X )",13,10,0
;___log___statusok	db	"Status is OK",0
;___log___exechandler	db	"Exec Event Handler",0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
