;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
%define __HLE_HeapLOG
%macro LogHLE_HeapLOG 1
	%ifdef __HLE_HeapLOG
		push dword [byte RegRegister + r___A3___b]
		push dword [byte RegRegister + r___A2___b]
		push dword [byte RegRegister + r___A1___b]
		push dword [byte RegRegister + r___A0___b]
		push dword %1
		rb_call ___rb___Log___Printf___
		add esp,0x14
	%endif
%endmacro
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
;---
	mov eax,A0_39
	mov ecx,0x0039
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_33
	mov ecx,0x0033
	rb_call ___rb___Hook___hleA0___
	mov eax,A0_37
	mov ecx,0x0037
	rb_call ___rb___Hook___hleA0___
;---
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
;InitHeap(void *block,int n)
A0_39:
	LogHLE_HeapLOG ___log___A0___39
        mov eax,[byte RegRegister + r___A0___b]                     ;9000 - heap base       =*block
        mov [MemRegister+0x00009000],eax                ;9004 - heap size       =size
        mov edx,[byte RegRegister + r___A1___b]                     ;9008 - heap end        =*block+size
        mov [MemRegister+0x00009004],edx                ;900c - heap alloc      =0
        and eax,0x001fffff
        inc edx
        and edx,0x001ffffc
        add edx,eax
        mov [MemRegister+0x00009008],edx
        and eax,0x001fffff
        mov [MemRegister+eax],dword 0x00000000
        mov [MemRegister+0x0000900c],dword 0x00000000
        ret
;------------------------------------------------------------------------------;
;void *malloc(int n)
A0_33:
	LogHLE_HeapLOG ___log___A0___33
        mov edx,[byte RegRegister + r___A0___b]
        add edx,0x03
        and edx,0xfffffffc
        mov eax,[MemRegister+0x0000900c]
        test eax,eax
        jnz .notfirst
        mov eax,[MemRegister+0x00009000]
        cmp eax,[MemRegister+0x00009008]
        jge .error_exit
        mov ecx,eax
        and ecx,0x001fffff
        mov [MemRegister+ecx],dword 0xfffffffe
        mov [MemRegister+0x0000b064],eax
        mov [MemRegister+0x0000b060],eax
        add [MemRegister+0x00009000],dword 0x00000004
        call _33_allocate
        cmp [byte RegRegister + r___V0___b],dword 0x00000000
        jne .error_exit
        mov dword [MemRegister+0x0000900c],dword 0x00000001
        jmp .ok_exit
.notfirst:
        mov eax,[MemRegister+0x0000b064]
        and eax,0x001fffff
        mov eax,[MemRegister+eax]
        add eax,0x04
        add [MemRegister+0x0000b064],eax
        call _33_allocate
        cmp [byte RegRegister + r___V0___b],dword 0x00000000
        je .ok_exit
;        mov eax,[RegRegister+___A0]
;        and eax,0x001fffff                              ;9000 - heap base       =*block
;        mov [MemRegister+0x00009000],eax                ;9004 - heap size       =size
;        mov edx,[RegRegister+___A1]                     ;9008 - heap end        =*block+size
;        mov [MemRegister+0x00009004],edx                ;900c - heap alloc      =0
;        inc edx
;        and edx,0x001ffffc
;        add edx,eax
;        mov [MemRegister+0x00009008],edx
;        and eax,0x001fffff
;        mov [MemRegister+eax],dword 0x00000000
;        mov [MemRegister+0x0000900c],dword 0x00000000
.error_exit:
        mov [byte RegRegister + r___V0___b],dword 0x00000000
        ret
.ok_exit:
        mov eax,[MemRegister+0x0000b064]
        add eax,0x04
        mov [byte RegRegister + r___V0___b],eax
        ret
_33_allocate:
        test edx,edx
        jz .zero_alloc
        mov eax,[MemRegister+0x00009000]
        mov ecx,edx
        and eax,0x001fffff
        add ecx,eax
        mov [MemRegister+ecx+4],dword 0xfffffffe
;        inc edx
        mov [MemRegister+eax-4],edx
        add edx,0x04                            ;
        add [MemRegister+0x00009000],edx
        mov [byte RegRegister + r___V0___b],dword 0x00000000
        ret
.zero_alloc:
;       mov eax,[MemRegister+0x00009000]
;       mov [RegRegister+___V0],eax
        ret
;------------------------------------------------------------------------------;
;void *calloc(int size,int n)
A0_37:
        mov eax,[byte RegRegister + r___A0___b]
        mul dword [byte RegRegister + r___A1___b]
        mov [byte RegRegister + r___A0___b],eax
        push eax
		mov dword [byte RegRegister + r___T1___b]	,dword  0x00000033
		q_call q___hle___a0
        pop eax
        mov ecx,[byte RegRegister + r___V0___b]
        mov [byte RegRegister + r___A1___b],eax
        mov [byte RegRegister + r___A0___b],ecx
        push ecx
		mov dword [byte RegRegister + r___T1___b]   ,dword  0x00000028
		q_call q___hle___a0
        pop ecx
        mov [byte RegRegister + r___V0___b],ecx
        ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
___log___A0___39	db      "---HLE---| HEAP|(A0:39)---InitHeap( 0x%X , 0x%X )",13,10,0
___log___A0___33	db      "---HLE---| HEAP|(A0:33)---malloc( 0x%X )",13,10,0
;LOG_hwr16       db      "---HW---[ %X ]   Read Half  [ %X ] from [ %X ] (UnHook)",13,10,0
;LOG_hwr32       db      "---HW---[ %X ]   Read Word  [ %X ] from [ %X ] (UnHook)",13,10,0
;LOG_hww8        db      "---HW---[ %X ]  Write Byte  [ %X ]  to  [ %X ] (UnHook)",13,10,0
;LOG_hww16       db      "---HW---[ %X ]  Write Half  [ %X ]  to  [ %X ] (UnHook)",13,10,0
;LOG_hww32       db      "---HW---[ %X ]  Write Word  [ %X ]  to  [ %X ] (UnHook)",13,10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
