#ifndef __RBPSE__SDK__H__
#define __RBPSE__SDK__H__

#include "rbpse.data.h"

#if   defined(BEOS)

# include <image.h>
# define RbPSe_CreateThread(x,y)	(long)spawn_thread((thread_func)x,\
					"RbPSe_Thread",	B_NORMAL_PRIORITY,(void*)y)
# define RbPSe_ResumeThread(x)		(long)resume_thread((thread_id)x)
# define RbPSe_SuspendThread(x)		(long)suspend_thread((thread_id)x)
# define RbPSe_KillThread(x)		(long)kill_thread((thread_id)x)
# define RbPSe_CurrentThread()		(long)find_thread(NULL);

#elif defined(WIN32)

#include <windows.h>
DWORD	__tmp__;
# define RbPSe_CreateThread(x,y)	(long)CreateThread(0,0,\
	(LPTHREAD_START_ROUTINE)x,(LPVOID)y,CREATE_SUSPENDED,&__tmp__)
# define RbPSe_ResumeThread(x)		(long)ResumeThread((HANDLE)x)
# define RbPSe_SuspendThread(x)		(long)SuspendThread((HANDLE)x)
# define RbPSe_KillThread(x)		(long)TerminateThread((HANDLE)x,0)

#elif defined(LINUX)

#endif

#include "system.h"

//extern "C" {
//long	RbPSe_fopen(const char*,const char*,int);
//long	RbPSe_fclose(long);
//long	RbPSe_ReadSettings(const char*,const char*,const char*, const char**,
//			const char*,const char[][32]);
//long	RbPSe_LoadLibrary(const char*,const char*,const char**,const long[6]);
//}

#define INSTALL_FUNC(place,func) \
	RbPSeFuncData. ## place = func; \
    RbPSeFuncDataAddr-> ## place = func;

#endif

