;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
;======import======
;Interface:
;	[___rb___Hook___RUN___]				(memory)
;	[___rb___Hook___RUN___Ext___]		(memory)
;	[___rb___Hook___HW4___]				(hardware)
;	[___rb___Hook___HW2___]				(hardware)
;	[___rb___Hook___HLE___B0___]		(hle)
;	[___rb___Hook___HLE___C0___]		(hle)
;Run--Time:
;BIOS-Call:
;======export======
;Interface:	(None)
;Run--Time:
;	[___syscall]
;	[___RequestInterrupt]
;BIOS-Call:
;------------------------------------------------------------------------------;
;%define __INT_REGLOG
;%define __INT_FUNCLOG
%macro LogINT_REGLOG 1
	%ifdef __INT_REGLOG
		mov edx,[esp+4]
		sub edx,DynRegister
		shr edx,0x02
		and edx,0xfffffffc
		push eax
			push eax
			push edx
			push dword %1
			rb_call ___rb___Log___Printf___
			add esp,0x0c
		pop eax
	%endif
%endmacro
%macro LogINT_FUNCLOG 1
	%ifdef __INT_FUNCLOG
		push dword [byte RegRegister + r___A3___b]
		push dword [byte RegRegister + r___A2___b]
		push dword [byte RegRegister + r___A1___b]
		push dword [byte RegRegister + r___A0___b]
		push dword %1
		rb_call ___rb___Log___Printf___
		add esp,0x14
	%endif
%endmacro
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
;--- funcs ---
	mov eax,RequestInterrupt
	mov ecx,___RequestInterrupt
	rb_call ___rb___Hook___Table___
	mov eax,ExecuteSystemCall
	mov ecx,___ExecuteSystemCall
	rb_call ___rb___Hook___Table___
	mov eax,ExecuteSystemCall
	mov ecx,o___syscall
	rb_call ___rb___Hook___Table___
;--- hw data ---
	mov dword [InterruptRegister]   ,dword 0x00000000
	mov dword [InterruptMask]       ,dword 0x00000000
;--- hw hook ---
	mov eax,writeIntRegWord
	mov edx,readIntRegWord
	mov ecx,0x00001070
	rb_call ___rb___Hook___HardWare32___
	mov eax,writeIntMaskWord
	mov edx,readIntMaskWord
	mov ecx,0x00001074
	rb_call ___rb___Hook___HardWare32___
	mov eax,writeIntRegHalf
	mov edx,readIntRegHalf
	mov ecx,0x00001070
	rb_call ___rb___Hook___HardWare16___
	mov eax,writeIntMaskHalf
	mov edx,readIntMaskHalf
	mov ecx,0x00001074
	rb_call ___rb___Hook___HardWare16___
;--- bios hle ---
	mov eax,B0_17
	mov ecx,0x0017
	rb_call ___rb___Hook___hleB0___
	mov eax,B0_18
	mov ecx,0x0018
	rb_call ___rb___Hook___hleB0___
	mov eax,B0_19
	mov ecx,0x0019
	rb_call ___rb___Hook___hleB0___
	mov eax,C0_02
	mov ecx,0x0002
	rb_call ___rb___Hook___hleC0___
	mov eax,C0_03
	mov ecx,0x0003
	rb_call ___rb___Hook___hleC0___
;---
	mov eax,IntReturnFunction
	mov edx,0x00000090
	mov ecx,0x00000004
	rb_call ___rb___Hook___Function___Ext___
;;---
	mov eax,___HLE17f4
	mov edx,0x000017f4
	rb_call ___rb___Hook___Function___
	mov eax,___HLE1958
	mov edx,0x00001958
	rb_call ___rb___Hook___Function___
	mov eax,___HLE1858
	mov edx,0x00001858
	rb_call ___rb___Hook___Function___
	mov eax,___HLE1990
	mov edx,0x00001990
	rb_call ___rb___Hook___Function___
	mov eax,___HLE2458
	mov edx,0x00002458
	rb_call ___rb___Hook___Function___
;;--- kernel data
	mov edx,DataTable
.data_loop:
	cmp dword [edx],byte 0x00
	jz .data_end
	push edx
	mov eax,[edx]
	mov ecx,[edx+4]
	mov edx,[edx+8]
	rb_call ___rb___Write___Memory___
	pop edx
	add edx,0x10
	jmp .data_loop
.data_end:
;;--
	push esi
	push edi
	push ebx
	mov esi,[RbPSeDataData+RbPSeDataStruc.Data___Table___]
	mov edi,[RbPSeDataData+RbPSeDataStruc.Data___Memory___]
	mov ebx,[RbPSeDataData+RbPSeDataStruc.Data___Dynarec___]
		mov dword [byte RegRegister + r___A0___b]   ,dword  0x00000001
		mov dword [byte RegRegister + r___A1___b]   ,dword  0x00006d68
		mov dword [byte RegRegister + r___T1___b]   ,dword  0x00000002
		q_call q___hle___c0
		mov ecx,0x02
		q_call q___system
	pop ebx
	pop edi
	pop esi
;;--
;	pusha
;		push dword 1
;		push dword MemDumpFile
;		call Rb_fopen
;		add esp,0x08
;	push eax
;		push dword 0x00200000
;		push dword [RbPSeMainStruc.MainMemory]
;		push eax
;		call Rb_fwrite
;		add esp,0x0c
;	pop eax
;		push eax
;		call Rb_fclose
;		add esp,0x04
;	popa
;;--
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
;;;;	HW Hook Functions
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Write----------------------------------------------;
;------------------------------------------------------------------------------;
writeIntRegWord:
	LogINT_REGLOG ___log_int_w4i
	and eax,[InterruptMask]
	and [InterruptRegister],eax
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Read-----------------------------------------------;
;------------------------------------------------------------------------------;
readIntRegWord:
	mov eax,[InterruptRegister]
	LogINT_REGLOG ___log_int_r4i
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Write----------------------------------------------;
;------------------------------------------------------------------------------;
writeIntMaskWord:
	LogINT_REGLOG ___log_int_w4m
	mov [InterruptMask],eax
	and eax,[InterruptRegister]
	jz .end
;;     jmp ExecInterrupt
.end:
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Read-----------------------------------------------;
;------------------------------------------------------------------------------;
readIntMaskWord:
	mov eax,[InterruptMask]
	LogINT_REGLOG ___log_int_r4m
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Write----------------------------------------------;
;------------------------------------------------------------------------------;
writeIntRegHalf:
	LogINT_REGLOG ___log_int_w2i
	and ax,[InterruptMask]
	and [InterruptRegister],ax
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Read-----------------------------------------------;
;------------------------------------------------------------------------------;
readIntRegHalf:
        mov ax,[InterruptRegister]
	LogINT_REGLOG ___log_int_r2i
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Write----------------------------------------------;
;------------------------------------------------------------------------------;
writeIntMaskHalf:
	LogINT_REGLOG ___log_int_w2m
	mov [InterruptMask],ax
	and ax,[InterruptRegister]
	jz .end
;;     jmp ExecInterrupt
.end:
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Read-----------------------------------------------;
;------------------------------------------------------------------------------;
readIntMaskHalf:
        mov ax,[InterruptMask]
	LogINT_REGLOG ___log_int_r2m
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Interrupt---------------------------------------------------;
;------------------------------------------------------------------------------;
RequestInterrupt:
	or [InterruptRegister],edx
	and edx,[InterruptMask]
	jz .exit
	cmp byte [InterruptStatus],byte 0x00
	je .disable
	jmp ExecuteInterrupt
.disable:
        inc byte [InterruptWaiting]
.exit:
        ret
;------------------------------------------------------------------------------;
align 4 ;----------Interrupt---------------------------------------------------;
;------------------------------------------------------------------------------;
ExecuteInterrupt:
;//Savestate
;	call printEDI
	mov byte [InterruptStatus],byte 0x00
	mov eax,[MemRegister+0x00000108]
	and eax,0x001fffff
	mov eax,[MemRegister+eax]
	and eax,0x001fffff
	push edi
	push esi
	lea edi,[MemRegister+eax+TCB_reg]
	mov ecx,0x20
	rep movsd
	pop esi
	add edi,0x04
	mov eax,[byte RegRegister + r___HI___b]
	mov [edi],eax
	add edi,0x04
	mov eax,[byte RegRegister + r___LO___b]
	mov [edi],eax
	pop edi
;//Funcs
	mov [byte RegRegister + r___RA___b],dword 0x00000090
	mov [byte RegRegister + r___SP___b],dword 0x000085d8
;;---
	mov eax,InterruptFunc1
.loop:
	cmp dword [eax],byte 0x00
	jz .eoi
	push eax
	call [eax]
	pop eax
	cmp dword [byte RegRegister + r___V0___b],byte 0x00
	je .next
	cmp dword [eax+0x20],byte 0x00
	je .next
	push eax
	call [eax+0x20]
	pop eax
.next:
	add eax,0x04
	jmp .loop
;//EOI
.eoi:
	mov ecx,[EntryIntFunc]
	cmp ecx,0x00006cf4
	je NEAR .defEntry
	and ecx,0x001fffff
	mov [byte RegRegister + r___V0___b],dword 0x00000001
	mov eax,[MemRegister+ecx+0x2c]
	mov [byte RegRegister + r___GP___b],eax
	mov eax,[MemRegister+ecx+0x28]
	mov [byte RegRegister + r___S7___b],eax
	mov eax,[MemRegister+ecx+0x24]
	mov [byte RegRegister + r___S6___b],eax
	mov eax,[MemRegister+ecx+0x20]
	mov [byte RegRegister + r___S5___b],eax
	mov eax,[MemRegister+ecx+0x1c]
	mov [byte RegRegister + r___S4___b],eax
	mov eax,[MemRegister+ecx+0x18]
	mov [byte RegRegister + r___S3___b],eax
	mov eax,[MemRegister+ecx+0x14]
	mov [byte RegRegister + r___S2___b],eax
	mov eax,[MemRegister+ecx+0x10]
	mov [byte RegRegister + r___S1___b],eax
	mov eax,[MemRegister+ecx+0x0c]
	mov [byte RegRegister + r___S0___b],eax
	mov eax,[MemRegister+ecx+0x08]
	mov [byte RegRegister + r___FP___b],eax
	mov eax,[MemRegister+ecx+0x04]
	mov [byte RegRegister + r___SP___b],eax
	mov eax,[MemRegister+ecx+0x00]
	mov [byte RegRegister + r___RA___b],eax
	and eax,0x001fffff
	lea eax,[DynRegister+eax*4]
	push eax
	call eax
	ret
.defEntry
	mov edx,[MemRegister+0x00000108]
	and edx,0x001fffff
	mov edx,[MemRegister+edx]
	and edx,0x001fffff
	push edi
	push esi
	lea esi,[MemRegister+edx+TCB_reg]
	mov edi,[esp]
	mov ecx,0x20
	rep movsd
	mov edi,esi
	pop esi
	add edi,0x04
	mov eax,[edi]
	mov [byte RegRegister + r___HI___b],eax
	add edi,0x04
	mov eax,[edi]
	mov [byte RegRegister + r___LO___b],eax
	pop edi
;;	call printEDI
	mov byte [InterruptStatus],byte 0x01
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Interrupt-Return-Function-----------------------------------;
;------------------------------------------------------------------------------;
IntReturnFunction:
	ret
;------------------------------------------------------------------------------;
align 4 ;----------System-Call's-----------------------------------------------;
;------------------------------------------------------------------------------;
ExecuteSystemCall:
        jmp [SysCallFuncs+ecx*4]
SysCall0:
;;        mov eax,0xffffffff
;;        mov edx,0x80
;;        mov ecx,0x00
;;        call cpuWriteWarning
	ret
SysCall1:
	call EnterCriticalSection
		push ___log___EnterCriticalSection
		rb_call ___rb___Log___Printf___
		add esp,0x04
;        and [RegRegister+___SR],dword 0xfffffffb
	ret
SysCall2:
	call ExitCriticalSection
		push ___log___ExitCriticalSection
		rb_call ___rb___Log___Printf___
		add esp,0x04
;;        or  [RegRegister+___SR],dword 0x00000004
	call InstallInterruptFunctions
;;	call LogExitDump
	ret
SysCall3:
;;        mov eax,0xfffffffe
;;        mov edx,0x80
;;        mov ecx,0x00
;;        call cpuWriteWarning
	ret
;------------------------------------------------------------------------------;
;       Interrupt Functions
;------------------------------------------------------------------------------;
EnterCriticalSection:
	mov byte [InterruptStatus],byte 0x00
	ret
ExitCriticalSection:
	mov byte [InterruptStatus],byte 0x01
;        cmp byte [InterruptWaiting],byte 0x00
	ret
;------------------------------------------------------------------------------;
InstallInterruptFunctions:
	push ebp
	mov ecx,[MemRegister+0x00000100]
	mov ebp,InterruptFunc1
	and ecx,0x001fffff
	push ecx
	add dword [esp],dword 0x20
.loop_ext:
	mov eax,[MemRegister+ecx]
	and eax,0x001fffff
.loop_int:
	test eax,eax
	jz .next_ext
	mov edx,[MemRegister+eax+0x08]
	test edx,edx
	jz .f1_is_0
	call _hle__convert
	mov [ebp],edx
	mov edx,[MemRegister+eax+0x04]
	call _hle__convert
	mov [ebp+0x20],edx
	add ebp,0x04
.f1_is_0:
	mov eax,[MemRegister+eax]
	and eax,0x001fffff
	jmp .loop_int
.next_ext:
	add ecx,0x08
	cmp ecx,[esp]
	jl .loop_ext
	pop ecx
	mov dword [ebp],dword 0x00000000
	pop ebp
	ret
_hle__convert:
	and edx,0x001fffff
	jz .exit
	lea edx,[DynRegister+edx*4]
.exit:
	ret
___HLE17f4:
;;---
;	push dword ___log___exec17f4
;	rb_call ___rb___Emulator___Log___
;	add esp,0x04
;;---
	mov eax,[InterruptMask]
	and eax,0x00000020
	jz .zero_exit
	and eax,[InterruptRegister]
	jz .zero_exit
		mov dword [byte RegRegister + r___A0___b]	,dword	0xf2000001
		mov dword [byte RegRegister + r___A1___b]	,dword	0x00000002
		mov dword [byte RegRegister + r___T1___b]	,dword	0x00000007
		q_call q___hle___b0
	mov dword [byte RegRegister + r___V0___b],dword 0x00000001
	ret
.zero_exit:
	mov dword [byte RegRegister + r___V0___b],dword 0x00000000
	ret
___HLE1858:
	mov eax,[InterruptMask]
	and eax,0x00000040
	jz .zero_exit
	and eax,[InterruptRegister]
	jz .zero_exit
		mov dword [byte RegRegister + r___A0___b]   ,dword  0xf2000002
		mov dword [byte RegRegister + r___A1___b]   ,dword  0x00000002
		mov dword [byte RegRegister + r___T1___b]   ,dword  0x00000007
		q_call q___hle___b0
	mov dword [byte RegRegister + r___V0___b],dword 0x00000001
	ret
.zero_exit:
	mov dword [byte RegRegister + r___V0___b],dword 0x00000000
	ret
___HLE1958:
;;---
;	push dword ___log___exec1958
;	rb_call ___rb___Emulator___Log___
;	add esp,0x04
;;---
	and dword [InterruptRegister],dword 0xffffffdf
	ret
___HLE1990:
	and dword [InterruptRegister],dword 0xffffffbf
	ret
___HLE2458:
;;      mov eax,[MemRegister+___HWMemory+0x1070]
;;      and eax,[MemRegister+___HWMemory+0x1074]
;;      xor [MemRegister+___HWMemory+0x1070],eax
	ret
;------------------------------------------------------------------------------;
;ReturnFromException
;;;;Full
B0_17:
	mov edx,[MemRegister+0x00000108]
	and edx,0x001fffff
	mov edx,[MemRegister+edx]
	and edx,0x001fffff
	push edi
	push esi
	lea esi,[MemRegister+edx+TCB_reg]
	mov edi,[esp]
	mov ecx,0x20
	rep movsd
;;
	mov edi,esi
	pop esi
	add edi,0x04
	mov eax,[edi]
	mov [byte RegRegister + r___HI___b],eax
	add edi,0x04
	mov eax,[edi]
	mov [byte RegRegister + r___LO___b],eax
	pop edi

	call ExitCriticalSection
	add esp,12
        ret
;------------------------------------------------------------------------------;
;ResetEntryInt()
B0_18:
	mov [EntryIntFunc],dword 0x00006cf4
	ret
;------------------------------------------------------------------------------;
;HookEntryInt(void (*func)())
B0_19:
	LogINT_FUNCLOG LOG_B0_19
	mov eax,[byte RegRegister + r___A0___b]                     ;75d0 - EntryIntFunc
	mov [EntryIntFunc],eax
	ret
;------------------------------------------------------------------------------;
;;;;SysEnqIntRP(int index,long *queue)
C0_02:
	LogINT_FUNCLOG LOG_C0_02
	mov edx,[byte RegRegister + r___A1___b]
	mov ecx,[byte RegRegister + r___A0___b]
	and edx,0x001fffff
	and dword [MemRegister+edx+4],dword 0x001fffff
	and dword [MemRegister+edx+8],dword 0x001fffff
	mov eax,[MemRegister+0x00000100]
	and eax,0x001fffff
	lea ecx,[eax+ecx*8]
	and ecx,0x001fffff
	mov eax,[MemRegister+ecx]
	mov [MemRegister+edx],eax
	mov [MemRegister+ecx],edx
	ret
;------------------------------------------------------------------------------;
;;;;SysDeqIntRP(int index,long *queue)
C0_03:
        LogINT_FUNCLOG LOG_C0_03
	mov ecx,[byte RegRegister + r___A0___b]
	mov edx,[byte RegRegister + r___A1___b]
	and edx,0x001fffff
	mov eax,[MemRegister+0x00000100]
	and eax,0x001fffff
	lea ecx,[eax+ecx*8]
	and ecx,0x001fffff
.loop:
	mov eax,[MemRegister+ecx]
	cmp eax,0x00000000
	je .exit
	cmp eax,edx
	je .remove
	mov ecx,eax
	and ecx,0x001fffff
	jmp .loop
.remove:
	and eax,0x001fffff
	mov edx,[MemRegister+eax]
	mov [MemRegister+ecx],edx
.exit:
	mov [byte RegRegister + r___V0___b],eax
	ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
SysCallFuncs		dd	SysCall0,SysCall1,SysCall2,SysCall3
DataTable:		;;--- PC ---  --- LEN ---  --- PSX ---
		dd      data__0100,data__0100___len,0x00000100,0x00000000
;		dd      f0__4c54,f0__4c54_len,0x00004c54,0x00000000
		dd      data__6cf4,data__6cf4___len,0x00006cf4,0x00000000
		dd      data__6d58,data__6d58___len,0x00006d58,0x00000000
;		dd      f0__74a8,f0__74a8_len,0x000074a8,0x00000000
		dd      data__e1e8,data__e1e8___len,0x0000e1e8,0x00000000
		dd      0x00000000,0x00000000,0x00000000,0x00000000
data__0100:
			dd	0xa000e004,0x00000020,0xa000e1ec,0x00000004
			dd	0xa000e1f4,0x00000300
data__0100___len	equ	$-data__0100
data__6cf4:
			dd      0x00000f40,0x000085d4,0x00000000,0x00000000
			dd      0x00000000,0x00000000,0x00000000,0x00000000
			dd      0x00000000,0x00000000,0x00000000,0x00000000
data__6cf4___len	equ	$-data__6cf4
data__6d58:
			dd      0x00000000,0x00001920,0x00001794,0x00000000
			dd      0x00006d58,0x00001958,0x000017f4,0x00000000
			dd      0x00006d68,0x00001990,0x00001858,0x00000000
			dd      0x00006d78,0x000019c8,0x000018bc,0x00000000
			dd      0x00000000,0x00000000,0x00002458,0x00000000
			dd      0x00000000,0x00000000,0x00001a00,0x00000000
data__6d58___len	equ	$-data__6d58
data__e1e8:
			dd      0x00000004,0xa000e1f4,0x00000300,0x00004000
data__e1e8___len	equ	$-data__e1e8
___log_int_w4i	db	"[ %X ]---INT---Write Word [ %X ]  to  Interrupt Register",10,0
___log_int_r4i	db	"[ %X ]---INT--- Read Word [ %X ] from Interrupt Register",10,0
___log_int_w4m	db	"[ %X ]---INT---Write Word [ %X ]  to   IntMask  Register",10,0
___log_int_r4m	db	"[ %X ]---INT--- Read Word [ %X ] from  IntMask  Register",10,0
___log_int_w2i	db	"[ %X ]---INT---Write Half [ %X ]  to  Interrupt Register",10,0
___log_int_r2i	db	"[ %X ]---INT--- Read Half [ %X ] from Interrupt Register",10,0
___log_int_w2m	db	"[ %X ]---INT---Write Half [ %X ]  to   IntMask  Register",10,0
___log_int_r2m	db	"[ %X ]---INT--- Read Half [ %X ] from  IntMask  Register",10,0
___log___EnterCriticalSection
	db      ">>>>>>>>>>>>   EnterCriticalSection   >>>>>>>>>>>>",10,0
___log___ExitCriticalSection
	db      "<<<<<<<<<<<<   ExitCriticalSection    <<<<<<<<<<<<",10,0
LOG_B0_19	db	"---HLE---| INT |(B0:19)---HookEntryInt( 0x%X )",10,0
LOG_C0_02	db	"---HLE---| INT |(C0:02)---SysEnqIntRP( 0x%X , 0x%X )",10,0
LOG_C0_03	db	"---HLE---| INT |(C0:03)---SysDeqIntRP( 0x%X , 0x%X )",10,0
MemDumpFile		db	"__mem__.dmp",0
___log___exec17f4	db	"Execute 17f4 function",10,0
___log___exec1958	db	"Execute 1958 function",10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
InterruptRegister	resd	1		;(HW)(1070)
InterruptMask		resd	1		;(HW)(1074)
EntryIntFunc		resd	1		;(KRNL)(75d0)
InterruptStatus		resb	1
InterruptWaiting	resb	1
InterruptFunc1		resd    0x20
InterruptFunc2		resd    0x20
