;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
CEXTERN	RbPSe_malloc
CEXTERN	RbPSe_fopen
CEXTERN RbPSe_fprintf
CEXTERN	RbPSE_fclose
CEXTERN	RbPSe_SysPrintf
;------------------------------------------------------------------------------;
%assign		REAL__SIZE	0x00200000
%assign		PARL__SIZE	0x00010000
%assign		Full__SIZE	0x00210000
%assign		Table_SIZE	0x00001000
%assign     ___PARLMemory   0x00200000
;------------------------------------------------------------------------------;
;%define __MEMLOG
;%macro LogMEMLOG 1
;        %ifdef __MEMLOG
;                mov edx,[esp+4]
;                sub edx,DynRegister
;                shr edx,0x02
;                and edx,0xfffffffc
;                push eax
;                push ecx
;                        push ecx
;                        push eax
;                        push edx
;                        push dword %1
;						rb_call ___rb___Log___Printf___
;                        add esp,0x10
;                pop ecx
;                pop eax
;        %endif
;%endmacro
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
;Allocate Register Memory
		push dword Table_SIZE
		call RbPSe_malloc
		add esp,0x04
	test eax,eax
	jnz .RegMemAlloc
		push dword Error_TableAlloc
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.RegMemAlloc:
	add eax,Table_SIZE/2
	mov [Data___Table___],eax
    INSTALL_DATA Data___Table___,eax
;Allocate Base Memory
		push dword Full__SIZE
		call RbPSe_malloc
		add esp,0x04
	test eax,eax
	jnz .BaseMemAlloc
		push dword Error_BaseAlloc
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.BaseMemAlloc:
	mov [Data___Memory___],eax
    INSTALL_DATA Data___Memory___,eax
    INSTALL_FUNC Write___Memory___,Write___Memory___
    INSTALL_HOOK Hook___Table___,Hook___Table___
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
;//Empty Memory
	push edi
		mov edi,[Data___Table___]			;+
		mov [edi+r___ZR],dword 0x00000000	;= Zero ZR Register
		mov edi,[Data___Memory___]			;+
		mov ecx,Full__SIZE/4				;+
		mov eax,0x00000000					;+
		rep stosd							;= Zero PSX Memory
	pop edi
;//Install Memory Functions
	mov eax,MemWrite8
	mov ecx,f___MemWrite8
	rb_call ___rb___Hook___Table___
	mov eax,MemWrite16
	mov ecx,f___MemWrite16
	rb_call ___rb___Hook___Table___
	mov eax,MemWrite32
	mov ecx,f___MemWrite32
	rb_call ___rb___Hook___Table___
	mov eax,MemRead8S
	mov ecx,f___MemRead8S
	rb_call ___rb___Hook___Table___
	mov eax,MemRead8U
	mov ecx,f___MemRead8U
	rb_call ___rb___Hook___Table___
	mov eax,MemRead16S
	mov ecx,f___MemRead16S
	rb_call ___rb___Hook___Table___
	mov eax,MemRead16U
	mov ecx,f___MemRead16U
	rb_call ___rb___Hook___Table___
	mov eax,MemRead32
	mov ecx,f___MemRead32
	rb_call ___rb___Hook___Table___
	mov eax,MemWriteL
	mov ecx,f___MemWriteL
	rb_call ___rb___Hook___Table___
	mov eax,MemWriteR
	mov ecx,f___MemWriteR
	rb_call ___rb___Hook___Table___
	mov eax,MemReadL
	mov ecx,f___MemReadL
	rb_call ___rb___Hook___Table___
	mov eax,MemReadR
	mov ecx,f___MemReadR
	rb_call ___rb___Hook___Table___
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
Write___Memory___:;eax - from(src),edx - to(dst),ecx - len(byte)
	push esi
	push edi
		mov edi,[Data___Memory___]
		mov esi,eax
		add edi,edx
		rep movsb
	pop edi
	pop esi
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
Hook___Table___:;eax - addr,ecx - num
	mov edx,[Data___Table___]
	mov [edx+ecx],eax
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
Hook___TableEx___:;eax - addr,ecx - num
	movsx ecx,cl
	mov edx,[Data___Table___]
	mov [edx+ecx],eax
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
MemWrite8:
	test ecx,0x10000000
	jnz .nRealMem__
	and ecx,0x001fffff
	mov [MemRegister+ecx],al
	ret
.nRealMem__:
	test ecx,0x00400000
	jnz .BIOSMem__
	test ecx,0x00800000
	jz  .LessThenHW
	q_call HardwareWrite8
	ret
.LessThenHW:
	and ecx,0x1fffffff
	mov [MemRegister+ecx+___PARLMemory-0x1f000000],al
	ret
.BIOSMem__:
;	and ecx,0x1fffffff
;	mov [__BIOSMemory-0x1fc00000+ecx],al
;	call GeneralEmulationError
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
MemWrite16:
        test ecx,0x10000000
        jnz .nRealMem__
        and ecx,0x001fffff
        mov [MemRegister+ecx],ax
        ret
.nRealMem__:
        test ecx,0x00400000
        jnz .BIOSMem__
        test ecx,0x00800000
        jz  .LessThenHW
        q_call HardwareWrite16
        ret
.LessThenHW:
        and ecx,0x1fffffff
        mov [MemRegister+ecx+___PARLMemory-0x1f000000],ax
        ret
.BIOSMem__:
;	and ecx,0x1fffffff
;	mov [__BIOSMemory-0x1fc00000+ecx],ax
;	call GeneralEmulationError
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
MemWrite32:
	test ecx,0x10000000
	jnz .nRealMem__
	and ecx,0x001fffff
	mov [MemRegister+ecx],eax
	ret
.nRealMem__:
	test ecx,0x00400000
	jnz .BIOSMem__
	test ecx,0x00800000
	jz  .LessThenHW
	q_call HardwareWrite32
	ret
.LessThenHW:
	and ecx,0x1fffffff
	mov [MemRegister+ecx+___PARLMemory-0x1f000000],eax
;	LogMEMLOG LOG_memw32
	ret
.BIOSMem__:
;	LogMEMLOG LOG_memw32
;	and ecx,0x1fffffff
;	mov [__BIOSMemory-0x1fc00000+ecx],eax
;	call GeneralEmulationError
	ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
MemRead8S:
        test ecx,0x10000000
        jnz .nRealMem__
        and ecx,0x001fffff
        movsx eax,byte [MemRegister+ecx]
        ret
.nRealMem__:
        test ecx,0x00400000
        jnz .BIOSMem__
        test ecx,0x00800000
        jz  .LessThenHW
        q_call HardwareRead8
        movsx eax,al
        ret
.LessThenHW:
        and ecx,0x1fffffff
        movsx eax,byte [MemRegister+ecx+___PARLMemory-0x1f000000]
        ret
.BIOSMem__:
;	and ecx,0x1fffffff
;	movsx eax,byte [MemRegister+ecx+___BIOSMemory-0x1fc00000]
;	call GeneralEmulationError
	mov eax,0x00
        ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
MemRead8U:
        test ecx,0x10000000
        jnz .nRealMem__
        and ecx,0x001fffff
        movzx eax,byte [MemRegister+ecx]
        ret
.nRealMem__:
        test ecx,0x00400000
        jnz .BIOSMem__
        test ecx,0x00800000
        jz  .LessThenHW
        q_call HardwareRead8
        movzx eax,al
        ret
.LessThenHW:
        and ecx,0x1fffffff
        movzx eax,byte [MemRegister+ecx+___PARLMemory-0x1f000000]
        ret
.BIOSMem__:
;	and ecx,0x1fffffff
;	movzx eax,byte [MemRegister+ecx+___BIOSMemory-0x1fc00000]
;	call GeneralEmulationError
    mov eax,0x00
        ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
MemRead16S:
        test ecx,0x10000000
        jnz .nRealMem__
        and ecx,0x001fffff
        movsx eax,word [MemRegister+ecx]
        ret
.nRealMem__:
        test ecx,0x00400000
        jnz .BIOSMem__
        test ecx,0x00800000
        jz  .LessThenHW
        q_call HardwareRead16
        movsx eax,ax
        ret
.LessThenHW:
        and ecx,0x1fffffff
        movsx eax,word [MemRegister+ecx+___PARLMemory-0x1f000000]
        ret
.BIOSMem__:
;	and ecx,0x1fffffff
;	movsx eax,word [MemRegister+ecx+___BIOSMemory-0x1fc00000]
;	call GeneralEmulationError
    mov eax,0x00
        ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
MemRead16U:
        test ecx,0x10000000
        jnz .nRealMem__
        and ecx,0x001fffff
        movzx eax,word [MemRegister+ecx]
        ret
.nRealMem__:
        test ecx,0x00400000
        jnz .BIOSMem__
        test ecx,0x00800000
        jz  .LessThenHW
        q_call HardwareRead16
        movzx eax,ax
        ret
.LessThenHW:
        and ecx,0x1fffffff
        movzx eax,word [MemRegister+ecx+___PARLMemory-0x1f000000]
        ret
.BIOSMem__:
;	and ecx,0x1fffffff
;	movzx eax,word [MemRegister+ecx+___BIOSMemory-0x1fc00000]
;	call GeneralEmulationError
    mov eax,0x00
        ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
MemRead32:
        test ecx,0x10000000
        jnz .nRealMem__
        and ecx,0x001fffff
        mov eax,[MemRegister+ecx]
        ret
.nRealMem__:
        test ecx,0x00400000
        jnz .BIOSMem__
        test ecx,0x00800000
        jz  .LessThenHW
        q_call HardwareRead32
        ret
.LessThenHW:
        and ecx,0x1fffffff
        mov eax,[MemRegister+ecx+___PARLMemory-0x1f000000]
        ret
.BIOSMem__:
;	and ecx,0x1fffffff
;	mov eax,[MemRegister+ecx+___BIOSMemory-0x1fc00000]
;	call GeneralEmulationError
    mov eax,0x00
        ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
MemWriteL:
        and edx,0x0000007c
        mov eax,[RegRegister+edx]
        push eax
        mov edx,ecx
        and edx,0x001ffffc                              ;
        and ecx,0x00000003
        shl ecx,0x03
        mov eax,0xffffff00
        shl eax,cl
        and [MemRegister+edx],eax
        pop eax
        neg ecx
        add ecx,0x18
        shr eax,cl                                      ;
        or  [MemRegister+edx],eax                       ;
        ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
MemWriteR:
        and edx,0x0000007c
        mov eax,[RegRegister+edx]                       ;
        mov edx,ecx                                     ;
        and edx,0x001ffffc                              ;
        and ecx,0x00000003
        shl ecx,0x03
        shl eax,cl                                      ;
        push eax
        neg ecx
        add ecx,0x18
        mov eax,0x00ffffff
        shr eax,cl
        and [MemRegister+edx],eax
        pop eax
        or [MemRegister+edx],eax                        ;
        ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
MemReadL:
        and edx,0x0000007c              ;Get rt*4
        mov eax,ecx
        and ecx,0x00000003              ;vaddr 1..0
        and eax,0x001ffffc              ;baddr
        push eax
        shl ecx,0x03                    ;vaddr*8
        mov eax,0x00ffffff
        shr eax,cl                      ;eax=ffffff>>vaddr*8
        and [RegRegister+edx],eax
        pop eax                         ;baddr
        mov eax,[MemRegister+eax]       ;eax=[baddr]
        neg ecx
        add ecx,0x18
        shl eax,cl
        or [RegRegister+edx],eax
        ret
;------------------------------------------------------------------------------;
align 4 ;----------------------------------------------------------------------;
;------------------------------------------------------------------------------;
MemReadR:
        and edx,0x0000007c
        mov eax,ecx
        and ecx,0x00000003
        and eax,0x001ffffc
        mov eax,[MemRegister+eax]
        shl ecx,0x03
        shr eax,cl
        push eax
        neg ecx
        add ecx,0x18
        mov eax,0xffffff00
        shl eax,cl
        and [RegRegister+edx],eax
        pop eax
        or [RegRegister+edx],eax
        ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
Data___Table___		dd	0x00000000
Data___Memory___	dd	0x00000000
Error_TableAlloc	db	"[  MEM  ]Error: Cann't allocate 'Table' memory",10,0
Error_BaseAlloc		db	"[  MEM  ]Error: Cann't allocate 'Base' memory",10,0
;LOG_memw32		db	"---MEM---[ %X ]  Write Word  [ %X ]  to  [ %X ]",13,10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
