;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
%define __SIO_FUNCLOG
%macro LogSIO_FUNCLOG 1
	%ifdef __SIO_FUNCLOG
		push dword [byte RegRegister + r___A3___b]
		push dword [byte RegRegister + r___A2___b]
		push dword [byte RegRegister + r___A1___b]
		push dword [byte RegRegister + r___A0___b]
		push dword %1
		rb_call ___rb___Log___Printf___
		add esp,0x14
        %endif
%endmacro
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
;	mov eax,writeSIO_40_h
;	mov edx,readSIO_40_h
;	mov ecx,0x00001040
;	call HWHook16
	mov eax,writeSIO_44_h
	mov edx,readSIO_44_h
	mov ecx,0x00001044
	rb_call ___rb___Hook___HardWare16___
;;---
	mov eax,B0_15
	mov ecx,0x0015
	rb_call ___rb___Hook___hleB0___
	mov eax,B0_16
	mov ecx,0x0016
	rb_call ___rb___Hook___hleB0___
	mov eax,B0_5B
	mov ecx,0x005B
	rb_call ___rb___Hook___hleB0___
;;---
	mov eax,___HLE49bc
	mov edx,0x000049bc
	rb_call ___rb___Hook___Function___
	mov eax,___HLE4a4c
	mov edx,0x00004a4c
	rb_call ___rb___Hook___Function___
;;--- kernel data
	mov edx,DataTable
.data_loop:
	cmp dword [edx],byte 0x00
	jz .data_end
	push edx
	mov eax,[edx]
	mov ecx,[edx+4]
	mov edx,[edx+8]
	rb_call ___rb___Write___Memory___
	pop edx
	add edx,0x10
	jmp .data_loop
.data_end:
;;--
	mov eax,hookfunc
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
    xor eax,eax
    ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
    xor eax,eax
    ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
    xor eax,eax
    ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
align 4
;------------------------------------------------------------------------------;
hookfunc:
	mov edx,[esp+8]
	cmp [esp+4],dword 0
	je press
	jmp release
press:
	cmp dl,0x1e		;'a'
	jne .nleft
	or dword [CurrentKey],0x00008000
    ret
.nleft:
	cmp dl,0x1f		;'s'
	jne .ndown
	or dword [CurrentKey],0x00004000
    ret
.ndown:
	cmp dl,0x20		;'d'
	jne .nright
	or dword [CurrentKey],0x00002000
	ret
.nright:
	cmp dl,0x11		;'w'
	jne .nup
	or dword [CurrentKey],0x00001000
	ret
.nup:
	cmp dl,0x1b		;']'
	jne .nstart
	or dword [CurrentKey],0x00000800
	ret
.nstart:
	cmp dl,0x1a		;'['
	jne .nselect
	or dword [CurrentKey],0x00000100
	ret
.nselect:
	cmp dl,0x23		;'h'
	jne .nsquare
	or dword [CurrentKey],0x00000080
	ret
.nsquare:
	cmp dl,0x24		;'j'
	jne .ncross
	or dword [CurrentKey],0x00000040
	ret
.ncross:
	cmp dl,0x25		;'k'
	jne .ncircle
	or dword [CurrentKey],0x00000020
	ret
.ncircle:
	cmp dl,0x16		;'u'
	jne .ntriangle
	or dword [CurrentKey],0x00000010
	ret
.ntriangle:
	cmp dl,0x32		;'m'
	jne .nR1
	or dword [CurrentKey],0x00000008
	ret
.nR1:
	cmp dl,0x31		;'n'
	jne .nL1
	or dword [CurrentKey],0x00000004
	ret
.nL1:
	cmp dl,0x17		;'i'
	jne .nR2
	or dword [CurrentKey],0x00000002
	ret
.nR2:
	cmp dl,0x15		;'y'
	jne .nL2
	or dword [CurrentKey],0x00000001
	ret
.nL2:
	ret
release:
	cmp dl,0x1e             ;'a'
	jne .nleft
	and dword [CurrentKey],0xffff7fff
	ret
.nleft:
	cmp dl,0x1f             ;'s'
	jne .ndown
	and dword [CurrentKey],0xffffbfff
	ret
.ndown:
	cmp dl,0x20             ;'d'
	jne .nright
	and dword [CurrentKey],0xffffdfff
	ret
.nright:
	cmp dl,0x11             ;'w'
	jne .nup
	and dword [CurrentKey],0xffffefff
	ret
.nup:
	cmp dl,0x1b             ;']'
	jne .nstart
	and dword [CurrentKey],0xfffff7ff
	ret
.nstart:
	cmp dl,0x1a             ;'['
	jne .nselect
	and dword [CurrentKey],0xfffffeff
	ret
.nselect:
	cmp dl,0x23             ;'h'
	jne .nsquare
	and dword [CurrentKey],0xffffff7f
	ret
.nsquare:
	cmp dl,0x24             ;'j'
	jne .ncross
	and dword [CurrentKey],0xffffffbf
	ret
.ncross:
	cmp dl,0x25             ;'k'
	jne .ncircle
	and dword [CurrentKey],0xffffffdf
	ret
.ncircle:
	cmp dl,0x16             ;'u'
	jne .ntriangle
	and dword [CurrentKey],0xffffffef
	ret
.ntriangle:
	cmp dl,0x32             ;'m'
	jne .nR1
	and dword [CurrentKey],0xfffffff7
	ret
.nR1:
	cmp dl,0x31             ;'n'
	jne .nL1
	and dword [CurrentKey],0xfffffffb
	ret
.nL1:
	cmp dl,0x17             ;'i'
	jne .nR2
	and dword [CurrentKey],0xfffffffd
	ret
.nR2:
	cmp dl,0x15             ;'y'
	jne .nL2
	and dword [CurrentKey],0xfffffffe
	ret
.nL2:
	ret
;------------------------------------------------------------------------------;
;align 4 ;----------Memory---Write---Half---------------------------------------;
;------------------------------------------------------------------------------;
HLPADGet:
	mov edx,[CurrentKey]
	not edx
	ret
;------------------------------------------------------------------------------;
;align 4 ;----------Memory---Write---Half---------------------------------------;
;------------------------------------------------------------------------------;
;writeSIO_40_h:
;        call writeHalf
;	ret
;------------------------------------------------------------------------------;
;align 4 ;----------Memory---Read---Half----------------------------------------;
;------------------------------------------------------------------------------;
;readSIO_40_h:
;        call readHalf
;	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Write----------------------------------------------;
;------------------------------------------------------------------------------;
writeSIO_44_h:
	ret
;------------------------------------------------------------------------------;
align 4 ;----------Memory---Read-----------------------------------------------;
;------------------------------------------------------------------------------;
readSIO_44_h:
	mov eax,0x0001
	ret
;------------------------------------------------------------------------------;
;align 4 ;----------Memory---Write----------------------------------------------;
;------------------------------------------------------------------------------;
;writeSIO_48_h:
;	ret
;------------------------------------------------------------------------------;
;align 4 ;----------Memory---Read-----------------------------------------------;
;------------------------------------------------------------------------------;
;readSIO_48_h:
;	ret
;;------------------------------------------------------------------------------;
;align 4 ;----------Memory---Write----------------------------------------------;
;;------------------------------------------------------------------------------;
;;------------------------------------------------------------------------------;
;align 4 ;----------Memory---Read-----------------------------------------------;
;------------------------------------------------------------------------------;
___HLE49bc:
	mov eax,[MemRegister+0x000074c4]
	call HLPADGet
	mov [MemRegister+eax],edx
	ret
___HLE4a4c:					;!!!_Full_!!!
	mov ecx,0x00001074
	q_call HardwareRead32
	and eax,0x00000001
	jz .zero_exit
	mov edx,eax
	mov ecx,0x00001070
	q_call HardwareRead32
	and edx,eax
	jz .zero_exit
	mov dword [byte RegRegister + r___V0___b],dword 0x00000001
	ret
.zero_exit:
	mov dword [byte RegRegister + r___V0___b],dword 0x00000000
	ret
;------------------------------------------------------------------------------;
;PAD_init(Type,addr,...)
;Experimental
B0_15:
	LogSIO_FUNCLOG ___log___b0___15
	mov eax,[byte RegRegister + r___A0___b]
	cmp eax,0x10000001
	jne .nDCross
	mov [byte RegRegister + r___V0___b],dword 0x00000000
	jmp .exit
.nDCross:
	cmp eax,0x20000001
	je .pad6
	mov [byte RegRegister + r___V0___b],dword 0x00000000
	jmp .exit
.pad6:
;;---
;;;        mov [MemRegister+0x00007570],word 0xffff
;;;        mov [MemRegister+0x00007572],dword 0x02020202
;;;        mov [MemRegister+0x00007576],dword 0x02020202
;;;        mov [MemRegister+0x0000757a],dword 0x02020202
;;;        mov [MemRegister+0x0000757e],dword 0x02020202
;;;        mov [MemRegister+0x00007582],dword 0x02020202
;;;        mov [MemRegister+0x00007586],dword 0x02020202
;;;        mov [MemRegister+0x0000758a],dword 0x02020202
;;;        mov [MemRegister+0x0000758e],dword 0x02020202
;;;      mov [MemRegister+0x00007598],word 0xffff
;;;        mov [MemRegister+0x0000759a],dword 0x02020202
;;;        mov [MemRegister+0x0000759e],dword 0x02020202
;;;        mov [MemRegister+0x000075a2],dword 0x02020202
;;;        mov [MemRegister+0x000075a6],dword 0x02020202
;;;        mov [MemRegister+0x000075aa],dword 0x02020202
;;;        mov [MemRegister+0x000075ae],dword 0x02020202
;;;        mov [MemRegister+0x000075b2],dword 0x02020202
;;;        mov [MemRegister+0x000075b6],dword 0x02020202
;;---
;;;      mov [MemRegister+0x000074d0],dword 0x00000000
;;;        mov [MemRegister+0x000074d4],dword 0x00000000
;;;        mov [MemRegister+0x000074e0],dword 0x00000000
;;;        mov [MemRegister+0x000074e4],dword 0x00000000
;;---
;;;        mov [MemRegister+0x000074c8],dword 0x00007570
;;;        mov [MemRegister+0x000074cc],dword 0x00007598
;;;        mov [MemRegister+0x000074d8],dword 0x00000022
;;;        mov [MemRegister+0x000074dc],dword 0x00000022
;;---zero
;;;        mov [MemRegister+0x00007570],word 0x0000
;;;        mov [MemRegister+0x00007572],dword 0x00000000
;;;        mov [MemRegister+0x00007576],dword 0x00000000
;;;        mov [MemRegister+0x0000757a],dword 0x00000000
;;;        mov [MemRegister+0x0000757e],dword 0x00000000
;;;        mov [MemRegister+0x00007582],dword 0x00000000
;;;        mov [MemRegister+0x00007586],dword 0x00000000
;;;        mov [MemRegister+0x0000758a],dword 0x00000000
;;;        mov [MemRegister+0x0000758e],dword 0x00000000
;;;        mov [MemRegister+0x00007598],word 0x0000
;;;        mov [MemRegister+0x0000759a],dword 0x00000000
;;;        mov [MemRegister+0x0000759e],dword 0x00000000
;;;        mov [MemRegister+0x000075a2],dword 0x00000000
;;;        mov [MemRegister+0x000075a6],dword 0x00000000
;;;        mov [MemRegister+0x000075aa],dword 0x00000000
;;;        mov [MemRegister+0x000075ae],dword 0x00000000
;;;        mov [MemRegister+0x000075b2],dword 0x00000000
;;;        mov [MemRegister+0x000075b6],dword 0x00000000
;;---
;;;        mov [MemRegister+0x000074b8],dword 0x00000001
;;---
	mov eax,[byte RegRegister + r___A1___b]
	and eax,0x001fffff
	mov [MemRegister+0x000074c4],eax
;;---4b90---
;;;
;;;;        mov [MemRegister+0x000074c0],dword 0x00000000
;--
	mov dword [byte RegRegister + r___A0___b]   ,dword  0x00000002
	mov dword [byte RegRegister + r___A1___b]   ,dword  0x000074a8
	mov dword [byte RegRegister + r___T1___b]   ,dword  0x00000003
	q_call q___hle___c0
	mov dword [byte RegRegister + r___A0___b]   ,dword  0x00000002
	mov dword [byte RegRegister + r___A1___b]   ,dword  0x000074a8
	mov dword [byte RegRegister + r___T1___b]   ,dword  0x00000002
	q_call q___hle___c0
;=
	mov eax,0xfffffffe
	mov ecx,0x00001070
	q_call HardwareWrite32
	mov ecx,0x00001074
	q_call HardwareRead32
	or  eax,0x00000001
	q_call HardwareWrite32
;=
	mov ecx,0x02
	q_call q___system
;=
;;;        mov [MemRegister+0x00008914],dword 0x00000001
;;;        mov [MemRegister+0x0000860c],dword 0x00000000
;;---
	mov [byte RegRegister + r___V0___b],dword 0x00000002
.exit:
        ret
;------------------------------------------------------------------------------;
;PAD_dr()
;Experimental
B0_16:
	LogSIO_FUNCLOG ___log___b0___16
;---High Level Emulation
	mov eax,[MemRegister+0x000074c4]
	call HLPADGet
	mov [MemRegister+eax],edx
        ret
;------------------------------------------------------------------------------;
;ChangeClearPad(int)
B0_5B:
	LogSIO_FUNCLOG ___log___b0___5b
	mov eax,[byte RegRegister + r___A0___b]                     ;8914 - ClearPadFunc
	mov edx,[MemRegister+0x00008914]
	mov [MemRegister+0x00008914],eax
	mov [byte RegRegister + r___V0___b],edx
	ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
DataTable:              ;;--- PC ---  --- LEN ---  --- PSX ---
		dd      data__74a8,data__74a8___len,0x000074a8,0x00000000
                dd      0x00000000,0x00000000,0x00000000,0x00000000
data__74a8:
			dd      0x00000000,0x000049bc,0x00004a4c,0x00000000
data__74a8___len	equ	$-data__74a8
cur_hook		dd	0x00000000
CurrentKey		dd	0x00000000
___log___b0___15	db	"---HLE---| SIO |(B0:15)---PAD_init( 0x%X , 0x%X )",10,0
___log___b0___16	db	"---HLE---| SIO |(B0:16)---PAD_dr()",10,0
___log___b0___5b	db	"---HLE---| SIO |(B0:5B)---ChangeClearPad( 0x%X )",10,0
press_key		db	"Press %x",10,0
release_key		db	"Release %x",10,0
return_key		db	"Return %x",10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
