;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
CEXTERN RbPSe_LoadLibrary
CEXTERN RbPSe_ReadStrSettings
CEXTERN RbPSe_SysPrintf
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
    mov eax,[esp+4]     ;//RbPSeStartUpStrucAddr
    push dword ConfigSectionPSEmuBuffer
    push dword ConfigSectionPSEmuDefName
    push dword ConfigSectionPSEmuNames
    push dword ConfigSectionPSEmu
    push dword ConfigFileName
    push dword [eax+RbPSeStartStruc.ProfileDir]
    call RbPSe_ReadStrSettings
    add esp,0x18
        mov eax,[esp+4]     ;//RbPSeStartUpStrucAddr
		push dword spuHandles
		push dword spuFuncNames
        push dword ConfigSectionPSEmuBuffer
		push dword [eax+RbPSeStartStruc.PluginsDir]
		call RbPSe_LoadLibrary
		add esp,0x10
	test eax,eax
	jz .load_ok
		push dword ErrorLoadPSEmuSPUPlugin
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.load_ok:
	call [spuHandles.spuINIT]
	test eax,eax
	jz .init_ok
		push dword ErrorInitPSEmuSPUPlugin
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.init_ok:
	mov ecx,0x00001c00
.loop16:
	mov eax,Hook16write
	mov edx,Hook16read
	rb_call ___rb___Hook___HardWare16___
	add ecx,0x00000002
	cmp ecx,0x00001e00
	jb .loop16

	mov eax,DMAFunction				;//
	mov ecx,0x00000004				;//
	rb_call ___rb___Hook___dma___	;//
	mov [DMAData],eax				;//

			push SpuIrqCallBack
			call [spuHandles.spuRegCall]
BEOS_ONLY	add esp,0x04


	mov eax,[esp+4]
			push dword [eax+RbPSeStartStruc.Display]
			call [spuHandles.spuOPEN]
BEOS_ONLY	add esp,0x04
	test eax,eax
	jz .open_ok
		push dword ErrorOpenPSEmuSPUPlugin
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.open_ok:
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
    ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
    ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
    ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
    ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	call [spuHandles.spuCLOSE]
	test eax,eax
	jz .close_ok
		push dword ErrorClosePSEmuSPUPlugin
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.close_ok:

        call [spuHandles.spuSHUTDOWN]
	test eax,eax
	jz .shutdown_ok
		push dword ErrorShutdownPSEmuSPUPlugin
		call RbPSe_SysPrintf
		add esp,0x04
	mov eax,0xffffffff
	ret
.shutdown_ok:
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
Hook16write:
			push eax
			push ecx
			call [spuHandles.spuWReg]
BEOS_ONLY	add esp,0x08
	ret
Hook16read:
			push ecx
			call [spuHandles.spuRReg]
BEOS_ONLY	add esp,0x04
	ret
;------------------------------------------------------------------------------;
SpuIrqCallBack:
    push esi
    push edi
    push ebx
    	mov esi,[RbPSeDataData+RbPSeDataStruc.Data___Table___]
		mov edi,[RbPSeDataData+RbPSeDataStruc.Data___Memory___]
		mov ebx,[RbPSeDataData+RbPSeDataStruc.Data___Dynarec___]
			mov edx,0x200
			call [dword esi+___RequestInterrupt]
    pop ebx
    pop edi
    pop esi
	ret
;------------------------------------------------------------------------------;
DMAFunction:    ;//(eax)control
	test eax,0x00000001
	jnz .ToSPU
	jmp .FromSPU
.ToSPU:
	mov ecx,[DMAData]
    mov edx,[ecx]
    push edx
    mov ecx,[ecx+4]
    mov eax,ecx
    shr ecx,0x10
    mul cx
    shl edx,0x10
    mov dx,ax
    mov ecx,edx
    pop edx
    and edx,0x001fffff
	shl ecx,0x01
			add edx,[RbPSeDataData+RbPSeDataStruc.Data___Memory___]
            push ecx
            push edx
            call [spuHandles.spuWDMAM]
BEOS_ONLY   add esp,0x08
    ret
.FromSPU:
    ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
ConfigSectionPSEmuNames
				dd  ConfigSectionPSEmuPlugin,ConfigSectionPSEmuConfig,0
spuFuncNames	dd	SPUinitName,SPUopenName,SPUcloseName,SPUshutdownName
				dd	SPUwriteRegisterName,SPUreadRegisterName,SPUwriteDMAName
				dd	SPUreadDMAName,SPUwriteDMAMemName,SPUreadDMAMemName,
				dd	SPUregisterCallback,0
ConfigFileName              db  "s_spu_psemu.cfg",0
ConfigSectionPSEmu          db  "psemu",0
ConfigSectionPSEmuPlugin    db  "plugin",0
ConfigSectionPSEmuConfig    db  "config",0
ConfigSectionPSEmuDefName   db  "_nf_",0
WINDOWS_ONLY    PSEmuPluginDefName  db  "PSEmuPro\spu.dll",0
BEOS_ONLY       PSEmuPluginDefName  db  "PSEmuPro/spu.so",0
BEOS_ONLY       PSEmuConfigDefName  db  "PSEmuPro/spu.cfg",0
SPUinitName				db	"SPUinit",0
SPUopenName				db	"SPUopen",0
SPUcloseName			db	"SPUclose",0
SPUshutdownName			db	"SPUshutdown",0
SPUwriteRegisterName	db	"SPUwriteRegister",0
SPUreadRegisterName		db	"SPUreadRegister",0
SPUwriteDMAName			db	"SPUwriteDMA",0
SPUreadDMAName			db	"SPUreadDMA",0
SPUwriteDMAMemName		db	"SPUwriteDMAMem",0
SPUreadDMAMemName		db	"SPUreadDMAMem",0
SPUregisterCallback		db	"SPUregisterCallback",0
ErrorLoadPSEmuSPUPlugin		db	"[  SPU  ]Error: Cann't Load PSEmu SPU Plugin",10,0
ErrorInitPSEmuSPUPlugin		db	"[  SPU  ]Error: Cann't Init PSEmu SPU Plugin",10,0
ErrorOpenPSEmuSPUPlugin		db	"[  SPU  ]Error: Cann't Open PSEmu SPU Plugin",10,0
ErrorClosePSEmuSPUPlugin	db	"[  SPU  ]Error: Cann't Close PSEmu SPU Plugin",10,0
ErrorShutdownPSEmuSPUPlugin	db	"[  SPU  ]Error: Cann't Shutdown PSEmu SPU Plugin",10,0
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
ConfigSectionPSEmuBuffer    resd    0x04*0x20
spuHandles
.hlib			resd	1
.spuINIT		resd	1
.spuOPEN		resd	1
.spuCLOSE		resd	1
.spuSHUTDOWN	resd	1
.spuWReg		resd	1
.spuRReg		resd	1
.spuWDMA		resd	1
.spuRDMA		resd	1
.spuWDMAM		resd	1
.spuRDMAM		resd	1
.spuRegCall		resd	1
DMAData         resd    1

