;------------------------------------------------------------------------------;
;  RbPSe - Sony Play Station Emulator                                          ;
;  Copyright (C) notes:                                                        ;
;    Code: RomikB, 2002-2003                                                   ;
;         <romikb@mail.ru>                                                     ;
;                                                                              ;
;  This program is free software; you can redistribute it and/or               ;
;  modify it under the terms of the GNU General Public License                 ;
;  as published by the Free Software Foundation; either version 2              ;
;  of the License, or (at your option) any later version.                      ;
;                                                                              ;
;  This program is distributed in the hope that it will be useful,             ;
;  but WITHOUT ANY WARRANTY; without even the implied warranty of              ;
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               ;
;  GNU General Public License for more details.                                ;
;                                                                              ;
;  You should have received a copy of the GNU General Public License           ;
;  along with this program; if not, write to the Free Software                 ;
;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. ;
;------------------------------------------------------------------------------;
;Description:
;	=RootCounters
;	+WaitAble Interrupts
;------------------------------------------------------------------------------;
%include "../include/__rbpse.sdk"
;------------------------------------------------------------------------------;
CEXTERN RbPSe_GetClock
;------------------------------------------------------------------------------;
%assign         NTSCClock       60
%assign         PALClock        50
%assign         NTSCHSync       262             ;~262,2
%assign         PALHSync        312             ;312,5
;%define TimingLog
;%macro LogTimingLog 1
;        %ifdef TimingLog
;                mov edx,[esp+4]
;                sub edx,DynRegister
;                shr edx,0x02
;		and edx,0xfffffffc
;                push eax
;                push ecx
;                        push ecx
;                        push eax
;                        push edx
;                        push dword %1
;                        call Log_printf
;                        add esp,0x10
;                pop ecx
;                pop eax
;        %endif
;%endmacro
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "code"
;------------------------------------------------------------------------------;
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginOpen
;---funcs
	mov eax,ExecuteTiming					;Set
	mov ecx,s___timing						;   Timing
	rb_call ___rb___Hook___Table___			;         Function
	mov eax,WaitableInterrupt				;Set
	mov ecx,___WaitableInterrupt			;   Timing
	rb_call ___rb___Hook___Table___			;         Function
;---bios-hle
	mov eax,B0_02
	mov ecx,0x0002
	rb_call ___rb___Hook___hleB0___
	mov eax,B0_04
	mov ecx,0x0004
	rb_call ___rb___Hook___hleB0___
	mov eax,C0_0A
	mov ecx,0x000A
	rb_call ___rb___Hook___hleC0___
;---data
	mov dword [TimingCounter]       ,dword	0x00000000
	mov dword [TimingExec]          ,dword	0x00000100
	mov dword [IntClockCounter]		,dword	0x00000000
	mov dword [HWClockIntMask]		,dword	0x00000000
	mov dword [HWClockCounters]		,dword	NTSCHSync
	mov dword [HWClockFunctions]    ,dword	VSync_NTSC
	mov dword [HWClockCounters+4]	,dword	0x0000ffff
	mov dword [HWClockFunctions+4]	,dword	Root1_func
	mov dword [HWClockCounters+8]   ,dword	0xffffffff
	mov dword [HWClockFunctions+8]  ,dword	Root2_func
	mov dword [HWClockCounters+12]	,dword	0xffffffff
	mov dword [HWClockFunctions+12]	,dword	null_func
;;;---
	mov eax,0x01
	mov ecx,[ConfigTimingIncs]
	shl eax,cl
	mov [AddHSync],eax
;;//Clock                                dynamic config only
	call RbPSe_GetClock
	mov ecx,[ConfigTimingIncs]
	shld edx,eax,cl
	shl eax,cl
	mov ecx,(NTSCHSync * NTSCClock)
	div ecx
	mov [OneClock],eax
	mov [OneClock+4],dword 0x00000000
	rdtsc
	mov [OldClock],eax
	mov [OldClock+4],edx
	mov [CurClock],dword 0x00000000
	mov [CurClock+4],dword 0x00000000
;;;Roots
	mov dword [OldRoot1Count]	,dword 0x00000000
	mov dword [OldRoot2Count]	,dword 0x00000000
	mov dword [Root1Target]		,dword 0x0000ffff
	mov dword [Root2Target]		,dword 0x0000ffff
	mov byte [Root1IRQ]		,byte 0x00
	mov byte [Root2IRQ]		,byte 0x00
;;;Counters
;;;	mov edx,Root0Read32Value
;;;	mov eax,Root0Write32Value
;;;	mov ecx,0x00001100
;;;	call HWHook32
;;;	mov edx,Root0Read32Mode
;;;	mov eax,Root0Write32Mode
;;;	mov ecx,0x00001104
;;;	call HWHook32
;;;	mov edx,Root0Read32Target
;;;	mov eax,Root0Write32Target
;;;	mov ecx,0x00001108
;;;	call HWHook32
;;;	mov edx,Root0Read16Value
;;;	mov eax,Root0Write16Value
;;;	mov ecx,0x00001100
;;;	call HWHook16
;;;	mov edx,Root0Read16Mode
;;;	mov eax,Root0Write16Mode
;;;	mov ecx,0x00001104
;;;	call HWHook16
;;;	mov edx,Root0Read16Target
;;;	mov eax,Root0Write16Target
;;;	mov ecx,0x00001108
;;;	call HWHook16
	mov eax,Root1Write32Value
	mov edx,Root1Read32Value
	mov ecx,0x00001110
	rb_call ___rb___Hook___HardWare32___
	mov eax,Root1Write32Mode
	mov edx,Root1Read32Mode
	mov ecx,0x00001114
	rb_call ___rb___Hook___HardWare32___
	mov eax,Root1Write32Target
	mov edx,Root1Read32Target
	mov ecx,0x00001118
	rb_call ___rb___Hook___HardWare32___
	mov eax,Root1Write16Value
	mov edx,Root1Read16Value
	mov ecx,0x00001110
	rb_call ___rb___Hook___HardWare16___
	mov eax,Root1Write16Mode
	mov edx,Root1Read16Mode
	mov ecx,0x00001114
	rb_call ___rb___Hook___HardWare16___
	mov eax,Root1Write16Target
	mov edx,Root1Read16Target
	mov ecx,0x00001118
	rb_call ___rb___Hook___HardWare16___
;	mov edx,Root2Read32Value
;	mov eax,Root2Write32Value
;	mov ecx,0x00001120
;	call HWHook32
;	mov edx,Root2Read32Mode
;	mov eax,Root2Write32Mode
;	mov ecx,0x00001124
;	call HWHook32
;	mov edx,Root2Read32Target
;	mov eax,Root2Write32Target
;	mov ecx,0x00001128
;	call HWHook32
;	mov edx,Root2Read16Value
;	mov eax,Root2Write16Value
;	mov ecx,0x00001120
;	call HWHook16
;	mov edx,Root2Read16Mode
;	mov eax,Root2Write16Mode
;	mov ecx,0x00001124
;	call HWHook16
;	mov edx,Root2Read16Target
;	mov eax,Root2Write16Target
;	mov ecx,0x00001128
;	call HWHook16
;	popa
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStart
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginStop
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginSave
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginLoad
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginClose
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
ExportFunction RbPSePluginShutdown
	xor eax,eax
	ret
;------------------------------------------------------------------------------;
;ExportFunction SetVSyncFunction
;       mov eax,[esp+4]
;       mov [VSyncFunc],eax
;        ret 4
;;;
;;;	HW Hook Functions
;;;
;;;---Root-0-functions---
;;;Root0Read32Value:
;;;	ret
;;;Root0Write32Value:
;;;	ret
;;;Root0Read32Mode:
;;;	ret
;;;Root0Write32Mode:
;;;	ret
;;;Root0Read32Target:
;;;	ret
;;;Root0Write32Target:
;;;	ret
;;;---Root-1-functions---
Root1Read32Value:
	mov eax,[IntClockCounter]
	sub eax,[OldRoot1Count]
;	call readWord
	ret
Root1Write32Value:			;Don't supported by PSX
;	and eax,0x0000ffff
;	call writeWord
;	mov [Root1Count],eax
	ret
Root1Read32Mode:
	mov eax,[Root1Mode]
;	LogTimingLog LOG_root1mr32
	ret
Root1Write32Mode:
;        LogTimingLog LOG_root1mw32
	mov [Root1Mode],eax
	test eax,0x00000008
	jnz .IRQ
	mov [Root1Target],dword 0x0000ffff
.IRQ:
;;;Set HWClock - Temporary
	mov edx,[IntClockCounter]
	mov [OldRoot1Count],edx
	add edx,[Root1Target]
	mov [HWClockCounters+4],edx
;;;
	xor edx,edx
	and eax,0x00000050
	cmp eax,0x00000050
	jne .SetIRQ
	mov dl,0x01
.SetIRQ:
	mov [Root1IRQ],dl
	ret
Root1Read32Target:
	mov eax,[Root1Target]
;        LogTimingLog LOG_root1tr32
	ret
Root1Write32Target:
;        LogTimingLog LOG_root1tw32
	and eax,0x0000ffff
	mov [Root1Target],eax
	ret
Root1Read16Value:
	mov eax,[IntClockCounter]
	sub eax,[OldRoot1Count]
;	call readHalf
	ret
Root1Write16Value:			;Don't supported by PSX
;	call writeHalf
;	mov [Root1Count],ax
	ret
Root1Read16Mode:
	movzx eax,word [Root1Mode]
;        LogTimingLog LOG_root1mr16
	ret
Root1Write16Mode:
;        LogTimingLog LOG_root1mw16
	mov [Root1Mode],ax
	test ax,0x0008
	jnz .IRQ
	mov [Root1Target],dword 0x0000ffff
.IRQ:
;;;Set HWClock - Temporary
        mov edx,[IntClockCounter]
	mov [OldRoot1Count],edx
        add edx,[Root1Target]
        mov [HWClockCounters+4],edx
;;;
	xor edx,edx
	and eax,0x00000050
	cmp eax,0x00000050
	jne .SetIRQ
	mov dl,0x01
.SetIRQ:
	mov [Root1IRQ],dl
	ret
Root1Read16Target:
	movzx eax,word [Root1Target]
;        LogTimingLog LOG_root1tr16
	ret
Root1Write16Target:
;        LogTimingLog LOG_root1tw16
	mov [Root1Target],ax
	ret
;---Root-2-functions-----------------------------------------------------------;
;Root2Read32Value:
;	mov eax,[MemRegister+___HWMemory+0x1120]
;;	call readWord
;	ret
;Root2Write32Value:
;	call writeWord
;	and eax,0x0000ffff
;	mov [MemRegister+___HWMemory+0x1120],eax
;	ret
;Root2Read32Mode:
;	mov eax,[MemRegister+___HWMemory+0x1124]
;	call readWord
;	ret
;Root2Write32Mode:
;	call writeWord
;	mov [MemRegister+___HWMemory+0x1120],dword 0x00000000
;	mov [MemRegister+___HWMemory+0x1124],eax
;	test eax,0x00000008
;	jz .nTarget
;	mov edx,[MemRegister+___HWMemory+0x1128]
;	and edx,0x0000ffff
;	mov [Root2Target],edx
;	jmp .IRQ
;.nTarget:
;	mov [Root2Target],dword 0x0000ffff
;.IRQ:
;	xor edx,edx
;	and eax,0x00000050
;	cmp eax,0x00000050
;	jne .SetIRQ
;	mov dl,0x01
;.SetIRQ:
;	mov [Root2IRQ],dl
;	ret
;Root2Read32Target:
;	mov eax,[MemRegister+___HWMemory+0x1128]
;	call readWord
;	ret
;Root2Write32Target:
;	call writeWord
;	and eax,0x0000ffff
;	mov [MemRegister+___HWMemory+0x1128],eax
;	ret
;Root2Read16Value:
;	movzx eax,word [MemRegister+___HWMemory+0x1120]
;;	call readHalf
;	ret
;Root2Write16Value:
;	call writeHalf
;	mov [MemRegister+___HWMemory+0x1120],ax
;	ret
;Root2Read16Mode:
;	movzx eax,word [MemRegister+___HWMemory+0x1124]
;	call readHalf
;	ret
;Root2Write16Mode:
;	call writeHalf
;	mov [MemRegister+___HWMemory+0x1120],dword 0x00000000
;	mov [MemRegister+___HWMemory+0x1124],ax
;	test ax,0x0008
;	jz .nTarget
;	movzx edx,word [MemRegister+___HWMemory+0x1128]
;	mov [Root2Target],edx
;	jmp .IRQ
;.nTarget:
;	mov [Root2Target],dword 0x0000ffff
;.IRQ:
;	xor edx,edx
;	and eax,0x00000050
;	cmp eax,0x00000050
;	jne .SetIRQ
;	mov dl,0x01
;.SetIRQ:
;	mov [Root2IRQ],dl
;	ret
;Root2Read16Target:
;	movzx eax,word [MemRegister+___HWMemory+0x1128]
;	call readHalf
;	ret
;Root2Write16Target:
;	call writeHalf
;	mov [MemRegister+___HWMemory+0x1128],ax
;	ret
;------------------------------------------------------------------------------;
align 4 ;----------Interrupt---------------------------------------------------;
;------------------------------------------------------------------------------;
WaitableInterrupt:
	add eax,[IntClockCounter]
	mov [HWClockFunctions+12],edx
	mov [HWClockCounters+12],eax
	ret
;;;
;;;---Main-Timing-function---
;;;
;------------------------------------------------------------------------------;
align 4 ;----------Interrupt---------------------------------------------------;
;------------------------------------------------------------------------------;
ExecuteTiming:
	inc dword [TimingCounter]
	mov ecx,[TimingCounter]
	cmp ecx,[TimingExec]
	jb NEAR Timing_exit
;;---
	rdtsc
	push edx
        push eax
        sub eax,[OldClock]
        sbb edx,[OldClock+4]
        add eax,[CurClock]
        adc edx,[CurClock+4]
        cmp edx,[OneClock+4]
        jb .less
        ja .greater
        cmp eax,[OneClock]
        jae .greater
.less:
;;;;;;;;;shl dword [TimingExec],1
	add esp,0x08
        jmp Timing_exit
.greater:
	sub eax,[OneClock]
        sbb edx,[OneClock+4]
        mov [CurClock],eax
        mov [CurClock+4],edx
	pop eax
	pop edx
        mov [OldClock],eax
        mov [OldClock+4],edx
	mov [TimingCounter],dword 0x00000000
;;;;;;;;;shr dword [TimingExec],1
;;;1809 clocks per HSync
;;	add dword [MemRegister+___HWMemory+0x1100],0x0040
;;	push dword 0x00000000
;;---
	mov eax,[IntClockCounter]
	xor ecx,ecx
        add eax,[AddHSync]
.HWCC_loop:
        cmp eax,[HWClockCounters+ecx*4]
        jb .nHWClock
        push eax
        push ecx
	call [HWClockFunctions+ecx*4]
	or [HWClockIntMask],eax
 	pop ecx
	add [HWClockCounters+ecx*4],edx
	pop eax
.nHWClock:
	inc ecx
	cmp ecx,0x04
	jb .HWCC_loop
;;---
	cmp dword [HWClockIntMask]	,dword 0x00000000
	je .nInterrupt
	push eax
	mov edx,[HWClockIntMask]
	call [dword esi+___RequestInterrupt]
	pop eax
	mov dword [HWClockIntMask]	,dword 0x00000000
.nInterrupt:
;	cmp eax,0xf0000000
;        jb .nClockOverflow
;        mov edx,0xf0000000
;        sub eax,edx
;	sub [HWClockCounters],edx
;.nClockOverflow:
	mov [IntClockCounter],eax
;;---
;CheckRCnt2:
;        add dword [MemRegister+___HWMemory+0x1120],226*8	;Not Real;tmp
;	mov eax,[Root2Target]
;	cmp [MemRegister+___HWMemory+0x1120],eax
;	jb CheckRCnt3
;	sub [MemRegister+___HWMemory+0x1120],eax
;.RCntInt:
;	cmp byte [Root2IRQ],byte 0x00
;	je CheckRCnt3
;	mov edx,0x40
;	call [dword esi+___RequestInterrupt]	;;;Old
;CheckRCnt3:
Timing_exit:
	ret
;------------------------------------------------------------------------------;
VSync_PAL:
;        push ecx
	call [RegRegister+___screenupdatefunc]
;        pop ecx
	mov edx,PALHSync
	mov eax,0x01
	ret
;------------------------------------------------------------------------------;
VSync_NTSC:
	push ecx
	call [RegRegister+___screenupdatefunc]
	pop ecx
	mov edx,NTSCHSync
	mov eax,0x01
	ret
;------------------------------------------------------------------------------;
Root1_func:
	mov [OldRoot1Count],eax
	mov edx,[Root1Target]
	mov eax,0x00
	cmp byte [Root1IRQ],byte 0x00
	je .nInt
	mov eax,0x20
.nInt:
	ret
;------------------------------------------------------------------------------;
Root2_func:
	mov [OldRoot2Count],eax
	mov edx,[Root2Target]
	mov eax,0x00
	cmp byte [Root2IRQ],byte 0x00
	je .nInt
	mov eax,0x20
.nInt:
	ret
null_func:
	ret
;;;
;;;		HLE
;;;
;------------------------------------------------------------------------------;
;???InitRootCounter(HCounter,Target,Mode)
B0_02:
        mov eax,[byte RegRegister + r___A0___b]
        and eax,0x0000ffff
        cmp eax,byte 0x03
        jl .RootOk
        mov [byte RegRegister + r___V0___b],dword 0x00000000
        ret
.RootOk:
        mov ecx,0x00001104
        shl eax,0x04
        add ecx,eax
        mov eax,0x00
        q_call HardwareWrite32
        add ecx,0x04
        mov eax,[byte RegRegister + r___A1___b]
        and eax,0x0000ffff
        q_call HardwareWrite32
        sub ecx,0x04
        mov edx,[byte RegRegister + r___A2___b]
        mov eax,0x48
        test edx,0x00000001
        jnz .notClc
        or eax,0x00000100
.notClc:
        test edx,0x00000010
        jz .notEn
        or eax,0x00000001
.notEn:
        test edx,0x00001000
        jz .notIRQ
        or eax,0x00000010
.notIRQ:
        q_call HardwareWrite32
        mov [byte RegRegister + r___V0___b],dword 0x00000001
        ret
;------------------------------------------------------------------------------;
;???EnableRootCounterInt(HCounter)
B0_04:
        mov edx,[byte RegRegister + r___A0___b]
        and edx,0x0000ffff
        cmp edx,0x03
        pushf
	push edx
		mov ecx,0x00001074
		q_call HardwareRead32
	pop edx
        mov ecx,0x00001074
        mov edx,[IrqMask+edx*4]
        or eax,edx
        q_call HardwareWrite32
        popf
        jl .notVSync
        mov [byte RegRegister + r___V0___b],dword 0x00000000
        ret
.notVSync:
        mov [byte RegRegister + r___V0___b],dword 0x00000001
        ret
;------------------------------------------------------------------------------;
;ChangeClearRCnt(int index,int *func)
C0_0A:
	mov eax,[byte RegRegister + r___A0___b]                     ;8600 - ClearRoot0
	mov ecx,[byte RegRegister + r___A1___b]                     ;8604 - ClearRoot1
	mov edx,[MemRegister+0x00008600+eax*4]          ;8608 - ClearRoot2
	mov [MemRegister+0x00008600+eax*4],ecx          ;860c - ClearRoot3
	mov [byte RegRegister + r___V0___b],edx
	ret
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "data"
;------------------------------------------------------------------------------;
;HSyncCounter            dd      0               ;226=1 HSync
;ConfigTimingMain        dd      0x00000000
;                                       10
;0      -       ;TimingExec(inD);Static/Dynamic
;1      -       ;GpuUpdate      ;Normal/Half
ConfigTimingSpeed	dd      0x00010000      ;100%           ;OneClock
ConfigTimingIncs	dd	0x00000003		;must be in Registry
IrqMask:
	dd	0x00000010,0x00000020,0x00000040,0x00000001
;LOG_root1cr16	db      "---ROOT1---[ %X ]   Read Half  [ %X ] from [ %X ] (Counter)",13,10,0
;LOG_root1mr16	db      "---ROOT1---[ %X ]   Read Half  [ %X ] from [ %X ] (   Mode)",13,10,0
;LOG_root1tr16	db      "---ROOT1---[ %X ]   Read Half  [ %X ] from [ %X ] ( Target)",13,10,0
;LOG_root1cw16	db      "---ROOT1---[ %X ]  Write Half  [ %X ]  to  [ %X ] (Counter)",13,10,0
;LOG_root1mw16	db      "---ROOT1---[ %X ]  Write Half  [ %X ]  to  [ %X ] (   Mode)",13,10,0
;LOG_root1tw16	db      "---ROOT1---[ %X ]  Write Half  [ %X ]  to  [ %X ] ( Target)",13,10,0
;LOG_root1cr32	db      "---ROOT1---[ %X ]   Read Word  [ %X ] from [ %X ] (Counter)",13,10,0
;LOG_root1mr32	db      "---ROOT1---[ %X ]   Read Word  [ %X ] from [ %X ] (   Mode)",13,10,0
;LOG_root1tr32	db      "---ROOT1---[ %X ]   Read Word  [ %X ] from [ %X ] ( Target)",13,10,0
;LOG_root1cw32	db      "---ROOT1---[ %X ]  Write Word  [ %X ]  to  [ %X ] (Counter)",13,10,0
;LOG_root1mw32	db      "---ROOT1---[ %X ]  Write Word  [ %X ]  to  [ %X ] (   Mode)",13,10,0
;LOG_root1tw32	db      "---ROOT1---[ %X ]  Write Word  [ %X ]  to  [ %X ] ( Target)",13,10,0
;ChangeClearRCnt(
;maska	db	"%i,%i";
;------------------------------------------------------------------------------;
__rbpse_plugin_segment__ "bss"
;------------------------------------------------------------------------------;
AddHSync		resd	1
TimingCounter	resd	1
TimingExec		resd	1
OneClock		resd	2
OldClock		resd	2
CurClock		resd	2
VSyncFunc		resd	1
IntClockCounter	resd	1
;;VSyncClockCounter	resd	1		;Another
;;GPU__ClockCounter	resd	1	;UnSup
;CDROMClockCounter	resd	1
;;DMA__ClockCounter	resd	1	;NotWaitAble
;;Root0ClockCounter	resd	1	;UnSup
;;Root1ClockCounter	resd	1		;Another
;;Root2ClockCounter	resd	1		;Another
;;SIO0_ClockCounter	resd	1	;UnSup
;;SIO1_ClockCounter	resd	1	;UnSup
;;SPU__ClockCounter	resd	1	;UnSup
;;PIO__ClockCounter	resd	1	;UnSup
HWClockCounters		resd	0x10	;VSync;HSync;CDROM;Root2
HWClockFunctions	resd	0x10
HWClockIntMask		resd	1
OldRoot1Count		resd	1
OldRoot2Count		resd	1
;Root0Target		resd	1	;0x0000ffff
;Root1Count		resd	1
Root1Mode		resd	1
Root2Mode		resd	1
Root1Target		resd	1	;0x0000ffff
Root2Target		resd	1	;0x0000ffff
;Root0IRQ		resb	1	;0x00
Root1IRQ		resb	1	;0x00
Root2IRQ		resb	1	;0x00
